

/*===---- altivec.h - Standard header for type generic math ---------------===*\

 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
\*===----------------------------------------------------------------------===*/



#ifndef __ALTIVEC_H
#define __ALTIVEC_H

#ifndef __ALTIVEC__
#error "AltiVec support not enabled"
#endif

#include <stddef.h>


#define __ATTRS_o_ai __attribute__((__overloadable__, __always_inline__))

vector signed char __ATTRS_o_ai
vec_abs(vector signed char __a) __asm__("__IBMBuiltin_vec_abs_VScVSc");

vector signed short __ATTRS_o_ai
vec_abs(vector signed short __a) __asm__("__IBMBuiltin_vec_abs_VSsVSs");

vector signed int __ATTRS_o_ai
vec_abs(vector signed int __a) __asm__("__IBMBuiltin_vec_abs_VSiVSi");

vector unsigned int __ATTRS_o_ai
vec_addc(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_addc_VUiVUiVUi");

vector unsigned char __ATTRS_o_ai
vec_andc(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_andc_VUcVUcVUc");

vector unsigned char __ATTRS_o_ai
vec_andc(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_andc_VUcVUcVBc");

vector unsigned char __ATTRS_o_ai
vec_andc(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_andc_VUcVBcVUc");

vector signed char __ATTRS_o_ai
vec_andc(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_andc_VScVScVSc");

vector signed char __ATTRS_o_ai
vec_andc(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_andc_VScVScVBc");

vector signed char __ATTRS_o_ai
vec_andc(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_andc_VScVBcVSc");

vector bool char __ATTRS_o_ai
vec_andc(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_andc_VBcVBcVBc");

vector unsigned short __ATTRS_o_ai
vec_andc(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_andc_VUsVUsVUs");

vector unsigned short __ATTRS_o_ai
vec_andc(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_andc_VUsVUsVBs");

vector unsigned short __ATTRS_o_ai
vec_andc(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_andc_VUsVBsVUs");

vector signed short __ATTRS_o_ai
vec_andc(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_andc_VSsVSsVSs");

vector signed short __ATTRS_o_ai
vec_andc(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_andc_VSsVSsVBs");

vector signed short __ATTRS_o_ai
vec_andc(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_andc_VSsVBsVSs");

vector bool short __ATTRS_o_ai
vec_andc(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_andc_VBsVBsVBs");

vector unsigned int __ATTRS_o_ai
vec_andc(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_andc_VUiVUiVUi");

vector unsigned int __ATTRS_o_ai
vec_andc(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_andc_VUiVUiVBi");

vector unsigned int __ATTRS_o_ai
vec_andc(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_andc_VUiVBiVUi");

vector signed int __ATTRS_o_ai
vec_andc(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_andc_VSiVSiVSi");

vector signed int __ATTRS_o_ai
vec_andc(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_andc_VSiVSiVBi");

vector signed int __ATTRS_o_ai
vec_andc(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_andc_VSiVBiVSi");

vector bool int __ATTRS_o_ai
vec_andc(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_andc_VBiVBiVBi");

vector unsigned char __ATTRS_o_ai
vec_avg(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_avg_VUcVUcVUc");

vector signed char __ATTRS_o_ai
vec_avg(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_avg_VScVScVSc");

vector unsigned short __ATTRS_o_ai
vec_avg(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_avg_VUsVUsVUs");

vector signed short __ATTRS_o_ai
vec_avg(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_avg_VSsVSsVSs");

vector unsigned int __ATTRS_o_ai
vec_avg(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_avg_VUiVUiVUi");

vector signed int __ATTRS_o_ai
vec_avg(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_avg_VSiVSiVSi");

vector bool char __ATTRS_o_ai
vec_cmpeq(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_cmpeq_VBcVUcVUc");

vector bool char __ATTRS_o_ai
vec_cmpeq(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_cmpeq_VBcVScVSc");

vector bool short __ATTRS_o_ai
vec_cmpeq(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_cmpeq_VBsVUsVUs");

vector bool short __ATTRS_o_ai
vec_cmpeq(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_cmpeq_VBsVSsVSs");

vector bool int __ATTRS_o_ai
vec_cmpeq(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_cmpeq_VBiVUiVUi");

vector bool int __ATTRS_o_ai
vec_cmpeq(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_cmpeq_VBiVSiVSi");

vector bool char __ATTRS_o_ai
vec_cmpge(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_cmpge_VBcVUcVUc");

vector bool char __ATTRS_o_ai
vec_cmpge(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_cmpge_VBcVScVSc");

vector bool short __ATTRS_o_ai
vec_cmpge(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_cmpge_VBsVUsVUs");

vector bool short __ATTRS_o_ai
vec_cmpge(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_cmpge_VBsVSsVSs");

vector bool int __ATTRS_o_ai
vec_cmpge(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_cmpge_VBiVUiVUi");

vector bool int __ATTRS_o_ai
vec_cmpge(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_cmpge_VBiVSiVSi");

vector bool char __ATTRS_o_ai
vec_cmpgt(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_cmpgt_VBcVUcVUc");

vector bool char __ATTRS_o_ai
vec_cmpgt(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_cmpgt_VBcVScVSc");

vector bool short __ATTRS_o_ai
vec_cmpgt(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_cmpgt_VBsVUsVUs");

vector bool short __ATTRS_o_ai
vec_cmpgt(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_cmpgt_VBsVSsVSs");

vector bool int __ATTRS_o_ai
vec_cmpgt(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_cmpgt_VBiVUiVUi");

vector bool int __ATTRS_o_ai
vec_cmpgt(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_cmpgt_VBiVSiVSi");

vector bool char __ATTRS_o_ai
vec_cmple(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_cmple_VBcVUcVUc");

vector bool char __ATTRS_o_ai
vec_cmple(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_cmple_VBcVScVSc");

vector bool short __ATTRS_o_ai
vec_cmple(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_cmple_VBsVUsVUs");

vector bool short __ATTRS_o_ai
vec_cmple(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_cmple_VBsVSsVSs");

vector bool int __ATTRS_o_ai
vec_cmple(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_cmple_VBiVUiVUi");

vector bool int __ATTRS_o_ai
vec_cmple(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_cmple_VBiVSiVSi");

vector bool char __ATTRS_o_ai
vec_cmplt(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_cmplt_VBcVUcVUc");

vector bool char __ATTRS_o_ai
vec_cmplt(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_cmplt_VBcVScVSc");

vector bool short __ATTRS_o_ai
vec_cmplt(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_cmplt_VBsVUsVUs");

vector bool short __ATTRS_o_ai
vec_cmplt(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_cmplt_VBsVSsVSs");

vector bool int __ATTRS_o_ai
vec_cmplt(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_cmplt_VBiVUiVUi");

vector bool int __ATTRS_o_ai
vec_cmplt(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_cmplt_VBiVSiVSi");

vector unsigned char __ATTRS_o_ai
vec_max(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_max_VUcVUcVUc");

vector unsigned char __ATTRS_o_ai
vec_max(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_max_VUcVUcVBc");

vector unsigned char __ATTRS_o_ai
vec_max(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_max_VUcVBcVUc");

vector signed char __ATTRS_o_ai
vec_max(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_max_VScVScVSc");

vector signed char __ATTRS_o_ai
vec_max(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_max_VScVScVBc");

vector signed char __ATTRS_o_ai
vec_max(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_max_VScVBcVSc");

vector unsigned short __ATTRS_o_ai
vec_max(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_max_VUsVUsVUs");

vector unsigned short __ATTRS_o_ai
vec_max(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_max_VUsVUsVBs");

vector unsigned short __ATTRS_o_ai
vec_max(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_max_VUsVBsVUs");

vector signed short __ATTRS_o_ai
vec_max(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_max_VSsVSsVSs");

vector signed short __ATTRS_o_ai
vec_max(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_max_VSsVSsVBs");

vector signed short __ATTRS_o_ai
vec_max(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_max_VSsVBsVSs");

vector unsigned int __ATTRS_o_ai
vec_max(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_max_VUiVUiVUi");

vector unsigned int __ATTRS_o_ai
vec_max(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_max_VUiVUiVBi");

vector unsigned int __ATTRS_o_ai
vec_max(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_max_VUiVBiVUi");

vector signed int __ATTRS_o_ai
vec_max(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_max_VSiVSiVSi");

vector signed int __ATTRS_o_ai
vec_max(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_max_VSiVSiVBi");

vector signed int __ATTRS_o_ai
vec_max(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_max_VSiVBiVSi");

vector unsigned char __ATTRS_o_ai
vec_mergeh(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_mergeh_VUcVUcVUc");

vector signed char __ATTRS_o_ai
vec_mergeh(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_mergeh_VScVScVSc");

vector bool char __ATTRS_o_ai
vec_mergeh(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_mergeh_VBcVBcVBc");

vector unsigned short __ATTRS_o_ai
vec_mergeh(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_mergeh_VUsVUsVUs");

vector signed short __ATTRS_o_ai
vec_mergeh(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_mergeh_VSsVSsVSs");

vector bool short __ATTRS_o_ai
vec_mergeh(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_mergeh_VBsVBsVBs");

vector unsigned int __ATTRS_o_ai
vec_mergeh(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_mergeh_VUiVUiVUi");

vector signed int __ATTRS_o_ai
vec_mergeh(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_mergeh_VSiVSiVSi");

vector bool int __ATTRS_o_ai
vec_mergeh(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_mergeh_VBiVBiVBi");

vector unsigned char __ATTRS_o_ai
vec_mergel(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_mergel_VUcVUcVUc");

vector signed char __ATTRS_o_ai
vec_mergel(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_mergel_VScVScVSc");

vector bool char __ATTRS_o_ai
vec_mergel(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_mergel_VBcVBcVBc");

vector unsigned short __ATTRS_o_ai
vec_mergel(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_mergel_VUsVUsVUs");

vector signed short __ATTRS_o_ai
vec_mergel(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_mergel_VSsVSsVSs");

vector bool short __ATTRS_o_ai
vec_mergel(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_mergel_VBsVBsVBs");

vector unsigned int __ATTRS_o_ai
vec_mergel(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_mergel_VUiVUiVUi");

vector signed int __ATTRS_o_ai
vec_mergel(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_mergel_VSiVSiVSi");

vector bool int __ATTRS_o_ai
vec_mergel(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_mergel_VBiVBiVBi");

vector unsigned char __ATTRS_o_ai
vec_min(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_min_VUcVUcVUc");

vector unsigned char __ATTRS_o_ai
vec_min(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_min_VUcVUcVBc");

vector unsigned char __ATTRS_o_ai
vec_min(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_min_VUcVBcVUc");

vector signed char __ATTRS_o_ai
vec_min(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_min_VScVScVSc");

vector signed char __ATTRS_o_ai
vec_min(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_min_VScVScVBc");

vector signed char __ATTRS_o_ai
vec_min(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_min_VScVBcVSc");

vector unsigned short __ATTRS_o_ai
vec_min(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_min_VUsVUsVUs");

vector unsigned short __ATTRS_o_ai
vec_min(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_min_VUsVUsVBs");

vector unsigned short __ATTRS_o_ai
vec_min(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_min_VUsVBsVUs");

vector signed short __ATTRS_o_ai
vec_min(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_min_VSsVSsVSs");

vector signed short __ATTRS_o_ai
vec_min(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_min_VSsVSsVBs");

vector signed short __ATTRS_o_ai
vec_min(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_min_VSsVBsVSs");

vector unsigned int __ATTRS_o_ai
vec_min(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_min_VUiVUiVUi");

vector unsigned int __ATTRS_o_ai
vec_min(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_min_VUiVUiVBi");

vector unsigned int __ATTRS_o_ai
vec_min(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_min_VUiVBiVUi");

vector signed int __ATTRS_o_ai
vec_min(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_min_VSiVSiVSi");

vector signed int __ATTRS_o_ai
vec_min(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_min_VSiVSiVBi");

vector signed int __ATTRS_o_ai
vec_min(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_min_VSiVBiVSi");

vector unsigned short __ATTRS_o_ai
vec_mladd(vector unsigned short __a, vector unsigned short __b, vector unsigned short __c) __asm__("__IBMBuiltin_vec_mladd_VUsVUsVUsVUs");

vector signed short __ATTRS_o_ai
vec_mladd(vector unsigned short __a, vector signed short __b, vector signed short __c) __asm__("__IBMBuiltin_vec_mladd_VSsVUsVSsVSs");

vector signed short __ATTRS_o_ai
vec_mladd(vector signed short __a, vector unsigned short __b, vector unsigned short __c) __asm__("__IBMBuiltin_vec_mladd_VSsVSsVUsVUs");

vector signed short __ATTRS_o_ai
vec_mladd(vector signed short __a, vector signed short __b, vector signed short __c) __asm__("__IBMBuiltin_vec_mladd_VSsVSsVSsVSs");

vector unsigned short __ATTRS_o_ai
vec_mule(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_mule_VUsVUcVUc");

vector signed short __ATTRS_o_ai
vec_mule(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_mule_VSsVScVSc");

vector unsigned int __ATTRS_o_ai
vec_mule(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_mule_VUiVUsVUs");

vector signed int __ATTRS_o_ai
vec_mule(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_mule_VSiVSsVSs");

vector unsigned short __ATTRS_o_ai
vec_mulo(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_mulo_VUsVUcVUc");

vector signed short __ATTRS_o_ai
vec_mulo(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_mulo_VSsVScVSc");

vector unsigned int __ATTRS_o_ai
vec_mulo(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_mulo_VUiVUsVUs");

vector signed int __ATTRS_o_ai
vec_mulo(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_mulo_VSiVSsVSs");

vector unsigned char __ATTRS_o_ai
vec_nor(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_nor_VUcVUcVUc");

vector signed char __ATTRS_o_ai
vec_nor(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_nor_VScVScVSc");

vector bool char __ATTRS_o_ai
vec_nor(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_nor_VBcVBcVBc");

vector unsigned short __ATTRS_o_ai
vec_nor(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_nor_VUsVUsVUs");

vector signed short __ATTRS_o_ai
vec_nor(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_nor_VSsVSsVSs");

vector bool short __ATTRS_o_ai
vec_nor(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_nor_VBsVBsVBs");

vector unsigned int __ATTRS_o_ai
vec_nor(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_nor_VUiVUiVUi");

vector signed int __ATTRS_o_ai
vec_nor(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_nor_VSiVSiVSi");

vector bool int __ATTRS_o_ai
vec_nor(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_nor_VBiVBiVBi");

vector unsigned char __ATTRS_o_ai
vec_pack(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_pack_VUcVUsVUs");

vector signed char __ATTRS_o_ai
vec_pack(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_pack_VScVSsVSs");

vector bool char __ATTRS_o_ai
vec_pack(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_pack_VBcVBsVBs");

vector unsigned short __ATTRS_o_ai
vec_pack(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_pack_VUsVUiVUi");

vector signed short __ATTRS_o_ai
vec_pack(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_pack_VSsVSiVSi");

vector bool short __ATTRS_o_ai
vec_pack(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_pack_VBsVBiVBi");

vector unsigned char __ATTRS_o_ai
vec_packs(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_packs_VUcVUsVUs");

vector signed char __ATTRS_o_ai
vec_packs(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_packs_VScVSsVSs");

vector unsigned short __ATTRS_o_ai
vec_packs(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_packs_VUsVUiVUi");

vector signed short __ATTRS_o_ai
vec_packs(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_packs_VSsVSiVSi");

vector unsigned char __ATTRS_o_ai
vec_packsu(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_packsu_VUcVUsVUs");

vector unsigned char __ATTRS_o_ai
vec_packsu(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_packsu_VUcVSsVSs");

vector unsigned short __ATTRS_o_ai
vec_packsu(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_packsu_VUsVUiVUi");

vector unsigned short __ATTRS_o_ai
vec_packsu(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_packsu_VUsVSiVSi");

vector unsigned char __ATTRS_o_ai
vec_perm(vector unsigned char __a, vector unsigned char __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_VUcVUcVUcVUc");

vector signed char __ATTRS_o_ai
vec_perm(vector signed char __a, vector signed char __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_VScVScVScVUc");

vector bool char __ATTRS_o_ai
vec_perm(vector bool char __a, vector bool char __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_VBcVBcVBcVUc");

vector unsigned short __ATTRS_o_ai
vec_perm(vector unsigned short __a, vector unsigned short __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_VUsVUsVUsVUc");

vector signed short __ATTRS_o_ai
vec_perm(vector signed short __a, vector signed short __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_VSsVSsVSsVUc");

vector bool short __ATTRS_o_ai
vec_perm(vector bool short __a, vector bool short __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_VBsVBsVBsVUc");

vector unsigned int __ATTRS_o_ai
vec_perm(vector unsigned int __a, vector unsigned int __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_VUiVUiVUiVUc");

vector signed int __ATTRS_o_ai
vec_perm(vector signed int __a, vector signed int __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_VSiVSiVSiVUc");

vector bool int __ATTRS_o_ai
vec_perm(vector bool int __a, vector bool int __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_VBiVBiVBiVUc");

vector unsigned char __ATTRS_o_ai
vec_rl(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_rl_VUcVUcVUc");

vector signed char __ATTRS_o_ai
vec_rl(vector signed char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_rl_VScVScVUc");

vector unsigned short __ATTRS_o_ai
vec_rl(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_rl_VUsVUsVUs");

vector signed short __ATTRS_o_ai
vec_rl(vector signed short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_rl_VSsVSsVUs");

vector unsigned int __ATTRS_o_ai
vec_rl(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_rl_VUiVUiVUi");

vector signed int __ATTRS_o_ai
vec_rl(vector signed int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_rl_VSiVSiVUi");

vector unsigned char __ATTRS_o_ai
vec_sel(vector unsigned char __a, vector unsigned char __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_sel_VUcVUcVUcVUc");

vector unsigned char __ATTRS_o_ai
vec_sel(vector unsigned char __a, vector unsigned char __b, vector bool char __c) __asm__("__IBMBuiltin_vec_sel_VUcVUcVUcVBc");

vector signed char __ATTRS_o_ai
vec_sel(vector signed char __a, vector signed char __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_sel_VScVScVScVUc");

vector signed char __ATTRS_o_ai
vec_sel(vector signed char __a, vector signed char __b, vector bool char __c) __asm__("__IBMBuiltin_vec_sel_VScVScVScVBc");

vector bool char __ATTRS_o_ai
vec_sel(vector bool char __a, vector bool char __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_sel_VBcVBcVBcVUc");

vector bool char __ATTRS_o_ai
vec_sel(vector bool char __a, vector bool char __b, vector bool char __c) __asm__("__IBMBuiltin_vec_sel_VBcVBcVBcVBc");

vector unsigned short __ATTRS_o_ai
vec_sel(vector unsigned short __a, vector unsigned short __b, vector unsigned short __c) __asm__("__IBMBuiltin_vec_sel_VUsVUsVUsVUs");

vector unsigned short __ATTRS_o_ai
vec_sel(vector unsigned short __a, vector unsigned short __b, vector bool short __c) __asm__("__IBMBuiltin_vec_sel_VUsVUsVUsVBs");

vector signed short __ATTRS_o_ai
vec_sel(vector signed short __a, vector signed short __b, vector unsigned short __c) __asm__("__IBMBuiltin_vec_sel_VSsVSsVSsVUs");

vector signed short __ATTRS_o_ai
vec_sel(vector signed short __a, vector signed short __b, vector bool short __c) __asm__("__IBMBuiltin_vec_sel_VSsVSsVSsVBs");

vector bool short __ATTRS_o_ai
vec_sel(vector bool short __a, vector bool short __b, vector unsigned short __c) __asm__("__IBMBuiltin_vec_sel_VBsVBsVBsVUs");

vector bool short __ATTRS_o_ai
vec_sel(vector bool short __a, vector bool short __b, vector bool short __c) __asm__("__IBMBuiltin_vec_sel_VBsVBsVBsVBs");

vector unsigned int __ATTRS_o_ai
vec_sel(vector unsigned int __a, vector unsigned int __b, vector unsigned int __c) __asm__("__IBMBuiltin_vec_sel_VUiVUiVUiVUi");

vector unsigned int __ATTRS_o_ai
vec_sel(vector unsigned int __a, vector unsigned int __b, vector bool int __c) __asm__("__IBMBuiltin_vec_sel_VUiVUiVUiVBi");

vector signed int __ATTRS_o_ai
vec_sel(vector signed int __a, vector signed int __b, vector unsigned int __c) __asm__("__IBMBuiltin_vec_sel_VSiVSiVSiVUi");

vector signed int __ATTRS_o_ai
vec_sel(vector signed int __a, vector signed int __b, vector bool int __c) __asm__("__IBMBuiltin_vec_sel_VSiVSiVSiVBi");

vector bool int __ATTRS_o_ai
vec_sel(vector bool int __a, vector bool int __b, vector unsigned int __c) __asm__("__IBMBuiltin_vec_sel_VBiVBiVBiVUi");

vector bool int __ATTRS_o_ai
vec_sel(vector bool int __a, vector bool int __b, vector bool int __c) __asm__("__IBMBuiltin_vec_sel_VBiVBiVBiVBi");

vector unsigned char __ATTRS_o_ai
vec_sll(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sll_VUcVUcVUc");

vector unsigned char __ATTRS_o_ai
vec_sll(vector unsigned char __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sll_VUcVUcVUs");

vector unsigned char __ATTRS_o_ai
vec_sll(vector unsigned char __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sll_VUcVUcVUi");

vector signed char __ATTRS_o_ai
vec_sll(vector signed char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sll_VScVScVUc");

vector signed char __ATTRS_o_ai
vec_sll(vector signed char __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sll_VScVScVUs");

vector signed char __ATTRS_o_ai
vec_sll(vector signed char __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sll_VScVScVUi");

vector bool char __ATTRS_o_ai
vec_sll(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sll_VBcVBcVUc");

vector bool char __ATTRS_o_ai
vec_sll(vector bool char __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sll_VBcVBcVUs");

vector bool char __ATTRS_o_ai
vec_sll(vector bool char __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sll_VBcVBcVUi");

vector unsigned short __ATTRS_o_ai
vec_sll(vector unsigned short __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sll_VUsVUsVUc");

vector unsigned short __ATTRS_o_ai
vec_sll(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sll_VUsVUsVUs");

vector unsigned short __ATTRS_o_ai
vec_sll(vector unsigned short __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sll_VUsVUsVUi");

vector signed short __ATTRS_o_ai
vec_sll(vector signed short __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sll_VSsVSsVUc");

vector signed short __ATTRS_o_ai
vec_sll(vector signed short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sll_VSsVSsVUs");

vector signed short __ATTRS_o_ai
vec_sll(vector signed short __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sll_VSsVSsVUi");

vector bool short __ATTRS_o_ai
vec_sll(vector bool short __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sll_VBsVBsVUc");

vector bool short __ATTRS_o_ai
vec_sll(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sll_VBsVBsVUs");

vector bool short __ATTRS_o_ai
vec_sll(vector bool short __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sll_VBsVBsVUi");

vector unsigned int __ATTRS_o_ai
vec_sll(vector unsigned int __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sll_VUiVUiVUc");

vector unsigned int __ATTRS_o_ai
vec_sll(vector unsigned int __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sll_VUiVUiVUs");

vector unsigned int __ATTRS_o_ai
vec_sll(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sll_VUiVUiVUi");

vector signed int __ATTRS_o_ai
vec_sll(vector signed int __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sll_VSiVSiVUc");

vector signed int __ATTRS_o_ai
vec_sll(vector signed int __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sll_VSiVSiVUs");

vector signed int __ATTRS_o_ai
vec_sll(vector signed int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sll_VSiVSiVUi");

vector bool int __ATTRS_o_ai
vec_sll(vector bool int __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sll_VBiVBiVUc");

vector bool int __ATTRS_o_ai
vec_sll(vector bool int __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sll_VBiVBiVUs");

vector bool int __ATTRS_o_ai
vec_sll(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sll_VBiVBiVUi");

vector unsigned char __ATTRS_o_ai
vec_srl(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_srl_VUcVUcVUc");

vector unsigned char __ATTRS_o_ai
vec_srl(vector unsigned char __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_srl_VUcVUcVUs");

vector unsigned char __ATTRS_o_ai
vec_srl(vector unsigned char __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_srl_VUcVUcVUi");

vector signed char __ATTRS_o_ai
vec_srl(vector signed char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_srl_VScVScVUc");

vector signed char __ATTRS_o_ai
vec_srl(vector signed char __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_srl_VScVScVUs");

vector signed char __ATTRS_o_ai
vec_srl(vector signed char __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_srl_VScVScVUi");

vector bool char __ATTRS_o_ai
vec_srl(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_srl_VBcVBcVUc");

vector bool char __ATTRS_o_ai
vec_srl(vector bool char __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_srl_VBcVBcVUs");

vector bool char __ATTRS_o_ai
vec_srl(vector bool char __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_srl_VBcVBcVUi");

vector unsigned short __ATTRS_o_ai
vec_srl(vector unsigned short __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_srl_VUsVUsVUc");

vector unsigned short __ATTRS_o_ai
vec_srl(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_srl_VUsVUsVUs");

vector unsigned short __ATTRS_o_ai
vec_srl(vector unsigned short __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_srl_VUsVUsVUi");

vector signed short __ATTRS_o_ai
vec_srl(vector signed short __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_srl_VSsVSsVUc");

vector signed short __ATTRS_o_ai
vec_srl(vector signed short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_srl_VSsVSsVUs");

vector signed short __ATTRS_o_ai
vec_srl(vector signed short __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_srl_VSsVSsVUi");

vector bool short __ATTRS_o_ai
vec_srl(vector bool short __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_srl_VBsVBsVUc");

vector bool short __ATTRS_o_ai
vec_srl(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_srl_VBsVBsVUs");

vector bool short __ATTRS_o_ai
vec_srl(vector bool short __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_srl_VBsVBsVUi");

vector unsigned int __ATTRS_o_ai
vec_srl(vector unsigned int __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_srl_VUiVUiVUc");

vector unsigned int __ATTRS_o_ai
vec_srl(vector unsigned int __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_srl_VUiVUiVUs");

vector unsigned int __ATTRS_o_ai
vec_srl(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_srl_VUiVUiVUi");

vector signed int __ATTRS_o_ai
vec_srl(vector signed int __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_srl_VSiVSiVUc");

vector signed int __ATTRS_o_ai
vec_srl(vector signed int __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_srl_VSiVSiVUs");

vector signed int __ATTRS_o_ai
vec_srl(vector signed int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_srl_VSiVSiVUi");

vector bool int __ATTRS_o_ai
vec_srl(vector bool int __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_srl_VBiVBiVUc");

vector bool int __ATTRS_o_ai
vec_srl(vector bool int __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_srl_VBiVBiVUs");

vector bool int __ATTRS_o_ai
vec_srl(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_srl_VBiVBiVUi");

vector unsigned int __ATTRS_o_ai
vec_subc(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_subc_VUiVUiVUi");

signed int __ATTRS_o_ai
vec_all_eq(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_all_eq_iVUcVUc");

signed int __ATTRS_o_ai
vec_all_eq(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_all_eq_iVUcVBc");

signed int __ATTRS_o_ai
vec_all_eq(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_all_eq_iVScVSc");

signed int __ATTRS_o_ai
vec_all_eq(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_all_eq_iVScVBc");

signed int __ATTRS_o_ai
vec_all_eq(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_all_eq_iVBcVUc");

signed int __ATTRS_o_ai
vec_all_eq(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_all_eq_iVBcVSc");

signed int __ATTRS_o_ai
vec_all_eq(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_all_eq_iVBcVBc");

signed int __ATTRS_o_ai
vec_all_eq(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_all_eq_iVUsVUs");

signed int __ATTRS_o_ai
vec_all_eq(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_all_eq_iVUsVBs");

signed int __ATTRS_o_ai
vec_all_eq(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_all_eq_iVSsVSs");

signed int __ATTRS_o_ai
vec_all_eq(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_all_eq_iVSsVBs");

signed int __ATTRS_o_ai
vec_all_eq(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_all_eq_iVBsVUs");

signed int __ATTRS_o_ai
vec_all_eq(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_all_eq_iVBsVSs");

signed int __ATTRS_o_ai
vec_all_eq(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_all_eq_iVBsVBs");

signed int __ATTRS_o_ai
vec_all_eq(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_all_eq_iVUiVUi");

signed int __ATTRS_o_ai
vec_all_eq(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_all_eq_iVUiVBi");

signed int __ATTRS_o_ai
vec_all_eq(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_all_eq_iVSiVSi");

signed int __ATTRS_o_ai
vec_all_eq(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_all_eq_iVSiVBi");

signed int __ATTRS_o_ai
vec_all_eq(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_all_eq_iVBiVUi");

signed int __ATTRS_o_ai
vec_all_eq(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_all_eq_iVBiVSi");

signed int __ATTRS_o_ai
vec_all_eq(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_all_eq_iVBiVBi");

signed int __ATTRS_o_ai
vec_all_ge(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_all_ge_iVUcVUc");

signed int __ATTRS_o_ai
vec_all_ge(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_all_ge_iVUcVBc");

signed int __ATTRS_o_ai
vec_all_ge(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_all_ge_iVBcVUc");

signed int __ATTRS_o_ai
vec_all_ge(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_all_ge_iVScVSc");

signed int __ATTRS_o_ai
vec_all_ge(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_all_ge_iVScVBc");

signed int __ATTRS_o_ai
vec_all_ge(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_all_ge_iVBcVSc");

signed int __ATTRS_o_ai
vec_all_ge(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_all_ge_iVUsVUs");

signed int __ATTRS_o_ai
vec_all_ge(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_all_ge_iVUsVBs");

signed int __ATTRS_o_ai
vec_all_ge(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_all_ge_iVBsVUs");

signed int __ATTRS_o_ai
vec_all_ge(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_all_ge_iVSsVSs");

signed int __ATTRS_o_ai
vec_all_ge(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_all_ge_iVSsVBs");

signed int __ATTRS_o_ai
vec_all_ge(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_all_ge_iVBsVSs");

signed int __ATTRS_o_ai
vec_all_ge(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_all_ge_iVUiVUi");

signed int __ATTRS_o_ai
vec_all_ge(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_all_ge_iVUiVBi");

signed int __ATTRS_o_ai
vec_all_ge(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_all_ge_iVBiVUi");

signed int __ATTRS_o_ai
vec_all_ge(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_all_ge_iVSiVSi");

signed int __ATTRS_o_ai
vec_all_ge(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_all_ge_iVSiVBi");

signed int __ATTRS_o_ai
vec_all_ge(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_all_ge_iVBiVSi");

signed int __ATTRS_o_ai
vec_all_gt(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_all_gt_iVUcVUc");

signed int __ATTRS_o_ai
vec_all_gt(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_all_gt_iVUcVBc");

signed int __ATTRS_o_ai
vec_all_gt(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_all_gt_iVBcVUc");

signed int __ATTRS_o_ai
vec_all_gt(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_all_gt_iVScVSc");

signed int __ATTRS_o_ai
vec_all_gt(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_all_gt_iVScVBc");

signed int __ATTRS_o_ai
vec_all_gt(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_all_gt_iVBcVSc");

signed int __ATTRS_o_ai
vec_all_gt(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_all_gt_iVUsVUs");

signed int __ATTRS_o_ai
vec_all_gt(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_all_gt_iVUsVBs");

signed int __ATTRS_o_ai
vec_all_gt(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_all_gt_iVBsVUs");

signed int __ATTRS_o_ai
vec_all_gt(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_all_gt_iVSsVSs");

signed int __ATTRS_o_ai
vec_all_gt(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_all_gt_iVSsVBs");

signed int __ATTRS_o_ai
vec_all_gt(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_all_gt_iVBsVSs");

signed int __ATTRS_o_ai
vec_all_gt(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_all_gt_iVUiVUi");

signed int __ATTRS_o_ai
vec_all_gt(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_all_gt_iVUiVBi");

signed int __ATTRS_o_ai
vec_all_gt(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_all_gt_iVBiVUi");

signed int __ATTRS_o_ai
vec_all_gt(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_all_gt_iVSiVSi");

signed int __ATTRS_o_ai
vec_all_gt(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_all_gt_iVSiVBi");

signed int __ATTRS_o_ai
vec_all_gt(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_all_gt_iVBiVSi");

signed int __ATTRS_o_ai
vec_all_le(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_all_le_iVUcVUc");

signed int __ATTRS_o_ai
vec_all_le(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_all_le_iVUcVBc");

signed int __ATTRS_o_ai
vec_all_le(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_all_le_iVBcVUc");

signed int __ATTRS_o_ai
vec_all_le(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_all_le_iVScVSc");

signed int __ATTRS_o_ai
vec_all_le(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_all_le_iVScVBc");

signed int __ATTRS_o_ai
vec_all_le(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_all_le_iVBcVSc");

signed int __ATTRS_o_ai
vec_all_le(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_all_le_iVUsVUs");

signed int __ATTRS_o_ai
vec_all_le(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_all_le_iVUsVBs");

signed int __ATTRS_o_ai
vec_all_le(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_all_le_iVBsVUs");

signed int __ATTRS_o_ai
vec_all_le(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_all_le_iVSsVSs");

signed int __ATTRS_o_ai
vec_all_le(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_all_le_iVSsVBs");

signed int __ATTRS_o_ai
vec_all_le(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_all_le_iVBsVSs");

signed int __ATTRS_o_ai
vec_all_le(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_all_le_iVUiVUi");

signed int __ATTRS_o_ai
vec_all_le(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_all_le_iVUiVBi");

signed int __ATTRS_o_ai
vec_all_le(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_all_le_iVBiVUi");

signed int __ATTRS_o_ai
vec_all_le(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_all_le_iVSiVSi");

signed int __ATTRS_o_ai
vec_all_le(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_all_le_iVSiVBi");

signed int __ATTRS_o_ai
vec_all_le(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_all_le_iVBiVSi");

signed int __ATTRS_o_ai
vec_all_lt(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_all_lt_iVUcVUc");

signed int __ATTRS_o_ai
vec_all_lt(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_all_lt_iVUcVBc");

signed int __ATTRS_o_ai
vec_all_lt(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_all_lt_iVBcVUc");

signed int __ATTRS_o_ai
vec_all_lt(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_all_lt_iVScVSc");

signed int __ATTRS_o_ai
vec_all_lt(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_all_lt_iVScVBc");

signed int __ATTRS_o_ai
vec_all_lt(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_all_lt_iVBcVSc");

signed int __ATTRS_o_ai
vec_all_lt(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_all_lt_iVUsVUs");

signed int __ATTRS_o_ai
vec_all_lt(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_all_lt_iVUsVBs");

signed int __ATTRS_o_ai
vec_all_lt(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_all_lt_iVBsVUs");

signed int __ATTRS_o_ai
vec_all_lt(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_all_lt_iVSsVSs");

signed int __ATTRS_o_ai
vec_all_lt(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_all_lt_iVSsVBs");

signed int __ATTRS_o_ai
vec_all_lt(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_all_lt_iVBsVSs");

signed int __ATTRS_o_ai
vec_all_lt(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_all_lt_iVUiVUi");

signed int __ATTRS_o_ai
vec_all_lt(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_all_lt_iVUiVBi");

signed int __ATTRS_o_ai
vec_all_lt(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_all_lt_iVBiVUi");

signed int __ATTRS_o_ai
vec_all_lt(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_all_lt_iVSiVSi");

signed int __ATTRS_o_ai
vec_all_lt(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_all_lt_iVSiVBi");

signed int __ATTRS_o_ai
vec_all_lt(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_all_lt_iVBiVSi");

signed int __ATTRS_o_ai
vec_all_ne(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_all_ne_iVUcVUc");

signed int __ATTRS_o_ai
vec_all_ne(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_all_ne_iVUcVBc");

signed int __ATTRS_o_ai
vec_all_ne(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_all_ne_iVScVSc");

signed int __ATTRS_o_ai
vec_all_ne(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_all_ne_iVScVBc");

signed int __ATTRS_o_ai
vec_all_ne(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_all_ne_iVBcVUc");

signed int __ATTRS_o_ai
vec_all_ne(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_all_ne_iVBcVSc");

signed int __ATTRS_o_ai
vec_all_ne(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_all_ne_iVBcVBc");

signed int __ATTRS_o_ai
vec_all_ne(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_all_ne_iVUsVUs");

signed int __ATTRS_o_ai
vec_all_ne(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_all_ne_iVUsVBs");

signed int __ATTRS_o_ai
vec_all_ne(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_all_ne_iVSsVSs");

signed int __ATTRS_o_ai
vec_all_ne(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_all_ne_iVSsVBs");

signed int __ATTRS_o_ai
vec_all_ne(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_all_ne_iVBsVUs");

signed int __ATTRS_o_ai
vec_all_ne(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_all_ne_iVBsVSs");

signed int __ATTRS_o_ai
vec_all_ne(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_all_ne_iVBsVBs");

signed int __ATTRS_o_ai
vec_all_ne(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_all_ne_iVUiVUi");

signed int __ATTRS_o_ai
vec_all_ne(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_all_ne_iVUiVBi");

signed int __ATTRS_o_ai
vec_all_ne(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_all_ne_iVSiVSi");

signed int __ATTRS_o_ai
vec_all_ne(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_all_ne_iVSiVBi");

signed int __ATTRS_o_ai
vec_all_ne(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_all_ne_iVBiVUi");

signed int __ATTRS_o_ai
vec_all_ne(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_all_ne_iVBiVSi");

signed int __ATTRS_o_ai
vec_all_ne(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_all_ne_iVBiVBi");

signed int __ATTRS_o_ai
vec_any_eq(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_any_eq_iVUcVUc");

signed int __ATTRS_o_ai
vec_any_eq(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_any_eq_iVUcVBc");

signed int __ATTRS_o_ai
vec_any_eq(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_any_eq_iVScVSc");

signed int __ATTRS_o_ai
vec_any_eq(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_any_eq_iVScVBc");

signed int __ATTRS_o_ai
vec_any_eq(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_any_eq_iVBcVUc");

signed int __ATTRS_o_ai
vec_any_eq(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_any_eq_iVBcVSc");

signed int __ATTRS_o_ai
vec_any_eq(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_any_eq_iVBcVBc");

signed int __ATTRS_o_ai
vec_any_eq(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_any_eq_iVUsVUs");

signed int __ATTRS_o_ai
vec_any_eq(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_any_eq_iVUsVBs");

signed int __ATTRS_o_ai
vec_any_eq(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_any_eq_iVSsVSs");

signed int __ATTRS_o_ai
vec_any_eq(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_any_eq_iVSsVBs");

signed int __ATTRS_o_ai
vec_any_eq(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_any_eq_iVBsVUs");

signed int __ATTRS_o_ai
vec_any_eq(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_any_eq_iVBsVSs");

signed int __ATTRS_o_ai
vec_any_eq(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_any_eq_iVBsVBs");

signed int __ATTRS_o_ai
vec_any_eq(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_any_eq_iVUiVUi");

signed int __ATTRS_o_ai
vec_any_eq(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_any_eq_iVUiVBi");

signed int __ATTRS_o_ai
vec_any_eq(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_any_eq_iVSiVSi");

signed int __ATTRS_o_ai
vec_any_eq(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_any_eq_iVSiVBi");

signed int __ATTRS_o_ai
vec_any_eq(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_any_eq_iVBiVUi");

signed int __ATTRS_o_ai
vec_any_eq(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_any_eq_iVBiVSi");

signed int __ATTRS_o_ai
vec_any_eq(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_any_eq_iVBiVBi");

signed int __ATTRS_o_ai
vec_any_ge(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_any_ge_iVUcVUc");

signed int __ATTRS_o_ai
vec_any_ge(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_any_ge_iVUcVBc");

signed int __ATTRS_o_ai
vec_any_ge(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_any_ge_iVBcVUc");

signed int __ATTRS_o_ai
vec_any_ge(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_any_ge_iVScVSc");

signed int __ATTRS_o_ai
vec_any_ge(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_any_ge_iVScVBc");

signed int __ATTRS_o_ai
vec_any_ge(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_any_ge_iVBcVSc");

signed int __ATTRS_o_ai
vec_any_ge(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_any_ge_iVUsVUs");

signed int __ATTRS_o_ai
vec_any_ge(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_any_ge_iVUsVBs");

signed int __ATTRS_o_ai
vec_any_ge(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_any_ge_iVBsVUs");

signed int __ATTRS_o_ai
vec_any_ge(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_any_ge_iVSsVSs");

signed int __ATTRS_o_ai
vec_any_ge(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_any_ge_iVSsVBs");

signed int __ATTRS_o_ai
vec_any_ge(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_any_ge_iVBsVSs");

signed int __ATTRS_o_ai
vec_any_ge(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_any_ge_iVUiVUi");

signed int __ATTRS_o_ai
vec_any_ge(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_any_ge_iVUiVBi");

signed int __ATTRS_o_ai
vec_any_ge(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_any_ge_iVBiVUi");

signed int __ATTRS_o_ai
vec_any_ge(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_any_ge_iVSiVSi");

signed int __ATTRS_o_ai
vec_any_ge(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_any_ge_iVSiVBi");

signed int __ATTRS_o_ai
vec_any_ge(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_any_ge_iVBiVSi");

signed int __ATTRS_o_ai
vec_any_gt(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_any_gt_iVUcVUc");

signed int __ATTRS_o_ai
vec_any_gt(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_any_gt_iVUcVBc");

signed int __ATTRS_o_ai
vec_any_gt(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_any_gt_iVBcVUc");

signed int __ATTRS_o_ai
vec_any_gt(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_any_gt_iVScVSc");

signed int __ATTRS_o_ai
vec_any_gt(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_any_gt_iVScVBc");

signed int __ATTRS_o_ai
vec_any_gt(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_any_gt_iVBcVSc");

signed int __ATTRS_o_ai
vec_any_gt(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_any_gt_iVUsVUs");

signed int __ATTRS_o_ai
vec_any_gt(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_any_gt_iVUsVBs");

signed int __ATTRS_o_ai
vec_any_gt(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_any_gt_iVBsVUs");

signed int __ATTRS_o_ai
vec_any_gt(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_any_gt_iVSsVSs");

signed int __ATTRS_o_ai
vec_any_gt(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_any_gt_iVSsVBs");

signed int __ATTRS_o_ai
vec_any_gt(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_any_gt_iVBsVSs");

signed int __ATTRS_o_ai
vec_any_gt(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_any_gt_iVUiVUi");

signed int __ATTRS_o_ai
vec_any_gt(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_any_gt_iVUiVBi");

signed int __ATTRS_o_ai
vec_any_gt(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_any_gt_iVBiVUi");

signed int __ATTRS_o_ai
vec_any_gt(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_any_gt_iVSiVSi");

signed int __ATTRS_o_ai
vec_any_gt(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_any_gt_iVSiVBi");

signed int __ATTRS_o_ai
vec_any_gt(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_any_gt_iVBiVSi");

signed int __ATTRS_o_ai
vec_any_le(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_any_le_iVUcVUc");

signed int __ATTRS_o_ai
vec_any_le(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_any_le_iVUcVBc");

signed int __ATTRS_o_ai
vec_any_le(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_any_le_iVBcVUc");

signed int __ATTRS_o_ai
vec_any_le(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_any_le_iVScVSc");

signed int __ATTRS_o_ai
vec_any_le(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_any_le_iVScVBc");

signed int __ATTRS_o_ai
vec_any_le(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_any_le_iVBcVSc");

signed int __ATTRS_o_ai
vec_any_le(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_any_le_iVUsVUs");

signed int __ATTRS_o_ai
vec_any_le(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_any_le_iVUsVBs");

signed int __ATTRS_o_ai
vec_any_le(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_any_le_iVBsVUs");

signed int __ATTRS_o_ai
vec_any_le(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_any_le_iVSsVSs");

signed int __ATTRS_o_ai
vec_any_le(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_any_le_iVSsVBs");

signed int __ATTRS_o_ai
vec_any_le(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_any_le_iVBsVSs");

signed int __ATTRS_o_ai
vec_any_le(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_any_le_iVUiVUi");

signed int __ATTRS_o_ai
vec_any_le(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_any_le_iVUiVBi");

signed int __ATTRS_o_ai
vec_any_le(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_any_le_iVBiVUi");

signed int __ATTRS_o_ai
vec_any_le(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_any_le_iVSiVSi");

signed int __ATTRS_o_ai
vec_any_le(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_any_le_iVSiVBi");

signed int __ATTRS_o_ai
vec_any_le(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_any_le_iVBiVSi");

signed int __ATTRS_o_ai
vec_any_lt(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_any_lt_iVUcVUc");

signed int __ATTRS_o_ai
vec_any_lt(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_any_lt_iVUcVBc");

signed int __ATTRS_o_ai
vec_any_lt(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_any_lt_iVBcVUc");

signed int __ATTRS_o_ai
vec_any_lt(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_any_lt_iVScVSc");

signed int __ATTRS_o_ai
vec_any_lt(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_any_lt_iVScVBc");

signed int __ATTRS_o_ai
vec_any_lt(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_any_lt_iVBcVSc");

signed int __ATTRS_o_ai
vec_any_lt(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_any_lt_iVUsVUs");

signed int __ATTRS_o_ai
vec_any_lt(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_any_lt_iVUsVBs");

signed int __ATTRS_o_ai
vec_any_lt(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_any_lt_iVBsVUs");

signed int __ATTRS_o_ai
vec_any_lt(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_any_lt_iVSsVSs");

signed int __ATTRS_o_ai
vec_any_lt(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_any_lt_iVSsVBs");

signed int __ATTRS_o_ai
vec_any_lt(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_any_lt_iVBsVSs");

signed int __ATTRS_o_ai
vec_any_lt(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_any_lt_iVUiVUi");

signed int __ATTRS_o_ai
vec_any_lt(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_any_lt_iVUiVBi");

signed int __ATTRS_o_ai
vec_any_lt(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_any_lt_iVBiVUi");

signed int __ATTRS_o_ai
vec_any_lt(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_any_lt_iVSiVSi");

signed int __ATTRS_o_ai
vec_any_lt(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_any_lt_iVSiVBi");

signed int __ATTRS_o_ai
vec_any_lt(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_any_lt_iVBiVSi");

signed int __ATTRS_o_ai
vec_any_ne(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_any_ne_iVUcVUc");

signed int __ATTRS_o_ai
vec_any_ne(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_any_ne_iVUcVBc");

signed int __ATTRS_o_ai
vec_any_ne(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_any_ne_iVScVSc");

signed int __ATTRS_o_ai
vec_any_ne(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_any_ne_iVScVBc");

signed int __ATTRS_o_ai
vec_any_ne(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_any_ne_iVBcVUc");

signed int __ATTRS_o_ai
vec_any_ne(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_any_ne_iVBcVSc");

signed int __ATTRS_o_ai
vec_any_ne(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_any_ne_iVBcVBc");

signed int __ATTRS_o_ai
vec_any_ne(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_any_ne_iVUsVUs");

signed int __ATTRS_o_ai
vec_any_ne(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_any_ne_iVUsVBs");

signed int __ATTRS_o_ai
vec_any_ne(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_any_ne_iVSsVSs");

signed int __ATTRS_o_ai
vec_any_ne(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_any_ne_iVSsVBs");

signed int __ATTRS_o_ai
vec_any_ne(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_any_ne_iVBsVUs");

signed int __ATTRS_o_ai
vec_any_ne(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_any_ne_iVBsVSs");

signed int __ATTRS_o_ai
vec_any_ne(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_any_ne_iVBsVBs");

signed int __ATTRS_o_ai
vec_any_ne(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_any_ne_iVUiVUi");

signed int __ATTRS_o_ai
vec_any_ne(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_any_ne_iVUiVBi");

signed int __ATTRS_o_ai
vec_any_ne(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_any_ne_iVSiVSi");

signed int __ATTRS_o_ai
vec_any_ne(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_any_ne_iVSiVBi");

signed int __ATTRS_o_ai
vec_any_ne(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_any_ne_iVBiVUi");

signed int __ATTRS_o_ai
vec_any_ne(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_any_ne_iVBiVSi");

signed int __ATTRS_o_ai
vec_any_ne(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_any_ne_iVBiVBi");

vector double __ATTRS_o_ai
vec_promote(double __a, signed int __b) __asm__("__IBMBuiltin_vec_promote_f8_Vddi");

vector signed long long __ATTRS_o_ai
vec_promote(signed long long __a, signed int __b) __asm__("__IBMBuiltin_vec_promote_s8_VSlli");

vector unsigned long long __ATTRS_o_ai
vec_promote(unsigned long long __a, signed int __b) __asm__("__IBMBuiltin_vec_promote_u8_VUlli");

vector signed int __ATTRS_o_ai
vec_promote(signed int __a, signed int __b) __asm__("__IBMBuiltin_vec_promote_s4_VSiii");

vector unsigned int __ATTRS_o_ai
vec_promote(unsigned int __a, signed int __b) __asm__("__IBMBuiltin_vec_promote_u4_VUiii");

vector signed short __ATTRS_o_ai
vec_promote(signed short __a, signed int __b) __asm__("__IBMBuiltin_vec_promote_s2_VSssi");

vector unsigned short __ATTRS_o_ai
vec_promote(unsigned short __a, signed int __b) __asm__("__IBMBuiltin_vec_promote_u2_VUssi");

vector signed char __ATTRS_o_ai
vec_promote(signed char __a, signed int __b) __asm__("__IBMBuiltin_vec_promote_s1_VScci");

vector unsigned char __ATTRS_o_ai
vec_promote(unsigned char __a, signed int __b) __asm__("__IBMBuiltin_vec_promote_u1_VUcci");

double __ATTRS_o_ai
vec_extract(vector double __a, signed int __b) __asm__("__IBMBuiltin_vec_extract_f8_dVdi");

signed long long __ATTRS_o_ai
vec_extract(vector signed long long __a, signed int __b) __asm__("__IBMBuiltin_vec_extract_s8_lVSli");

unsigned long long __ATTRS_o_ai
vec_extract(vector unsigned long long __a, signed int __b) __asm__("__IBMBuiltin_vec_extract_u8_lVUli");

unsigned long long __ATTRS_o_ai
vec_extract(vector bool long long __a, signed int __b) __asm__("__IBMBuiltin_vec_extract_u8_lVBli");

signed int __ATTRS_o_ai
vec_extract(vector signed int __a, signed int __b) __asm__("__IBMBuiltin_vec_extract_s4_iVSii");

unsigned int __ATTRS_o_ai
vec_extract(vector unsigned int __a, signed int __b) __asm__("__IBMBuiltin_vec_extract_u4_iVUii");

unsigned int __ATTRS_o_ai
vec_extract(vector bool int __a, signed int __b) __asm__("__IBMBuiltin_vec_extract_u4_iVBii");

signed short __ATTRS_o_ai
vec_extract(vector signed short __a, signed int __b) __asm__("__IBMBuiltin_vec_extract_s2_sVSsi");

unsigned short __ATTRS_o_ai
vec_extract(vector unsigned short __a, signed int __b) __asm__("__IBMBuiltin_vec_extract_u2_sVUsi");

unsigned short __ATTRS_o_ai
vec_extract(vector bool short __a, signed int __b) __asm__("__IBMBuiltin_vec_extract_u2_sVBsi");

signed char __ATTRS_o_ai
vec_extract(vector signed char __a, signed int __b) __asm__("__IBMBuiltin_vec_extract_s1_cVSci");

unsigned char __ATTRS_o_ai
vec_extract(vector unsigned char __a, signed int __b) __asm__("__IBMBuiltin_vec_extract_u1_cVUci");

unsigned char __ATTRS_o_ai
vec_extract(vector bool char __a, signed int __b) __asm__("__IBMBuiltin_vec_extract_u1_cVBci");

vector double __ATTRS_o_ai
vec_splats(double __a) __asm__("__IBMBuiltin_vec_splats_f8_Vdd");

vector signed long long __ATTRS_o_ai
vec_splats(signed long long __a) __asm__("__IBMBuiltin_vec_splats_s8_VSll");

vector unsigned long long __ATTRS_o_ai
vec_splats(unsigned long long __a) __asm__("__IBMBuiltin_vec_splats_u8_VUll");

vector signed int __ATTRS_o_ai
vec_splats(signed int __a) __asm__("__IBMBuiltin_vec_splats_s4_VSii");

vector unsigned int __ATTRS_o_ai
vec_splats(unsigned int __a) __asm__("__IBMBuiltin_vec_splats_u4_VUii");

vector signed short __ATTRS_o_ai
vec_splats(signed short __a) __asm__("__IBMBuiltin_vec_splats_s2_VSss");

vector unsigned short __ATTRS_o_ai
vec_splats(unsigned short __a) __asm__("__IBMBuiltin_vec_splats_u2_VUss");

vector signed char __ATTRS_o_ai
vec_splats(signed char __a) __asm__("__IBMBuiltin_vec_splats_s1_VScc");

vector unsigned char __ATTRS_o_ai
vec_splats(unsigned char __a) __asm__("__IBMBuiltin_vec_splats_u1_VUcc");

vector double __ATTRS_o_ai
vec_insert(double __a, vector double __b, signed int __c) __asm__("__IBMBuiltin_vec_insert_f8_VddVdi");

vector signed long long __ATTRS_o_ai
vec_insert(signed long long __a, vector signed long long __b, signed int __c) __asm__("__IBMBuiltin_vec_insert_s8_VSllVSli");

vector unsigned long long __ATTRS_o_ai
vec_insert(unsigned long long __a, vector unsigned long long __b, signed int __c) __asm__("__IBMBuiltin_vec_insert_u8_VUllVUli");

vector unsigned long long __ATTRS_o_ai
vec_insert(unsigned long long __a, vector bool long long __b, signed int __c) __asm__("__IBMBuiltin_vec_insert_u8_VUllVBli");

vector signed int __ATTRS_o_ai
vec_insert(signed int __a, vector signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_insert_s4_VSiiVSii");

vector unsigned int __ATTRS_o_ai
vec_insert(unsigned int __a, vector unsigned int __b, signed int __c) __asm__("__IBMBuiltin_vec_insert_u4_VUiiVUii");

vector unsigned int __ATTRS_o_ai
vec_insert(unsigned int __a, vector bool int __b, signed int __c) __asm__("__IBMBuiltin_vec_insert_u4_VUiiVBii");

vector signed short __ATTRS_o_ai
vec_insert(signed short __a, vector signed short __b, signed int __c) __asm__("__IBMBuiltin_vec_insert_s2_VSssVSsi");

vector unsigned short __ATTRS_o_ai
vec_insert(unsigned short __a, vector unsigned short __b, signed int __c) __asm__("__IBMBuiltin_vec_insert_u2_VUssVUsi");

vector unsigned short __ATTRS_o_ai
vec_insert(unsigned short __a, vector bool short __b, signed int __c) __asm__("__IBMBuiltin_vec_insert_u2_VUssVBsi");

vector signed char __ATTRS_o_ai
vec_insert(signed char __a, vector signed char __b, signed int __c) __asm__("__IBMBuiltin_vec_insert_s1_VSccVSci");

vector unsigned char __ATTRS_o_ai
vec_insert(unsigned char __a, vector unsigned char __b, signed int __c) __asm__("__IBMBuiltin_vec_insert_u1_VUccVUci");

vector unsigned char __ATTRS_o_ai
vec_insert(unsigned char __a, vector bool char __b, signed int __c) __asm__("__IBMBuiltin_vec_insert_u1_VUccVBci");

vector double __ATTRS_o_ai
vec_abs(vector double __a) __asm__("__IBMBuiltin_vec_abs_8_VdVd");

vector double __ATTRS_o_ai
vec_nabs(vector double __a) __asm__("__IBMBuiltin_vec_nabs_VdVd");

vector double __ATTRS_o_ai
vec_sqrt(vector double __a) __asm__("__IBMBuiltin_vec_sqrt_VdVd");

vector double __ATTRS_o_ai
vec_roundc(vector double __a) __asm__("__IBMBuiltin_vec_roundc_VdVd");

vector bool long long __ATTRS_o_ai
vec_cmpeq(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_cmpeq_8_VBlVdVd");

vector bool long long __ATTRS_o_ai
vec_cmpeq(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_cmpeq_8_VBlVSlVSl");

vector bool long long __ATTRS_o_ai
vec_cmpeq(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_cmpeq_8_VBlVUlVUl");

vector bool long long __ATTRS_o_ai
vec_cmpeq(vector bool long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_cmpeq_8_VBlVBlVBl");

vector bool long long __ATTRS_o_ai
vec_cmpge(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_cmpge_8_VBlVdVd");

vector bool long long __ATTRS_o_ai
vec_cmple(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_cmple_8_VBlVdVd");

vector bool long long __ATTRS_o_ai
vec_cmpge(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_cmpge_8_VBlVSlVSl");

vector bool long long __ATTRS_o_ai
vec_cmpge(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_cmpge_8_VBlVUlVUl");

vector bool long long __ATTRS_o_ai
vec_cmple(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_cmple_8_VBlVSlVSl");

vector bool long long __ATTRS_o_ai
vec_cmple(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_cmple_8_VBlVUlVUl");

vector bool long long __ATTRS_o_ai
vec_cmpgt(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_cmpgt_8_VBlVdVd");

vector bool long long __ATTRS_o_ai
vec_cmplt(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_cmplt_8_VBlVdVd");

vector bool long long __ATTRS_o_ai
vec_cmpgt(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_cmpgt_8_VBlVSlVSl");

vector bool long long __ATTRS_o_ai
vec_cmpgt(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_cmpgt_8_VBlVUlVUl");

vector bool long long __ATTRS_o_ai
vec_cmplt(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_cmplt_8_VBlVSlVSl");

vector bool long long __ATTRS_o_ai
vec_cmplt(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_cmplt_8_VBlVUlVUl");

signed int __ATTRS_o_ai
vec_all_eq(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_all_eq_8_iVdVd");

signed int __ATTRS_o_ai
vec_all_eq(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_all_eq_8_iVSlVSl");

signed int __ATTRS_o_ai
vec_all_eq(vector signed long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_all_eq_8_iVSlVBl");

signed int __ATTRS_o_ai
vec_all_eq(vector bool long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_all_eq_8_iVBlVSl");

signed int __ATTRS_o_ai
vec_all_eq(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_all_eq_8_iVUlVUl");

signed int __ATTRS_o_ai
vec_all_eq(vector unsigned long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_all_eq_8_iVUlVBl");

signed int __ATTRS_o_ai
vec_all_eq(vector bool long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_all_eq_8_iVBlVUl");

signed int __ATTRS_o_ai
vec_all_eq(vector bool long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_all_eq_8_iVBlVBl");

signed int __ATTRS_o_ai
vec_all_ne(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_all_ne_8_iVdVd");

signed int __ATTRS_o_ai
vec_all_ne(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_all_ne_8_iVSlVSl");

signed int __ATTRS_o_ai
vec_all_ne(vector signed long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_all_ne_8_iVSlVBl");

signed int __ATTRS_o_ai
vec_all_ne(vector bool long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_all_ne_8_iVBlVSl");

signed int __ATTRS_o_ai
vec_all_ne(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_all_ne_8_iVUlVUl");

signed int __ATTRS_o_ai
vec_all_ne(vector unsigned long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_all_ne_8_iVUlVBl");

signed int __ATTRS_o_ai
vec_all_ne(vector bool long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_all_ne_8_iVBlVUl");

signed int __ATTRS_o_ai
vec_all_ne(vector bool long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_all_ne_8_iVBlVBl");

signed int __ATTRS_o_ai
vec_all_gt(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_all_gt_8_iVdVd");

signed int __ATTRS_o_ai
vec_all_lt(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_all_lt_8_iVdVd");

signed int __ATTRS_o_ai
vec_all_gt(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_all_gt_8_iVSlVSl");

signed int __ATTRS_o_ai
vec_all_gt(vector signed long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_all_gt_8_iVSlVBl");

signed int __ATTRS_o_ai
vec_all_gt(vector bool long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_all_gt_8_iVBlVSl");

signed int __ATTRS_o_ai
vec_all_lt(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_all_lt_8_iVSlVSl");

signed int __ATTRS_o_ai
vec_all_lt(vector signed long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_all_lt_8_iVSlVBl");

signed int __ATTRS_o_ai
vec_all_lt(vector bool long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_all_lt_8_iVBlVSl");

signed int __ATTRS_o_ai
vec_all_gt(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_all_gt_8_iVUlVUl");

signed int __ATTRS_o_ai
vec_all_gt(vector unsigned long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_all_gt_8_iVUlVBl");

signed int __ATTRS_o_ai
vec_all_gt(vector bool long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_all_gt_8_iVBlVUl");

signed int __ATTRS_o_ai
vec_all_lt(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_all_lt_8_iVUlVUl");

signed int __ATTRS_o_ai
vec_all_lt(vector unsigned long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_all_lt_8_iVUlVBl");

signed int __ATTRS_o_ai
vec_all_lt(vector bool long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_all_lt_8_iVBlVUl");

signed int __ATTRS_o_ai
vec_all_ge(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_all_ge_8_iVdVd");

signed int __ATTRS_o_ai
vec_all_le(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_all_le_8_iVdVd");

signed int __ATTRS_o_ai
vec_all_ge(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_all_ge_8_iVSlVSl");

signed int __ATTRS_o_ai
vec_all_ge(vector signed long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_all_ge_8_iVSlVBl");

signed int __ATTRS_o_ai
vec_all_ge(vector bool long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_all_ge_8_iVBlVSl");

signed int __ATTRS_o_ai
vec_all_le(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_all_le_8_iVSlVSl");

signed int __ATTRS_o_ai
vec_all_le(vector signed long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_all_le_8_iVSlVBl");

signed int __ATTRS_o_ai
vec_all_le(vector bool long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_all_le_8_iVBlVSl");

signed int __ATTRS_o_ai
vec_all_ge(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_all_ge_8_iVUlVUl");

signed int __ATTRS_o_ai
vec_all_ge(vector unsigned long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_all_ge_8_iVUlVBl");

signed int __ATTRS_o_ai
vec_all_ge(vector bool long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_all_ge_8_iVBlVUl");

signed int __ATTRS_o_ai
vec_all_le(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_all_le_8_iVUlVUl");

signed int __ATTRS_o_ai
vec_all_le(vector unsigned long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_all_le_8_iVUlVBl");

signed int __ATTRS_o_ai
vec_all_le(vector bool long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_all_le_8_iVBlVUl");

signed int __ATTRS_o_ai
vec_any_eq(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_any_eq_8_iVdVd");

signed int __ATTRS_o_ai
vec_any_eq(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_any_eq_8_iVSlVSl");

signed int __ATTRS_o_ai
vec_any_eq(vector signed long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_any_eq_8_iVSlVBl");

signed int __ATTRS_o_ai
vec_any_eq(vector bool long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_any_eq_8_iVBlVSl");

signed int __ATTRS_o_ai
vec_any_eq(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_any_eq_8_iVUlVUl");

signed int __ATTRS_o_ai
vec_any_eq(vector unsigned long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_any_eq_8_iVUlVBl");

signed int __ATTRS_o_ai
vec_any_eq(vector bool long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_any_eq_8_iVBlVUl");

signed int __ATTRS_o_ai
vec_any_eq(vector bool long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_any_eq_8_iVBlVBl");

signed int __ATTRS_o_ai
vec_any_ne(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_any_ne_8_iVdVd");

signed int __ATTRS_o_ai
vec_any_ne(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_any_ne_8_iVSlVSl");

signed int __ATTRS_o_ai
vec_any_ne(vector signed long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_any_ne_8_iVSlVBl");

signed int __ATTRS_o_ai
vec_any_ne(vector bool long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_any_ne_8_iVBlVSl");

signed int __ATTRS_o_ai
vec_any_ne(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_any_ne_8_iVUlVUl");

signed int __ATTRS_o_ai
vec_any_ne(vector unsigned long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_any_ne_8_iVUlVBl");

signed int __ATTRS_o_ai
vec_any_ne(vector bool long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_any_ne_8_iVBlVUl");

signed int __ATTRS_o_ai
vec_any_ne(vector bool long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_any_ne_8_iVBlVBl");

signed int __ATTRS_o_ai
vec_any_gt(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_any_gt_8_iVdVd");

signed int __ATTRS_o_ai
vec_any_lt(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_any_lt_8_iVdVd");

signed int __ATTRS_o_ai
vec_any_gt(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_any_gt_8_iVSlVSl");

signed int __ATTRS_o_ai
vec_any_gt(vector signed long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_any_gt_8_iVSlVBl");

signed int __ATTRS_o_ai
vec_any_gt(vector bool long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_any_gt_8_iVBlVSl");

signed int __ATTRS_o_ai
vec_any_lt(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_any_lt_8_iVSlVSl");

signed int __ATTRS_o_ai
vec_any_lt(vector signed long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_any_lt_8_iVSlVBl");

signed int __ATTRS_o_ai
vec_any_lt(vector bool long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_any_lt_8_iVBlVSl");

signed int __ATTRS_o_ai
vec_any_gt(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_any_gt_8_iVUlVUl");

signed int __ATTRS_o_ai
vec_any_gt(vector unsigned long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_any_gt_8_iVUlVBl");

signed int __ATTRS_o_ai
vec_any_gt(vector bool long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_any_gt_8_iVBlVUl");

signed int __ATTRS_o_ai
vec_any_lt(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_any_lt_8_iVUlVUl");

signed int __ATTRS_o_ai
vec_any_lt(vector unsigned long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_any_lt_8_iVUlVBl");

signed int __ATTRS_o_ai
vec_any_lt(vector bool long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_any_lt_8_iVBlVUl");

signed int __ATTRS_o_ai
vec_any_ge(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_any_ge_8_iVdVd");

signed int __ATTRS_o_ai
vec_any_le(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_any_le_8_iVdVd");

signed int __ATTRS_o_ai
vec_any_ge(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_any_ge_8_iVSlVSl");

signed int __ATTRS_o_ai
vec_any_ge(vector signed long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_any_ge_8_iVSlVBl");

signed int __ATTRS_o_ai
vec_any_ge(vector bool long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_any_ge_8_iVBlVSl");

signed int __ATTRS_o_ai
vec_any_le(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_any_le_8_iVSlVSl");

signed int __ATTRS_o_ai
vec_any_le(vector signed long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_any_le_8_iVSlVBl");

signed int __ATTRS_o_ai
vec_any_le(vector bool long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_any_le_8_iVBlVSl");

signed int __ATTRS_o_ai
vec_any_ge(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_any_ge_8_iVUlVUl");

signed int __ATTRS_o_ai
vec_any_ge(vector unsigned long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_any_ge_8_iVUlVBl");

signed int __ATTRS_o_ai
vec_any_ge(vector bool long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_any_ge_8_iVBlVUl");

signed int __ATTRS_o_ai
vec_any_le(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_any_le_8_iVUlVUl");

signed int __ATTRS_o_ai
vec_any_le(vector unsigned long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_any_le_8_iVUlVBl");

signed int __ATTRS_o_ai
vec_any_le(vector bool long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_any_le_8_iVBlVUl");

vector signed long long __ATTRS_o_ai
vec_ctsl(vector double __a, signed int __b) __asm__("__IBMBuiltin_vec_ctsl_VSlVdi");

vector unsigned long long __ATTRS_o_ai
vec_ctul(vector double __a, signed int __b) __asm__("__IBMBuiltin_vec_ctul_VUlVdi");

vector double __ATTRS_o_ai
vec_ctd(vector signed long long __a, signed int __b) __asm__("__IBMBuiltin_vec_ctd_VdVSli");

vector double __ATTRS_o_ai
vec_ctd(vector unsigned long long __a, signed int __b) __asm__("__IBMBuiltin_vec_ctd_VdVUli");

vector double __ATTRS_o_ai
vec_msub(vector double __a, vector double __b, vector double __c) __asm__("__IBMBuiltin_vec_msub_VdVdVdVd");

vector double __ATTRS_o_ai
vec_andc(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_andc_8_VdVdVd");

vector double __ATTRS_o_ai
vec_andc(vector double __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_andc_8_VdVdVBl");

vector double __ATTRS_o_ai
vec_andc(vector bool long long __a, vector double __b) __asm__("__IBMBuiltin_vec_andc_8_VdVBlVd");

vector unsigned long long __ATTRS_o_ai
vec_andc(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_andc_8_VUlVUlVUl");

vector unsigned long long __ATTRS_o_ai
vec_andc(vector unsigned long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_andc_8_VUlVUlVBl");

vector unsigned long long __ATTRS_o_ai
vec_andc(vector bool long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_andc_8_VUlVBlVUl");

vector bool long long __ATTRS_o_ai
vec_andc(vector bool long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_andc_8_VBlVBlVBl");

vector signed long long __ATTRS_o_ai
vec_andc(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_andc_8_VSlVSlVSl");

vector signed long long __ATTRS_o_ai
vec_andc(vector signed long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_andc_8_VSlVSlVBl");

vector signed long long __ATTRS_o_ai
vec_andc(vector bool long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_andc_8_VSlVBlVSl");

vector double __ATTRS_o_ai
vec_nor(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_nor_8_VdVdVd");

vector unsigned long long __ATTRS_o_ai
vec_nor(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_nor_8_VUlVUlVUl");

vector bool long long __ATTRS_o_ai
vec_nor(vector bool long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_nor_8_VBlVBlVBl");

vector signed long long __ATTRS_o_ai
vec_nor(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_nor_8_VSlVSlVSl");

vector unsigned long long __ATTRS_o_ai
vec_mergeh(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_mergeh_8_VUlVUlVUl");

vector signed long long __ATTRS_o_ai
vec_mergeh(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_mergeh_8_VSlVSlVSl");

vector bool long long __ATTRS_o_ai
vec_mergeh(vector bool long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_mergeh_8_VBlVBlVBl");

vector double __ATTRS_o_ai
vec_mergeh(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_mergeh_8_VdVdVd");

vector unsigned long long __ATTRS_o_ai
vec_mergel(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_mergel_8_VUlVUlVUl");

vector signed long long __ATTRS_o_ai
vec_mergel(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_mergel_8_VSlVSlVSl");

vector bool long long __ATTRS_o_ai
vec_mergel(vector bool long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_mergel_8_VBlVBlVBl");

vector double __ATTRS_o_ai
vec_mergel(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_mergel_8_VdVdVd");

vector unsigned long long __ATTRS_o_ai
vec_permi(vector unsigned long long __a, vector unsigned long long __b, signed int __c) __asm__("__IBMBuiltin_vec_permi_VUlVUlVUli");

vector signed long long __ATTRS_o_ai
vec_permi(vector signed long long __a, vector signed long long __b, signed int __c) __asm__("__IBMBuiltin_vec_permi_VSlVSlVSli");

vector bool long long __ATTRS_o_ai
vec_permi(vector bool long long __a, vector bool long long __b, signed int __c) __asm__("__IBMBuiltin_vec_permi_VBlVBlVBli");

vector double __ATTRS_o_ai
vec_permi(vector double __a, vector double __b, signed int __c) __asm__("__IBMBuiltin_vec_permi_VdVdVdi");

vector double __ATTRS_o_ai
vec_sel(vector double __a, vector double __b, vector bool long long __c) __asm__("__IBMBuiltin_vec_sel_8_VdVdVdVBl");

vector double __ATTRS_o_ai
vec_sel(vector double __a, vector double __b, vector unsigned long long __c) __asm__("__IBMBuiltin_vec_sel_8_VdVdVdVUl");

vector bool long long __ATTRS_o_ai
vec_sel(vector bool long long __a, vector bool long long __b, vector bool long long __c) __asm__("__IBMBuiltin_vec_sel_8_VBlVBlVBlVBl");

vector bool long long __ATTRS_o_ai
vec_sel(vector bool long long __a, vector bool long long __b, vector unsigned long long __c) __asm__("__IBMBuiltin_vec_sel_8_VBlVBlVBlVUl");

vector unsigned long long __ATTRS_o_ai
vec_sel(vector unsigned long long __a, vector unsigned long long __b, vector bool long long __c) __asm__("__IBMBuiltin_vec_sel_8_VUlVUlVUlVBl");

vector unsigned long long __ATTRS_o_ai
vec_sel(vector unsigned long long __a, vector unsigned long long __b, vector unsigned long long __c) __asm__("__IBMBuiltin_vec_sel_8_VUlVUlVUlVUl");

vector signed long long __ATTRS_o_ai
vec_sel(vector signed long long __a, vector signed long long __b, vector bool long long __c) __asm__("__IBMBuiltin_vec_sel_8_VSlVSlVSlVBl");

vector signed long long __ATTRS_o_ai
vec_sel(vector signed long long __a, vector signed long long __b, vector unsigned long long __c) __asm__("__IBMBuiltin_vec_sel_8_VSlVSlVSlVUl");

vector unsigned char __ATTRS_o_ai
vec_sldw(vector unsigned char __a, vector unsigned char __b, signed int __c) __asm__("__IBMBuiltin_vec_sldw_VUcVUcVUci");

vector signed char __ATTRS_o_ai
vec_sldw(vector signed char __a, vector signed char __b, signed int __c) __asm__("__IBMBuiltin_vec_sldw_VScVScVSci");

vector unsigned short __ATTRS_o_ai
vec_sldw(vector unsigned short __a, vector unsigned short __b, signed int __c) __asm__("__IBMBuiltin_vec_sldw_VUsVUsVUsi");

vector signed short __ATTRS_o_ai
vec_sldw(vector signed short __a, vector signed short __b, signed int __c) __asm__("__IBMBuiltin_vec_sldw_VSsVSsVSsi");

vector unsigned int __ATTRS_o_ai
vec_sldw(vector unsigned int __a, vector unsigned int __b, signed int __c) __asm__("__IBMBuiltin_vec_sldw_VUiVUiVUii");

vector signed int __ATTRS_o_ai
vec_sldw(vector signed int __a, vector signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_sldw_VSiVSiVSii");

vector signed char __ATTRS_o_ai
vec_xld2(signed long __a, signed char * __b) __asm__("__IBMBuiltin_vec_xld2_VSclcA");

vector unsigned char __ATTRS_o_ai
vec_xld2(signed long __a, unsigned char * __b) __asm__("__IBMBuiltin_vec_xld2_VUclcA");

vector signed short __ATTRS_o_ai
vec_xld2(signed long __a, signed short * __b) __asm__("__IBMBuiltin_vec_xld2_VSslsA");

vector unsigned short __ATTRS_o_ai
vec_xld2(signed long __a, unsigned short * __b) __asm__("__IBMBuiltin_vec_xld2_VUslsA");

vector signed int __ATTRS_o_ai
vec_xld2(signed long __a, signed int * __b) __asm__("__IBMBuiltin_vec_xld2_VSiliA");

vector unsigned int __ATTRS_o_ai
vec_xld2(signed long __a, unsigned int * __b) __asm__("__IBMBuiltin_vec_xld2_VUiliA");

vector signed char __ATTRS_o_ai
vec_xlw4(signed long __a, signed char * __b) __asm__("__IBMBuiltin_vec_xlw4_VSclcA");

vector unsigned char __ATTRS_o_ai
vec_xlw4(signed long __a, unsigned char * __b) __asm__("__IBMBuiltin_vec_xlw4_VUclcA");

vector signed short __ATTRS_o_ai
vec_xlw4(signed long __a, signed short * __b) __asm__("__IBMBuiltin_vec_xlw4_VSslsA");

vector unsigned short __ATTRS_o_ai
vec_xlw4(signed long __a, unsigned short * __b) __asm__("__IBMBuiltin_vec_xlw4_VUslsA");

vector unsigned int __ATTRS_o_ai
vec_xlw4(signed long __a, unsigned int * __b) __asm__("__IBMBuiltin_vec_xlw4_VUiliA");

vector signed int __ATTRS_o_ai
vec_xlw4(signed long __a, signed int * __b) __asm__("__IBMBuiltin_vec_xlw4_VSiliA");

void __ATTRS_o_ai
vec_xstd2(vector signed char __a, signed long __b, signed char * __c) __asm__("__IBMBuiltin_vec_xstd2_vVSclcA");

void __ATTRS_o_ai
vec_xstd2(vector unsigned char __a, signed long __b, unsigned char * __c) __asm__("__IBMBuiltin_vec_xstd2_vVUclcA");

void __ATTRS_o_ai
vec_xstd2(vector signed short __a, signed long __b, signed short * __c) __asm__("__IBMBuiltin_vec_xstd2_vVSslsA");

void __ATTRS_o_ai
vec_xstd2(vector unsigned short __a, signed long __b, unsigned short * __c) __asm__("__IBMBuiltin_vec_xstd2_vVUslsA");

void __ATTRS_o_ai
vec_xstd2(vector signed int __a, signed long __b, signed int * __c) __asm__("__IBMBuiltin_vec_xstd2_vVSiliA");

void __ATTRS_o_ai
vec_xstd2(vector unsigned int __a, signed long __b, unsigned int * __c) __asm__("__IBMBuiltin_vec_xstd2_vVUiliA");

void __ATTRS_o_ai
vec_xstw4(vector signed char __a, signed long __b, signed char * __c) __asm__("__IBMBuiltin_vec_xstw4_vVSclcA");

void __ATTRS_o_ai
vec_xstw4(vector unsigned char __a, signed long __b, unsigned char * __c) __asm__("__IBMBuiltin_vec_xstw4_vVUclcA");

void __ATTRS_o_ai
vec_xstw4(vector signed short __a, signed long __b, signed short * __c) __asm__("__IBMBuiltin_vec_xstw4_vVSslsA");

void __ATTRS_o_ai
vec_xstw4(vector unsigned short __a, signed long __b, unsigned short * __c) __asm__("__IBMBuiltin_vec_xstw4_vVUslsA");

void __ATTRS_o_ai
vec_xstw4(vector unsigned int __a, signed long __b, unsigned int * __c) __asm__("__IBMBuiltin_vec_xstw4_vVUiliA");

void __ATTRS_o_ai
vec_xstw4(vector signed int __a, signed long __b, signed int * __c) __asm__("__IBMBuiltin_vec_xstw4_vVSiliA");

vector unsigned int __ATTRS_o_ai
vec_cntlz(vector unsigned int __a) __asm__("__IBMBuiltin_vec_cntlz_VUiVUi");

vector unsigned short __ATTRS_o_ai
vec_cntlz(vector unsigned short __a) __asm__("__IBMBuiltin_vec_cntlz_VUsVUs");

vector unsigned char __ATTRS_o_ai
vec_cntlz(vector unsigned char __a) __asm__("__IBMBuiltin_vec_cntlz_VUcVUc");

vector signed int __ATTRS_o_ai
vec_cntlz(vector signed int __a) __asm__("__IBMBuiltin_vec_cntlz_VSiVSi");

vector signed short __ATTRS_o_ai
vec_cntlz(vector signed short __a) __asm__("__IBMBuiltin_vec_cntlz_VSsVSs");

vector signed char __ATTRS_o_ai
vec_cntlz(vector signed char __a) __asm__("__IBMBuiltin_vec_cntlz_VScVSc");

vector unsigned int __ATTRS_o_ai
vec_popcnt(vector unsigned int __a) __asm__("__IBMBuiltin_vec_popcnt_VUiVUi");

vector unsigned short __ATTRS_o_ai
vec_popcnt(vector unsigned short __a) __asm__("__IBMBuiltin_vec_popcnt_VUsVUs");

vector unsigned char __ATTRS_o_ai
vec_popcnt(vector unsigned char __a) __asm__("__IBMBuiltin_vec_popcnt_VUcVUc");

vector unsigned int __ATTRS_o_ai
vec_popcnt(vector signed int __a) __asm__("__IBMBuiltin_vec_popcnt_VUiVSi");

vector unsigned short __ATTRS_o_ai
vec_popcnt(vector signed short __a) __asm__("__IBMBuiltin_vec_popcnt_VUsVSs");

vector unsigned char __ATTRS_o_ai
vec_popcnt(vector signed char __a) __asm__("__IBMBuiltin_vec_popcnt_VUcVSc");

vector unsigned int __ATTRS_o_ai
vec_pack(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_pack_8_VUiVUlVUl");

vector signed int __ATTRS_o_ai
vec_pack(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_pack_8_VSiVSlVSl");

vector bool int __ATTRS_o_ai
vec_pack(vector bool long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_pack_8_VBiVBlVBl");

vector unsigned int __ATTRS_o_ai
vec_packs(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_packs_8_VUiVUlVUl");

vector unsigned int __ATTRS_o_ai
vec_packsu(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_packsu_8_VUiVSlVSl");

vector unsigned int __ATTRS_o_ai
vec_packsu(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_packsu_8_VUiVUlVUl");

vector signed int __ATTRS_o_ai
vec_packs(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_packs_8_VSiVSlVSl");

vector unsigned long long __ATTRS_o_ai
vec_rl(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_rl_8_VUlVUlVUl");

vector signed long long __ATTRS_o_ai
vec_rl(vector signed long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_rl_8_VSlVSlVUl");

vector unsigned char __attribute__((__always_inline__))
vec_add_u128(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_add_u128_VUcVUcVUc");

vector unsigned char __attribute__((__always_inline__))
vec_adde_u128(vector unsigned char __a, vector unsigned char __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_adde_u128_VUcVUcVUcVUc");

vector unsigned char __attribute__((__always_inline__))
vec_addc_u128(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_addc_u128_VUcVUcVUc");

vector unsigned char __attribute__((__always_inline__))
vec_addec_u128(vector unsigned char __a, vector unsigned char __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_addec_u128_VUcVUcVUcVUc");

vector unsigned char __attribute__((__always_inline__))
vec_sub_u128(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sub_u128_VUcVUcVUc");

vector unsigned char __attribute__((__always_inline__))
vec_sube_u128(vector unsigned char __a, vector unsigned char __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_sube_u128_VUcVUcVUcVUc");

vector unsigned char __attribute__((__always_inline__))
vec_subc_u128(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_subc_u128_VUcVUcVUc");

vector unsigned char __attribute__((__always_inline__))
vec_subec_u128(vector unsigned char __a, vector unsigned char __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_subec_u128_VUcVUcVUcVUc");




// LE Power specific vector builtins

vector float __ATTRS_o_ai
vec_recipdiv(vector float __a, vector float __b) __asm__("__IBMBuiltin___vec_recipdiv_VfVfVf");

vector float __ATTRS_o_ai
vec_nearbyint(vector float __a) __asm__("__IBMBuiltin___vec_nearbyint_VfVf");

vector float __ATTRS_o_ai
vec_rsqrt(vector float __a) __asm__("__IBMBuiltin___vec_rsqrt_VfVf");

vector float __ATTRS_o_ai
vec_abs(vector float __a) __asm__("__IBMBuiltin_vec_abs_VfVf");
// P9 vec_absd
vector unsigned char __ATTRS_o_ai
vec_absd(vector unsigned char, vector unsigned char) __asm__("__IBMBuiltin_vec_absd_VUcVUcVUc");

vector unsigned short __ATTRS_o_ai
vec_absd(vector unsigned short, vector unsigned short) __asm__("__IBMBuiltin_vec_absd_VUsVUsVUs");

vector unsigned int __ATTRS_o_ai
vec_absd(vector unsigned int, vector unsigned int) __asm__("__IBMBuiltin_vec_absd_VUiVUiVUi");
// P9 vec_absd end
vector signed char __ATTRS_o_ai
vec_abss(vector signed char __a) __asm__("__IBMBuiltin_vec_abss_VScVSc");

vector signed short __ATTRS_o_ai
vec_abss(vector signed short __a) __asm__("__IBMBuiltin_vec_abss_VSsVSs");

vector signed int __ATTRS_o_ai
vec_abss(vector signed int __a) __asm__("__IBMBuiltin_vec_abss_VSiVSi");

vector unsigned char __ATTRS_o_ai
vec_add(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_add_VUcVUcVUc");

vector unsigned char __ATTRS_o_ai
vec_add(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_add_VUcVUcVBc");

vector unsigned char __ATTRS_o_ai
vec_add(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_add_VUcVBcVUc");

vector signed char __ATTRS_o_ai
vec_add(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_add_VScVScVSc");

vector signed char __ATTRS_o_ai
vec_add(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_add_VScVScVBc");

vector signed char __ATTRS_o_ai
vec_add(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_add_VScVBcVSc");

vector unsigned char __ATTRS_o_ai
vec_vaddubm(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_add_VUcVUcVUc");

vector unsigned char __ATTRS_o_ai
vec_vaddubm(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_add_VUcVUcVBc");

vector unsigned char __ATTRS_o_ai
vec_vaddubm(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_add_VUcVBcVUc");

vector signed char __ATTRS_o_ai
vec_vaddubm(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_add_VScVScVSc");

vector signed char __ATTRS_o_ai
vec_vaddubm(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_add_VScVScVBc");

vector signed char __ATTRS_o_ai
vec_vaddubm(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_add_VScVBcVSc");

vector unsigned short __ATTRS_o_ai
vec_add(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_add_VUsVUsVUs");

vector unsigned short __ATTRS_o_ai
vec_add(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_add_VUsVUsVBs");

vector unsigned short __ATTRS_o_ai
vec_add(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_add_VUsVBsVUs");

vector signed short __ATTRS_o_ai
vec_add(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_add_VSsVSsVSs");

vector signed short __ATTRS_o_ai
vec_add(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_add_VSsVSsVBs");

vector signed short __ATTRS_o_ai
vec_add(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_add_VSsVBsVSs");

vector unsigned short __ATTRS_o_ai
vec_vadduhm(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_add_VUsVUsVUs");

vector unsigned short __ATTRS_o_ai
vec_vadduhm(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_add_VUsVUsVBs");

vector unsigned short __ATTRS_o_ai
vec_vadduhm(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_add_VUsVBsVUs");

vector signed short __ATTRS_o_ai
vec_vadduhm(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_add_VSsVSsVSs");

vector signed short __ATTRS_o_ai
vec_vadduhm(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_add_VSsVSsVBs");

vector signed short __ATTRS_o_ai
vec_vadduhm(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_add_VSsVBsVSs");

vector unsigned int __ATTRS_o_ai
vec_add(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_add_VUiVUiVUi");

vector unsigned int __ATTRS_o_ai
vec_add(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_add_VUiVUiVBi");

vector unsigned int __ATTRS_o_ai
vec_add(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_add_VUiVBiVUi");

vector signed int __ATTRS_o_ai
vec_add(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_add_VSiVSiVSi");

vector signed int __ATTRS_o_ai
vec_add(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_add_VSiVSiVBi");

vector signed int __ATTRS_o_ai
vec_add(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_add_VSiVBiVSi");

vector unsigned int __ATTRS_o_ai
vec_vadduwm(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_add_VUiVUiVUi");

vector unsigned int __ATTRS_o_ai
vec_vadduwm(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_add_VUiVUiVBi");

vector unsigned int __ATTRS_o_ai
vec_vadduwm(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_add_VUiVBiVUi");

vector signed int __ATTRS_o_ai
vec_vadduwm(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_add_VSiVSiVSi");

vector signed int __ATTRS_o_ai
vec_vadduwm(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_add_VSiVSiVBi");

vector signed int __ATTRS_o_ai
vec_vadduwm(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_add_VSiVBiVSi");

vector float __ATTRS_o_ai
vec_add(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_add_VfVfVf");

vector float __attribute__((__always_inline__))
vec_vaddfp(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_add_VfVfVf");

vector unsigned int __attribute__((__always_inline__))
vec_vaddcuw(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_addc_VUiVUiVUi");

vector unsigned char __ATTRS_o_ai
vec_adds(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_adds_VUcVUcVUc");

vector unsigned char __ATTRS_o_ai
vec_adds(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_adds_VUcVUcVBc");

vector unsigned char __ATTRS_o_ai
vec_adds(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_adds_VUcVBcVUc");

vector unsigned char __ATTRS_o_ai
vec_vaddubs(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_adds_VUcVUcVUc");

vector unsigned char __ATTRS_o_ai
vec_vaddubs(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_adds_VUcVUcVBc");

vector unsigned char __ATTRS_o_ai
vec_vaddubs(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_adds_VUcVBcVUc");

vector signed char __ATTRS_o_ai
vec_adds(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_adds_VScVScVSc");

vector signed char __ATTRS_o_ai
vec_adds(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_adds_VScVScVBc");

vector signed char __ATTRS_o_ai
vec_adds(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_adds_VScVBcVSc");

vector signed char __ATTRS_o_ai
vec_vaddsbs(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_adds_VScVScVSc");

vector signed char __ATTRS_o_ai
vec_vaddsbs(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_adds_VScVScVBc");

vector signed char __ATTRS_o_ai
vec_vaddsbs(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_adds_VScVBcVSc");

vector unsigned short __ATTRS_o_ai
vec_adds(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_adds_VUsVUsVUs");

vector unsigned short __ATTRS_o_ai
vec_adds(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_adds_VUsVUsVBs");

vector unsigned short __ATTRS_o_ai
vec_adds(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_adds_VUsVBsVUs");

vector unsigned short __ATTRS_o_ai
vec_vadduhs(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_adds_VUsVUsVUs");

vector unsigned short __ATTRS_o_ai
vec_vadduhs(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_adds_VUsVUsVBs");

vector unsigned short __ATTRS_o_ai
vec_vadduhs(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_adds_VUsVBsVUs");

vector signed short __ATTRS_o_ai
vec_adds(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_adds_VSsVSsVSs");

vector signed short __ATTRS_o_ai
vec_adds(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_adds_VSsVSsVBs");

vector signed short __ATTRS_o_ai
vec_adds(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_adds_VSsVBsVSs");

vector signed short __ATTRS_o_ai
vec_vaddshs(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_adds_VSsVSsVSs");

vector signed short __ATTRS_o_ai
vec_vaddshs(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_adds_VSsVSsVBs");

vector signed short __ATTRS_o_ai
vec_vaddshs(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_adds_VSsVBsVSs");

vector unsigned int __ATTRS_o_ai
vec_adds(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_adds_VUiVUiVUi");

vector unsigned int __ATTRS_o_ai
vec_adds(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_adds_VUiVUiVBi");

vector unsigned int __ATTRS_o_ai
vec_adds(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_adds_VUiVBiVUi");

vector unsigned int __ATTRS_o_ai
vec_vadduws(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_adds_VUiVUiVUi");

vector unsigned int __ATTRS_o_ai
vec_vadduws(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_adds_VUiVUiVBi");

vector unsigned int __ATTRS_o_ai
vec_vadduws(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_adds_VUiVBiVUi");

vector signed int __ATTRS_o_ai
vec_adds(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_adds_VSiVSiVSi");

vector signed int __ATTRS_o_ai
vec_adds(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_adds_VSiVSiVBi");

vector signed int __ATTRS_o_ai
vec_adds(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_adds_VSiVBiVSi");

vector signed int __ATTRS_o_ai
vec_vaddsws(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_adds_VSiVSiVSi");

vector signed int __ATTRS_o_ai
vec_vaddsws(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_adds_VSiVSiVBi");

vector signed int __ATTRS_o_ai
vec_vaddsws(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_adds_VSiVBiVSi");

vector unsigned char __ATTRS_o_ai
vec_and(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_and_VUcVUcVUc");

vector unsigned char __ATTRS_o_ai
vec_and(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_and_VUcVUcVBc");

vector unsigned char __ATTRS_o_ai
vec_and(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_and_VUcVBcVUc");

vector signed char __ATTRS_o_ai
vec_and(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_and_VScVScVSc");

vector signed char __ATTRS_o_ai
vec_and(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_and_VScVScVBc");

vector signed char __ATTRS_o_ai
vec_and(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_and_VScVBcVSc");

vector bool char __ATTRS_o_ai
vec_and(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_and_VBcVBcVBc");

vector unsigned short __ATTRS_o_ai
vec_and(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_and_VUsVUsVUs");

vector unsigned short __ATTRS_o_ai
vec_and(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_and_VUsVUsVBs");

vector unsigned short __ATTRS_o_ai
vec_and(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_and_VUsVBsVUs");

vector signed short __ATTRS_o_ai
vec_and(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_and_VSsVSsVSs");

vector signed short __ATTRS_o_ai
vec_and(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_and_VSsVSsVBs");

vector signed short __ATTRS_o_ai
vec_and(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_and_VSsVBsVSs");

vector bool short __ATTRS_o_ai
vec_and(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_and_VBsVBsVBs");

vector unsigned int __ATTRS_o_ai
vec_and(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_and_VUiVUiVUi");

vector unsigned int __ATTRS_o_ai
vec_and(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_and_VUiVUiVBi");

vector unsigned int __ATTRS_o_ai
vec_and(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_and_VUiVBiVUi");

vector signed int __ATTRS_o_ai
vec_and(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_and_VSiVSiVSi");

vector signed int __ATTRS_o_ai
vec_and(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_and_VSiVSiVBi");

vector signed int __ATTRS_o_ai
vec_and(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_and_VSiVBiVSi");

vector bool int __ATTRS_o_ai
vec_and(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_and_VBiVBiVBi");

vector float __ATTRS_o_ai
vec_and(vector bool int __a, vector float __b) __asm__("__IBMBuiltin_vec_and_VfVBiVf");

vector float __ATTRS_o_ai
vec_and(vector float __a, vector bool int __b) __asm__("__IBMBuiltin_vec_and_VfVfVBi");

vector float __ATTRS_o_ai
vec_and(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_and_VfVfVf");

vector unsigned char __ATTRS_o_ai
vec_vand(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_and_VUcVUcVUc");

vector unsigned char __ATTRS_o_ai
vec_vand(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_and_VUcVUcVBc");

vector unsigned char __ATTRS_o_ai
vec_vand(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_and_VUcVBcVUc");

vector signed char __ATTRS_o_ai
vec_vand(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_and_VScVScVSc");

vector signed char __ATTRS_o_ai
vec_vand(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_and_VScVScVBc");

vector signed char __ATTRS_o_ai
vec_vand(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_and_VScVBcVSc");

vector bool char __ATTRS_o_ai
vec_vand(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_and_VBcVBcVBc");

vector unsigned short __ATTRS_o_ai
vec_vand(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_and_VUsVUsVUs");

vector unsigned short __ATTRS_o_ai
vec_vand(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_and_VUsVUsVBs");

vector unsigned short __ATTRS_o_ai
vec_vand(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_and_VUsVBsVUs");

vector signed short __ATTRS_o_ai
vec_vand(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_and_VSsVSsVSs");

vector signed short __ATTRS_o_ai
vec_vand(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_and_VSsVSsVBs");

vector signed short __ATTRS_o_ai
vec_vand(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_and_VSsVBsVSs");

vector bool short __ATTRS_o_ai
vec_vand(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_and_VBsVBsVBs");

vector unsigned int __ATTRS_o_ai
vec_vand(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_and_VUiVUiVUi");

vector unsigned int __ATTRS_o_ai
vec_vand(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_and_VUiVUiVBi");

vector unsigned int __ATTRS_o_ai
vec_vand(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_and_VUiVBiVUi");

vector signed int __ATTRS_o_ai
vec_vand(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_and_VSiVSiVSi");

vector signed int __ATTRS_o_ai
vec_vand(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_and_VSiVSiVBi");

vector signed int __ATTRS_o_ai
vec_vand(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_and_VSiVBiVSi");

vector bool int __ATTRS_o_ai
vec_vand(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_and_VBiVBiVBi");

vector float __ATTRS_o_ai
vec_vand(vector bool int __a, vector float __b) __asm__("__IBMBuiltin_vec_and_VfVBiVf");

vector float __ATTRS_o_ai
vec_vand(vector float __a, vector bool int __b) __asm__("__IBMBuiltin_vec_and_VfVfVBi");

vector float __ATTRS_o_ai
vec_vand(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_and_VfVfVf");

vector float __ATTRS_o_ai
vec_andc(vector bool int __a, vector float __b) __asm__("__IBMBuiltin_vec_andc_VfVBiVf");

vector float __ATTRS_o_ai
vec_andc(vector float __a, vector bool int __b) __asm__("__IBMBuiltin_vec_andc_VfVfVBi");

vector float __ATTRS_o_ai
vec_andc(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_andc_VfVfVf");

vector unsigned char __ATTRS_o_ai
vec_vandc(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_andc_VUcVUcVUc");

vector unsigned char __ATTRS_o_ai
vec_vandc(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_andc_VUcVUcVBc");

vector unsigned char __ATTRS_o_ai
vec_vandc(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_andc_VUcVBcVUc");

vector signed char __ATTRS_o_ai
vec_vandc(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_andc_VScVScVSc");

vector signed char __ATTRS_o_ai
vec_vandc(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_andc_VScVScVBc");

vector signed char __ATTRS_o_ai
vec_vandc(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_andc_VScVBcVSc");

vector bool char __ATTRS_o_ai
vec_vandc(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_andc_VBcVBcVBc");

vector unsigned short __ATTRS_o_ai
vec_vandc(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_andc_VUsVUsVUs");

vector unsigned short __ATTRS_o_ai
vec_vandc(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_andc_VUsVUsVBs");

vector unsigned short __ATTRS_o_ai
vec_vandc(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_andc_VUsVBsVUs");

vector signed short __ATTRS_o_ai
vec_vandc(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_andc_VSsVSsVSs");

vector signed short __ATTRS_o_ai
vec_vandc(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_andc_VSsVSsVBs");

vector signed short __ATTRS_o_ai
vec_vandc(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_andc_VSsVBsVSs");

vector bool short __ATTRS_o_ai
vec_vandc(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_andc_VBsVBsVBs");

vector unsigned int __ATTRS_o_ai
vec_vandc(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_andc_VUiVUiVUi");

vector unsigned int __ATTRS_o_ai
vec_vandc(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_andc_VUiVUiVBi");

vector unsigned int __ATTRS_o_ai
vec_vandc(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_andc_VUiVBiVUi");

vector signed int __ATTRS_o_ai
vec_vandc(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_andc_VSiVSiVSi");

vector signed int __ATTRS_o_ai
vec_vandc(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_andc_VSiVSiVBi");

vector signed int __ATTRS_o_ai
vec_vandc(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_andc_VSiVBiVSi");

vector bool int __ATTRS_o_ai
vec_vandc(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_andc_VBiVBiVBi");

vector float __ATTRS_o_ai
vec_vandc(vector bool int __a, vector float __b) __asm__("__IBMBuiltin_vec_andc_VfVBiVf");

vector float __ATTRS_o_ai
vec_vandc(vector float __a, vector bool int __b) __asm__("__IBMBuiltin_vec_andc_VfVfVBi");

vector float __ATTRS_o_ai
vec_vandc(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_andc_VfVfVf");

vector unsigned char __attribute__((__always_inline__))
vec_vavgub(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_avg_VUcVUcVUc");

vector signed char __attribute__((__always_inline__))
vec_vavgsb(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_avg_VScVScVSc");

vector unsigned short __attribute__((__always_inline__))
vec_vavguh(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_avg_VUsVUsVUs");

vector signed short __attribute__((__always_inline__))
vec_vavgsh(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_avg_VSsVSsVSs");

vector unsigned int __attribute__((__always_inline__))
vec_vavguw(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_avg_VUiVUiVUi");

vector signed int __attribute__((__always_inline__))
vec_vavgsw(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_avg_VSiVSiVSi");

vector float __ATTRS_o_ai
vec_ceil(vector float __a) __asm__("__IBMBuiltin_vec_ceil_VfVf");

vector float __attribute__((__always_inline__))
vec_vrfip(vector float __a) __asm__("__IBMBuiltin_vec_ceil_VfVf");

vector signed int __attribute__((__always_inline__))
vec_cmpb(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_cmpb_VSiVfVf");

vector signed int __attribute__((__always_inline__))
vec_vcmpbfp(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_cmpb_VSiVfVf");

vector bool int __ATTRS_o_ai
vec_cmpeq(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_cmpeq_VBiVfVf");

vector bool char __ATTRS_o_ai
vec_vcmpequb(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_cmpeq_VBcVUcVUc");

vector bool char __ATTRS_o_ai
vec_vcmpequb(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_cmpeq_VBcVScVSc");

vector bool short __ATTRS_o_ai
vec_vcmpequh(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_cmpeq_VBsVUsVUs");

vector bool short __ATTRS_o_ai
vec_vcmpequh(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_cmpeq_VBsVSsVSs");

vector bool int __ATTRS_o_ai
vec_vcmpequw(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_cmpeq_VBiVUiVUi");

vector bool int __ATTRS_o_ai
vec_vcmpequw(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_cmpeq_VBiVSiVSi");

vector bool int __attribute__((__always_inline__))
vec_vcmpeqfp(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_cmpeq_VBiVfVf");

vector bool int __ATTRS_o_ai
vec_cmpge(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_cmpge_VBiVfVf");

vector bool int __attribute__((__always_inline__))
vec_vcmpgefp(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_cmpge_VBiVfVf");

vector bool int __ATTRS_o_ai
vec_cmpgt(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_cmpgt_VBiVfVf");

vector bool char __attribute__((__always_inline__))
vec_vcmpgtub(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_cmpgt_VBcVUcVUc");

vector bool char __attribute__((__always_inline__))
vec_vcmpgtsb(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_cmpgt_VBcVScVSc");

vector bool short __attribute__((__always_inline__))
vec_vcmpgtuh(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_cmpgt_VBsVUsVUs");

vector bool short __attribute__((__always_inline__))
vec_vcmpgtsh(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_cmpgt_VBsVSsVSs");

vector bool int __attribute__((__always_inline__))
vec_vcmpgtuw(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_cmpgt_VBiVUiVUi");

vector bool int __attribute__((__always_inline__))
vec_vcmpgtsw(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_cmpgt_VBiVSiVSi");

vector bool int __attribute__((__always_inline__))
vec_vcmpgtfp(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_cmpgt_VBiVfVf");

vector bool int __ATTRS_o_ai
vec_cmple(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_cmple_VBiVfVf");

vector bool int __ATTRS_o_ai
vec_cmplt(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_cmplt_VBiVfVf");

// P9 vec_cmpne
vector bool char __ATTRS_o_ai
vec_cmpne (vector signed char, vector signed char) __asm__ ("__IBMBuiltin_vec_cmpne_VBcVScVSc");

vector bool char __ATTRS_o_ai
vec_cmpne (vector unsigned char, vector unsigned char) __asm__ ("__IBMBuiltin_vec_cmpne_VBcVUcVUc");

vector bool short __ATTRS_o_ai
vec_cmpne (vector signed short, vector signed short) __asm__ ("__IBMBuiltin_vec_cmpne_VBsVSsVSs");

vector bool short __ATTRS_o_ai
vec_cmpne (vector unsigned short, vector unsigned short) __asm__ ("__IBMBuiltin_vec_cmpne_VBsVUsVUs");

vector bool int __ATTRS_o_ai
vec_cmpne (vector signed int, vector signed int) __asm__ ("__IBMBuiltin_vec_cmpne_VBiVSiVSi");

vector bool int __ATTRS_o_ai
vec_cmpne (vector unsigned int, vector unsigned int) __asm__ ("__IBMBuiltin_vec_cmpne_VBiVUiVUi");
// P9 vec_cmpne end
// P9 vec_cmpnez
vector bool char __ATTRS_o_ai
vec_cmpnez (vector signed char, vector signed char) __asm__ ("__IBMBuiltin_vec_cmpnez_VBcVScVSc");

vector bool char __ATTRS_o_ai
vec_cmpnez (vector unsigned char, vector unsigned char) __asm__ ("__IBMBuiltin_vec_cmpnez_VBcVUcVUc");

vector bool short __ATTRS_o_ai
vec_cmpnez (vector signed short, vector signed short) __asm__ ("__IBMBuiltin_vec_cmpnez_VBsVSsVSs");

vector bool short __ATTRS_o_ai
vec_cmpnez (vector unsigned short, vector unsigned short) __asm__ ("__IBMBuiltin_vec_cmpnez_VBsVUsVUs");

vector bool int __ATTRS_o_ai
vec_cmpnez (vector signed int, vector signed int) __asm__ ("__IBMBuiltin_vec_cmpnez_VBiVSiVSi");

vector bool int __ATTRS_o_ai
vec_cmpnez (vector unsigned int, vector unsigned int) __asm__ ("__IBMBuiltin_vec_cmpnez_VBiVUiVUi");
// P9 vec_cmpnez end
// P9 vec_cntlz_lsbb
signed int __ATTRS_o_ai
vec_cntlz_lsbb (vector signed char) __asm__ ("__IBMBuiltin_vec_cntlz_lsbb_SiVSc");

signed int __ATTRS_o_ai
vec_cntlz_lsbb (vector unsigned char) __asm__ ("__IBMBuiltin_vec_cntlz_lsbb_SiVUc");
// P9 vec_cntlz_lsbb end
// P9 vec_cnttz_lsbb
signed int __ATTRS_o_ai
vec_cnttz_lsbb (vector signed char) __asm__ ("__IBMBuiltin_vec_cnttz_lsbb_SiVSc");

signed int __ATTRS_o_ai
vec_cnttz_lsbb (vector unsigned char) __asm__ ("__IBMBuiltin_vec_cnttz_lsbb_SiVUc");
// P9 vec_cnttz_lsbb end
// P9 vec_cnttz
vector signed char __ATTRS_o_ai
vec_cnttz (vector signed char) __asm__ ("__IBMBuiltin_vec_cnttz_VScVSc");

vector unsigned char __ATTRS_o_ai
vec_cnttz (vector unsigned char) __asm__ ("__IBMBuiltin_vec_cnttz_VUcVUc");

vector signed short __ATTRS_o_ai
vec_cnttz (vector signed short) __asm__ ("__IBMBuiltin_vec_cnttz_VSsVSs");

vector unsigned short __ATTRS_o_ai
vec_cnttz (vector unsigned short) __asm__ ("__IBMBuiltin_vec_cnttz_VUsVUs");

vector signed int __ATTRS_o_ai
vec_cnttz (vector signed int) __asm__ ("__IBMBuiltin_vec_cnttz_VSiVSi");

vector unsigned int __ATTRS_o_ai
vec_cnttz (vector unsigned int) __asm__ ("__IBMBuiltin_vec_cnttz_VUiVUi");

vector signed long long __ATTRS_o_ai
vec_cnttz (vector signed long long) __asm__ ("__IBMBuiltin_vec_cnttz_VSllVSll");

vector unsigned long long __ATTRS_o_ai
vec_cnttz (vector unsigned long long) __asm__ ("__IBMBuiltin_vec_cnttz_VUllVUll");
// P9 vec_cnttz end

vector float __ATTRS_o_ai
vec_ctf(vector unsigned int __a, signed int __b) __asm__("__IBMBuiltin_vec_ctf_VfVUii");

vector float __ATTRS_o_ai
vec_ctf(vector signed int __a, signed int __b) __asm__("__IBMBuiltin_vec_ctf_VfVSii");

vector float __attribute__((__always_inline__))
vec_vcfux(vector unsigned int __a, signed int __b) __asm__("__IBMBuiltin_vec_ctf_VfVUii");

vector float __attribute__((__always_inline__))
vec_vcfsx(vector signed int __a, signed int __b) __asm__("__IBMBuiltin_vec_ctf_VfVSii");

vector signed int __ATTRS_o_ai
vec_cts(vector float __a, signed int __b) __asm__("__IBMBuiltin_vec_cts_VSiVfi");

vector signed int __attribute__((__always_inline__))
vec_vctsxs(vector float __a, signed int __b) __asm__("__IBMBuiltin_vec_cts_VSiVfi");

vector unsigned int __ATTRS_o_ai
vec_ctu(vector float __a, signed int __b) __asm__("__IBMBuiltin_vec_ctu_VUiVfi");

vector unsigned int __attribute__((__always_inline__))
vec_vctuxs(vector float __a, signed int __b) __asm__("__IBMBuiltin_vec_ctu_VUiVfi");

void __attribute__((__always_inline__))
vec_dss(signed int __a) __asm__("__IBMBuiltin_vec_dss_vi");

void __attribute__((__always_inline__))
vec_dssall() __asm__("__IBMBuiltin_vec_dssall_v");

void __ATTRS_o_ai
vec_dst(const vector unsigned char * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dst_vVUcACii");

void __ATTRS_o_ai
vec_dst(const vector signed char * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dst_vVScACii");

void __ATTRS_o_ai
vec_dst(const vector bool char * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dst_vVBcACii");

void __ATTRS_o_ai
vec_dst(const vector unsigned short * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dst_vVUsACii");

void __ATTRS_o_ai
vec_dst(const vector signed short * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dst_vVSsACii");

void __ATTRS_o_ai
vec_dst(const vector bool short * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dst_vVBsACii");

void __ATTRS_o_ai
vec_dst(const vector pixel * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dst_vVpACii");

void __ATTRS_o_ai
vec_dst(const vector unsigned int * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dst_vVUiACii");

void __ATTRS_o_ai
vec_dst(const vector signed int * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dst_vVSiACii");

void __ATTRS_o_ai
vec_dst(const vector bool int * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dst_vVBiACii");

void __ATTRS_o_ai
vec_dst(const vector float * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dst_vVfACii");

void __ATTRS_o_ai
vec_dst(const unsigned char * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dst_vcACii");

void __ATTRS_o_ai
vec_dst(const signed char * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dst_vcACii");

void __ATTRS_o_ai
vec_dst(const unsigned short * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dst_vsACii");

void __ATTRS_o_ai
vec_dst(const signed short * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dst_vsACii");

void __ATTRS_o_ai
vec_dst(const unsigned int * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dst_viACii");

void __ATTRS_o_ai
vec_dst(const unsigned long * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dst_vlACii");

void __ATTRS_o_ai
vec_dst(const signed int * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dst_viACii");

void __ATTRS_o_ai
vec_dst(const signed long * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dst_vlACii");

void __ATTRS_o_ai
vec_dst(const float * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dst_vfACii");

void __ATTRS_o_ai
vec_dstst(const vector unsigned char * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstst_vVUcACii");

void __ATTRS_o_ai
vec_dstst(const vector signed char * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstst_vVScACii");

void __ATTRS_o_ai
vec_dstst(const vector bool char * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstst_vVBcACii");

void __ATTRS_o_ai
vec_dstst(const vector unsigned short * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstst_vVUsACii");

void __ATTRS_o_ai
vec_dstst(const vector signed short * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstst_vVSsACii");

void __ATTRS_o_ai
vec_dstst(const vector bool short * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstst_vVBsACii");

void __ATTRS_o_ai
vec_dstst(const vector pixel * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstst_vVpACii");

void __ATTRS_o_ai
vec_dstst(const vector unsigned int * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstst_vVUiACii");

void __ATTRS_o_ai
vec_dstst(const vector signed int * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstst_vVSiACii");

void __ATTRS_o_ai
vec_dstst(const vector bool int * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstst_vVBiACii");

void __ATTRS_o_ai
vec_dstst(const vector float * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstst_vVfACii");

void __ATTRS_o_ai
vec_dstst(const unsigned char * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstst_vcACii");

void __ATTRS_o_ai
vec_dstst(const signed char * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstst_vcACii");

void __ATTRS_o_ai
vec_dstst(const unsigned short * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstst_vsACii");

void __ATTRS_o_ai
vec_dstst(const signed short * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstst_vsACii");

void __ATTRS_o_ai
vec_dstst(const unsigned int * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstst_viACii");

void __ATTRS_o_ai
vec_dstst(const signed int * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstst_viACii");

void __ATTRS_o_ai
vec_dstst(const float * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstst_vfACii");

void __ATTRS_o_ai
vec_dststt(const vector unsigned char * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dststt_vVUcACii");

void __ATTRS_o_ai
vec_dststt(const vector signed char * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dststt_vVScACii");

void __ATTRS_o_ai
vec_dststt(const vector bool char * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dststt_vVBcACii");

void __ATTRS_o_ai
vec_dststt(const vector unsigned short * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dststt_vVUsACii");

void __ATTRS_o_ai
vec_dststt(const vector signed short * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dststt_vVSsACii");

void __ATTRS_o_ai
vec_dststt(const vector bool short * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dststt_vVBsACii");

void __ATTRS_o_ai
vec_dststt(const vector pixel * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dststt_vVpACii");

void __ATTRS_o_ai
vec_dststt(const vector unsigned int * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dststt_vVUiACii");

void __ATTRS_o_ai
vec_dststt(const vector signed int * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dststt_vVSiACii");

void __ATTRS_o_ai
vec_dststt(const vector bool int * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dststt_vVBiACii");

void __ATTRS_o_ai
vec_dststt(const vector float * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dststt_vVfACii");

void __ATTRS_o_ai
vec_dststt(const unsigned char * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dststt_vcACii");

void __ATTRS_o_ai
vec_dststt(const signed char * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dststt_vcACii");

void __ATTRS_o_ai
vec_dststt(const unsigned short * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dststt_vsACii");

void __ATTRS_o_ai
vec_dststt(const signed short * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dststt_vsACii");

void __ATTRS_o_ai
vec_dststt(const unsigned int * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dststt_viACii");

void __ATTRS_o_ai
vec_dststt(const signed int * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dststt_viACii");

void __ATTRS_o_ai
vec_dststt(const float * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dststt_vfACii");

void __ATTRS_o_ai
vec_dstt(const vector unsigned char * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstt_vVUcACii");

void __ATTRS_o_ai
vec_dstt(const vector signed char * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstt_vVScACii");

void __ATTRS_o_ai
vec_dstt(const vector bool char * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstt_vVBcACii");

void __ATTRS_o_ai
vec_dstt(const vector unsigned short * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstt_vVUsACii");

void __ATTRS_o_ai
vec_dstt(const vector signed short * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstt_vVSsACii");

void __ATTRS_o_ai
vec_dstt(const vector bool short * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstt_vVBsACii");

void __ATTRS_o_ai
vec_dstt(const vector pixel * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstt_vVpACii");

void __ATTRS_o_ai
vec_dstt(const vector unsigned int * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstt_vVUiACii");

void __ATTRS_o_ai
vec_dstt(const vector signed int * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstt_vVSiACii");

void __ATTRS_o_ai
vec_dstt(const vector bool int * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstt_vVBiACii");

void __ATTRS_o_ai
vec_dstt(const vector float * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstt_vVfACii");

void __ATTRS_o_ai
vec_dstt(const unsigned char * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstt_vcACii");

void __ATTRS_o_ai
vec_dstt(const signed char * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstt_vcACii");

void __ATTRS_o_ai
vec_dstt(const unsigned short * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstt_vsACii");

void __ATTRS_o_ai
vec_dstt(const signed short * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstt_vsACii");

void __ATTRS_o_ai
vec_dstt(const unsigned int * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstt_viACii");

void __ATTRS_o_ai
vec_dstt(const signed int * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstt_viACii");

void __ATTRS_o_ai
vec_dstt(const unsigned long * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstt_vlACii");

void __ATTRS_o_ai
vec_dstt(const signed long * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstt_vlACii");

void __ATTRS_o_ai
vec_dstt(const float * __a, signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_dstt_vfACii");

vector float __attribute__((__always_inline__))
vec_expte(vector float __a) __asm__("__IBMBuiltin_vec_expte_VfVf");
// P9 vec_extract_exp
vector unsigned long long __ATTRS_o_ai
vec_extract_exp(vector double) __asm__ ("__IBMBuiltin_vec_extract_exp_VUllVd");

vector unsigned int __ATTRS_o_ai
vec_extract_exp(vector float) __asm__ ("__IBMBuiltin_vec_extract_exp_VUiVf");
// P9 vec_extract_exp end
// P9 vec_extract_sig
vector unsigned long long __ATTRS_o_ai
vec_extract_sig(vector double) __asm__ ("__IBMBuiltin_vec_extract_sig_VUllVd");

vector unsigned int __ATTRS_o_ai
vec_extract_sig(vector float) __asm__ ("__IBMBuiltin_vec_extract_sig_VUiVf");
// P9 vec_extract_sig end
vector float __attribute__((__always_inline__))
vec_vexptefp(vector float __a) __asm__("__IBMBuiltin_vec_expte_VfVf");

vector float __ATTRS_o_ai
vec_floor(vector float __a) __asm__("__IBMBuiltin_vec_floor_VfVf");

vector float __attribute__((__always_inline__))
vec_vrfim(vector float __a) __asm__("__IBMBuiltin_vec_floor_VfVf");
// P9 vec_first_match_index
unsigned int __ATTRS_o_ai
vec_first_match_index (vector signed char, vector signed char) __asm__("__IBMBuiltin_vec_first_match_index_UiVScVSc");

unsigned int __ATTRS_o_ai
vec_first_match_index (vector unsigned char, vector unsigned char) __asm__("__IBMBuiltin_vec_first_match_index_UiVUcVUc");

unsigned int __ATTRS_o_ai
vec_first_match_index (vector signed short, vector signed short) __asm__("__IBMBuiltin_vec_first_match_index_UiVSsVSs");

unsigned int __ATTRS_o_ai
vec_first_match_index (vector unsigned short, vector unsigned short) __asm__("__IBMBuiltin_vec_first_match_index_UiVUsVUs");

unsigned int __ATTRS_o_ai
vec_first_match_index (vector signed int, vector signed int) __asm__ ("__IBMBuiltin_vec_first_match_index_UiVSiVSi");

unsigned int __ATTRS_o_ai
vec_first_match_index (vector unsigned int, vector unsigned int) __asm__ ("__IBMBuiltin_vec_first_match_index_UiVUiVUi");

// P9 vec_first_mismatch_index
unsigned int __ATTRS_o_ai
vec_first_mismatch_index (vector signed char, vector signed char) __asm__ ("__IBMBuiltin_vec_first_mismatch_index_UiVScVSc");

unsigned int __ATTRS_o_ai
vec_first_mismatch_index (vector unsigned char, vector unsigned char) __asm__ ("__IBMBuiltin_vec_first_mismatch_index_UiVUcVUc");

unsigned int __ATTRS_o_ai
vec_first_mismatch_index (vector signed short, vector signed short) __asm__ ("__IBMBuiltin_vec_first_mismatch_index_UiVSsVSs");

unsigned int __ATTRS_o_ai
vec_first_mismatch_index (vector unsigned short, vector unsigned short) __asm__ ("__IBMBuiltin_vec_first_mismatch_index_UiVUsVUs");

unsigned int __ATTRS_o_ai
vec_first_mismatch_index (vector signed int, vector signed int) __asm__ ("__IBMBuiltin_vec_first_mismatch_index_UiVSiVSi");

unsigned int __ATTRS_o_ai
vec_first_mismatch_index (vector unsigned int, vector unsigned int) __asm__ ("__IBMBuiltin_vec_first_mismatch_index_UiVUiVUi");

// P9 vec_first_match_or_eos_index
unsigned int __ATTRS_o_ai
vec_first_match_or_eos_index (vector signed char, vector signed char) __asm__ ("__IBMBuiltin_vec_first_match_or_eos_index_UiVScVSc");

unsigned int __ATTRS_o_ai
vec_first_match_or_eos_index (vector unsigned char, vector unsigned char) __asm__ ("__IBMBuiltin_vec_first_match_or_eos_index_UiVUcVUc");

unsigned int __ATTRS_o_ai
vec_first_match_or_eos_index (vector signed short, vector signed short) __asm__ ("__IBMBuiltin_vec_first_match_or_eos_index_UiVSsVSs");

unsigned int __ATTRS_o_ai
vec_first_match_or_eos_index (vector unsigned short, vector unsigned short) __asm__ ("__IBMBuiltin_vec_first_match_or_eos_index_UiVUsVUs");

unsigned int __ATTRS_o_ai
vec_first_match_or_eos_index (vector signed int, vector signed int) __asm__ ("__IBMBuiltin_vec_first_match_or_eos_index_UiVSiVSi");

unsigned int __ATTRS_o_ai
vec_first_match_or_eos_index (vector unsigned int, vector unsigned int) __asm__ ("__IBMBuiltin_vec_first_match_or_eos_index_UiVUiVUi");

// P9 vec_first_mismatch_or_eos_index
unsigned int __ATTRS_o_ai
vec_first_mismatch_or_eos_index (vector signed char, vector signed char) __asm__ ("__IBMBuiltin_vec_first_mismatch_or_eos_index_UiVScVSc");

unsigned int __ATTRS_o_ai
vec_first_mismatch_or_eos_index (vector unsigned char, vector unsigned char) __asm__ ("__IBMBuiltin_vec_first_mismatch_or_eos_index_UiVUcVUc");

unsigned int __ATTRS_o_ai
vec_first_mismatch_or_eos_index (vector signed short, vector signed short) __asm__ ("__IBMBuiltin_vec_first_mismatch_or_eos_index_UiVSsVSs");

unsigned int __ATTRS_o_ai
vec_first_mismatch_or_eos_index (vector unsigned short, vector unsigned short) __asm__ ("__IBMBuiltin_vec_first_mismatch_or_eos_index_UiVUsVUs");

unsigned int __ATTRS_o_ai
vec_first_mismatch_or_eos_index (vector signed int, vector signed int) __asm__ ("__IBMBuiltin_vec_first_mismatch_or_eos_index_UiVSiVSi");

unsigned int __ATTRS_o_ai
vec_first_mismatch_or_eos_index (vector unsigned int, vector unsigned int) __asm__ ("__IBMBuiltin_vec_first_mismatch_or_eos_index_UiVUiVUi");

// P9 vec_insert_exp
vector double __ATTRS_o_ai
vec_insert_exp(vector double, vector unsigned long long) __asm__("__IBMBuiltin_vec_insert_exp_VdVdVUll");

vector double __ATTRS_o_ai
vec_insert_exp(vector unsigned long long, vector unsigned long long) __asm__("__IBMBuiltin_vec_insert_exp_VdVUllVUll");

vector float __ATTRS_o_ai
vec_insert_exp(vector float, vector unsigned int) __asm__("__IBMBuiltin_vec_insert_exp_VfVfVUi");

vector float __ATTRS_o_ai
vec_insert_exp(vector unsigned int, vector unsigned int) __asm__("__IBMBuiltin_vec_insert_exp_VfVUiVUi");
// P9 vec_insert end
vector unsigned char __ATTRS_o_ai
vec_ld(signed int __a, const vector unsigned char * __b) __asm__("__IBMBuiltin_vec_ld_VUciVUcAC");

vector unsigned char __ATTRS_o_ai
vec_ld(signed int __a, const unsigned char * __b) __asm__("__IBMBuiltin_vec_ld_VUcicAC");

vector signed char __ATTRS_o_ai
vec_ld(signed int __a, const vector signed char * __b) __asm__("__IBMBuiltin_vec_ld_VSciVScAC");

vector signed char __ATTRS_o_ai
vec_ld(signed int __a, const signed char * __b) __asm__("__IBMBuiltin_vec_ld_VScicAC");

vector bool char __ATTRS_o_ai
vec_ld(signed int __a, const vector bool char * __b) __asm__("__IBMBuiltin_vec_ld_VBciVBcAC");

vector unsigned short __ATTRS_o_ai
vec_ld(signed int __a, const vector unsigned short * __b) __asm__("__IBMBuiltin_vec_ld_VUsiVUsAC");

vector unsigned short __ATTRS_o_ai
vec_ld(signed int __a, const unsigned short * __b) __asm__("__IBMBuiltin_vec_ld_VUsisAC");

vector signed short __ATTRS_o_ai
vec_ld(signed int __a, const vector signed short * __b) __asm__("__IBMBuiltin_vec_ld_VSsiVSsAC");

vector signed short __ATTRS_o_ai
vec_ld(signed int __a, const signed short * __b) __asm__("__IBMBuiltin_vec_ld_VSsisAC");

vector bool short __ATTRS_o_ai
vec_ld(signed int __a, const vector bool short * __b) __asm__("__IBMBuiltin_vec_ld_VBsiVBsAC");

vector pixel __ATTRS_o_ai
vec_ld(signed int __a, const vector pixel * __b) __asm__("__IBMBuiltin_vec_ld_VpiVpAC");

vector unsigned int __ATTRS_o_ai
vec_ld(signed int __a, const vector unsigned int * __b) __asm__("__IBMBuiltin_vec_ld_VUiiVUiAC");

vector unsigned int __ATTRS_o_ai
vec_ld(signed int __a, const unsigned int * __b) __asm__("__IBMBuiltin_vec_ld_VUiiiAC");

vector signed int __ATTRS_o_ai
vec_ld(signed int __a, const vector signed int * __b) __asm__("__IBMBuiltin_vec_ld_VSiiVSiAC");

vector signed int __ATTRS_o_ai
vec_ld(signed int __a, const signed int * __b) __asm__("__IBMBuiltin_vec_ld_VSiiiAC");

vector bool int __ATTRS_o_ai
vec_ld(signed int __a, const vector bool int * __b) __asm__("__IBMBuiltin_vec_ld_VBiiVBiAC");

vector float __ATTRS_o_ai
vec_ld(signed int __a, const vector float * __b) __asm__("__IBMBuiltin_vec_ld_VfiVfAC");

vector float __ATTRS_o_ai
vec_ld(signed int __a, const float * __b) __asm__("__IBMBuiltin_vec_ld_VfifAC");

vector unsigned char __ATTRS_o_ai
vec_lde(signed int __a, const unsigned char * __b) __asm__("__IBMBuiltin_vec_lde_b_VUcicAC");

vector signed char __ATTRS_o_ai
vec_lde(signed int __a, const signed char * __b) __asm__("__IBMBuiltin_vec_lde_b_VScicAC");

vector unsigned short __ATTRS_o_ai
vec_lde(signed int __a, const unsigned short * __b) __asm__("__IBMBuiltin_vec_lde_h_VUsisAC");

vector signed short __ATTRS_o_ai
vec_lde(signed int __a, const signed short * __b) __asm__("__IBMBuiltin_vec_lde_h_VSsisAC");

vector unsigned int __ATTRS_o_ai
vec_lde(signed int __a, const unsigned int * __b) __asm__("__IBMBuiltin_vec_lde_w_VUiiiAC");

vector signed int __ATTRS_o_ai
vec_lde(signed int __a, const signed int * __b) __asm__("__IBMBuiltin_vec_lde_w_VSiiiAC");

vector float __ATTRS_o_ai
vec_lde(signed int __a, const float * __b) __asm__("__IBMBuiltin_vec_lde_w_VfifAC");

vector unsigned char __ATTRS_o_ai
vec_lvebx(signed int __a, const unsigned char * __b) __asm__("__IBMBuiltin_vec_lde_b_VUcicAC");

vector signed char __ATTRS_o_ai
vec_lvebx(signed int __a, const signed char * __b) __asm__("__IBMBuiltin_vec_lde_b_VScicAC");

vector unsigned short __ATTRS_o_ai
vec_lvehx(signed int __a, const unsigned short * __b) __asm__("__IBMBuiltin_vec_lde_h_VUsisAC");

vector signed short __ATTRS_o_ai
vec_lvehx(signed int __a, const signed short * __b) __asm__("__IBMBuiltin_vec_lde_h_VSsisAC");

vector unsigned int __ATTRS_o_ai
vec_lvewx(signed int __a, const unsigned int * __b) __asm__("__IBMBuiltin_vec_lde_w_VUiiiAC");

vector signed int __ATTRS_o_ai
vec_lvewx(signed int __a, const signed int * __b) __asm__("__IBMBuiltin_vec_lde_w_VSiiiAC");

vector float __ATTRS_o_ai
vec_lvewx(signed int __a, const float * __b) __asm__("__IBMBuiltin_vec_lde_w_VfifAC");

vector unsigned char __ATTRS_o_ai
vec_ldl(signed int __a, const vector unsigned char * __b) __asm__("__IBMBuiltin_vec_ldl_VUciVUcAC");

vector unsigned char __ATTRS_o_ai
vec_ldl(signed int __a, const unsigned char * __b) __asm__("__IBMBuiltin_vec_ldl_VUcicAC");

vector signed char __ATTRS_o_ai
vec_ldl(signed int __a, const vector signed char * __b) __asm__("__IBMBuiltin_vec_ldl_VSciVScAC");

vector signed char __ATTRS_o_ai
vec_ldl(signed int __a, const signed char * __b) __asm__("__IBMBuiltin_vec_ldl_VScicAC");

vector bool char __ATTRS_o_ai
vec_ldl(signed int __a, const vector bool char * __b) __asm__("__IBMBuiltin_vec_ldl_VBciVBcAC");

vector unsigned short __ATTRS_o_ai
vec_ldl(signed int __a, const vector unsigned short * __b) __asm__("__IBMBuiltin_vec_ldl_VUsiVUsAC");

vector unsigned short __ATTRS_o_ai
vec_ldl(signed int __a, const unsigned short * __b) __asm__("__IBMBuiltin_vec_ldl_VUsisAC");

vector signed short __ATTRS_o_ai
vec_ldl(signed int __a, const vector signed short * __b) __asm__("__IBMBuiltin_vec_ldl_VSsiVSsAC");

vector signed short __ATTRS_o_ai
vec_ldl(signed int __a, const signed short * __b) __asm__("__IBMBuiltin_vec_ldl_VSsisAC");

vector bool short __ATTRS_o_ai
vec_ldl(signed int __a, const vector bool short * __b) __asm__("__IBMBuiltin_vec_ldl_VBsiVBsAC");

vector pixel __ATTRS_o_ai
vec_ldl(signed int __a, const vector pixel * __b) __asm__("__IBMBuiltin_vec_ldl_VpiVpAC");

vector unsigned int __ATTRS_o_ai
vec_ldl(signed int __a, const vector unsigned int * __b) __asm__("__IBMBuiltin_vec_ldl_VUiiVUiAC");

vector unsigned int __ATTRS_o_ai
vec_ldl(signed int __a, const unsigned int * __b) __asm__("__IBMBuiltin_vec_ldl_VUiiiAC");

vector signed int __ATTRS_o_ai
vec_ldl(signed int __a, const vector signed int * __b) __asm__("__IBMBuiltin_vec_ldl_VSiiVSiAC");

vector signed int __ATTRS_o_ai
vec_ldl(signed int __a, const signed int * __b) __asm__("__IBMBuiltin_vec_ldl_VSiiiAC");

vector bool int __ATTRS_o_ai
vec_ldl(signed int __a, const vector bool int * __b) __asm__("__IBMBuiltin_vec_ldl_VBiiVBiAC");

vector float __ATTRS_o_ai
vec_ldl(signed int __a, const vector float * __b) __asm__("__IBMBuiltin_vec_ldl_VfiVfAC");

vector float __ATTRS_o_ai
vec_ldl(signed int __a, const float * __b) __asm__("__IBMBuiltin_vec_ldl_VfifAC");

vector unsigned char __ATTRS_o_ai
vec_lvxl(signed int __a, const vector unsigned char * __b) __asm__("__IBMBuiltin_vec_ldl_VUciVUcAC");

vector unsigned char __ATTRS_o_ai
vec_lvxl(signed int __a, const unsigned char * __b) __asm__("__IBMBuiltin_vec_ldl_VUcicAC");

vector signed char __ATTRS_o_ai
vec_lvxl(signed int __a, const vector signed char * __b) __asm__("__IBMBuiltin_vec_ldl_VSciVScAC");

vector signed char __ATTRS_o_ai
vec_lvxl(signed int __a, const signed char * __b) __asm__("__IBMBuiltin_vec_ldl_VScicAC");

vector bool char __ATTRS_o_ai
vec_lvxl(signed int __a, const vector bool char * __b) __asm__("__IBMBuiltin_vec_ldl_VBciVBcAC");

vector unsigned short __ATTRS_o_ai
vec_lvxl(signed int __a, const vector unsigned short * __b) __asm__("__IBMBuiltin_vec_ldl_VUsiVUsAC");

vector unsigned short __ATTRS_o_ai
vec_lvxl(signed int __a, const unsigned short * __b) __asm__("__IBMBuiltin_vec_ldl_VUsisAC");

vector signed short __ATTRS_o_ai
vec_lvxl(signed int __a, const vector signed short * __b) __asm__("__IBMBuiltin_vec_ldl_VSsiVSsAC");

vector signed short __ATTRS_o_ai
vec_lvxl(signed int __a, const signed short * __b) __asm__("__IBMBuiltin_vec_ldl_VSsisAC");

vector bool short __ATTRS_o_ai
vec_lvxl(signed int __a, const vector bool short * __b) __asm__("__IBMBuiltin_vec_ldl_VBsiVBsAC");

vector pixel __ATTRS_o_ai
vec_lvxl(signed int __a, const vector pixel * __b) __asm__("__IBMBuiltin_vec_ldl_VpiVpAC");

vector unsigned int __ATTRS_o_ai
vec_lvxl(signed int __a, const vector unsigned int * __b) __asm__("__IBMBuiltin_vec_ldl_VUiiVUiAC");

vector unsigned int __ATTRS_o_ai
vec_lvxl(signed int __a, const unsigned int * __b) __asm__("__IBMBuiltin_vec_ldl_VUiiiAC");

vector signed int __ATTRS_o_ai
vec_lvxl(signed int __a, const vector signed int * __b) __asm__("__IBMBuiltin_vec_ldl_VSiiVSiAC");

vector signed int __ATTRS_o_ai
vec_lvxl(signed int __a, const signed int * __b) __asm__("__IBMBuiltin_vec_ldl_VSiiiAC");

vector bool int __ATTRS_o_ai
vec_lvxl(signed int __a, const vector bool int * __b) __asm__("__IBMBuiltin_vec_ldl_VBiiVBiAC");

vector float __ATTRS_o_ai
vec_lvxl(signed int __a, const vector float * __b) __asm__("__IBMBuiltin_vec_ldl_VfiVfAC");

vector float __ATTRS_o_ai
vec_lvxl(signed int __a, const float * __b) __asm__("__IBMBuiltin_vec_ldl_VfifAC");

vector float __attribute__((__always_inline__))
vec_loge(vector float __a) __asm__("__IBMBuiltin_vec_loge_VfVf");

vector float __attribute__((__always_inline__))
vec_vlogefp(vector float __a) __asm__("__IBMBuiltin_vec_loge_VfVf");

vector unsigned char __ATTRS_o_ai
vec_lvsl(signed int __a, const unsigned char * __b) __asm__("__IBMBuiltin_vec_lvsl_VUcicAC");

vector unsigned char __ATTRS_o_ai
vec_lvsl(signed int __a, const signed char * __b) __asm__("__IBMBuiltin_vec_lvsl_VUcicAC");

vector unsigned char __ATTRS_o_ai
vec_lvsl(signed int __a, const unsigned short * __b) __asm__("__IBMBuiltin_vec_lvsl_VUcisAC");

vector unsigned char __ATTRS_o_ai
vec_lvsl(signed int __a, const signed short * __b) __asm__("__IBMBuiltin_vec_lvsl_VUcisAC");

vector unsigned char __ATTRS_o_ai
vec_lvsl(signed int __a, const unsigned int * __b) __asm__("__IBMBuiltin_vec_lvsl_VUciiAC");

vector unsigned char __ATTRS_o_ai
vec_lvsl(signed int __a, const signed int * __b) __asm__("__IBMBuiltin_vec_lvsl_VUciiAC");

vector unsigned char __ATTRS_o_ai
vec_lvsl(signed int __a, const unsigned long * __b) __asm__("__IBMBuiltin_vec_lvsl_VUcilAC");

vector unsigned char __ATTRS_o_ai
vec_lvsl(signed int __a, const signed long * __b) __asm__("__IBMBuiltin_vec_lvsl_VUcilAC");

vector unsigned char __ATTRS_o_ai
vec_lvsl(signed int __a, const float * __b) __asm__("__IBMBuiltin_vec_lvsl_VUcifAC");

vector unsigned char __ATTRS_o_ai
vec_lvsr(signed int __a, const unsigned char * __b) __asm__("__IBMBuiltin_vec_lvsr_VUcicAC");

vector unsigned char __ATTRS_o_ai
vec_lvsr(signed int __a, const signed char * __b) __asm__("__IBMBuiltin_vec_lvsr_VUcicAC");

vector unsigned char __ATTRS_o_ai
vec_lvsr(signed int __a, const unsigned short * __b) __asm__("__IBMBuiltin_vec_lvsr_VUcisAC");

vector unsigned char __ATTRS_o_ai
vec_lvsr(signed int __a, const signed short * __b) __asm__("__IBMBuiltin_vec_lvsr_VUcisAC");

vector unsigned char __ATTRS_o_ai
vec_lvsr(signed int __a, const unsigned int * __b) __asm__("__IBMBuiltin_vec_lvsr_VUciiAC");

vector unsigned char __ATTRS_o_ai
vec_lvsr(signed int __a, const signed int * __b) __asm__("__IBMBuiltin_vec_lvsr_VUciiAC");

vector unsigned char __ATTRS_o_ai
vec_lvsr(signed int __a, const unsigned long * __b) __asm__("__IBMBuiltin_vec_lvsr_VUcilAC");

vector unsigned char __ATTRS_o_ai
vec_lvsr(signed int __a, const signed long * __b) __asm__("__IBMBuiltin_vec_lvsr_VUcilAC");

vector unsigned char __ATTRS_o_ai
vec_lvsr(signed int __a, const float * __b) __asm__("__IBMBuiltin_vec_lvsr_VUcifAC");

vector float __ATTRS_o_ai
vec_madd(vector float __a, vector float __b, vector float __c) __asm__("__IBMBuiltin_vec_madd_VfVfVfVf");

vector float __attribute__((__always_inline__))
vec_vmaddfp(vector float __a, vector float __b, vector float __c) __asm__("__IBMBuiltin_vec_madd_VfVfVfVf");

vector signed short __attribute__((__always_inline__))
vec_madds(vector signed short __a, vector signed short __b, vector signed short __c) __asm__("__IBMBuiltin_vec_madds_VSsVSsVSsVSs");

vector signed short __attribute__((__always_inline__))
vec_vmhaddshs(vector signed short __a, vector signed short __b, vector signed short __c) __asm__("__IBMBuiltin_vec_madds_VSsVSsVSsVSs");

vector float __ATTRS_o_ai
vec_max(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_max_VfVfVf");

vector unsigned char __ATTRS_o_ai
vec_vmaxub(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_max_VUcVUcVUc");

vector unsigned char __ATTRS_o_ai
vec_vmaxub(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_max_VUcVUcVBc");

vector unsigned char __ATTRS_o_ai
vec_vmaxub(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_max_VUcVBcVUc");

vector signed char __ATTRS_o_ai
vec_vmaxsb(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_max_VScVScVSc");

vector signed char __ATTRS_o_ai
vec_vmaxsb(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_max_VScVScVBc");

vector signed char __ATTRS_o_ai
vec_vmaxsb(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_max_VScVBcVSc");

vector unsigned short __ATTRS_o_ai
vec_vmaxuh(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_max_VUsVUsVUs");

vector unsigned short __ATTRS_o_ai
vec_vmaxuh(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_max_VUsVUsVBs");

vector unsigned short __ATTRS_o_ai
vec_vmaxuh(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_max_VUsVBsVUs");

vector signed short __ATTRS_o_ai
vec_vmaxsh(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_max_VSsVSsVSs");

vector signed short __ATTRS_o_ai
vec_vmaxsh(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_max_VSsVSsVBs");

vector signed short __ATTRS_o_ai
vec_vmaxsh(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_max_VSsVBsVSs");

vector unsigned int __ATTRS_o_ai
vec_vmaxuw(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_max_VUiVUiVUi");

vector unsigned int __ATTRS_o_ai
vec_vmaxuw(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_max_VUiVUiVBi");

vector unsigned int __ATTRS_o_ai
vec_vmaxuw(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_max_VUiVBiVUi");

vector signed int __ATTRS_o_ai
vec_vmaxsw(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_max_VSiVSiVSi");

vector signed int __ATTRS_o_ai
vec_vmaxsw(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_max_VSiVSiVBi");

vector signed int __ATTRS_o_ai
vec_vmaxsw(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_max_VSiVBiVSi");

vector float __attribute__((__always_inline__))
vec_vmaxfp(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_max_VfVfVf");

vector pixel __ATTRS_o_ai
vec_mergeh(vector pixel __a, vector pixel __b) __asm__("__IBMBuiltin_vec_mergeh_VpVpVp");

vector float __ATTRS_o_ai
vec_mergeh(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_mergeh_VfVfVf");

vector unsigned char __ATTRS_o_ai
vec_vmrghb(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_mergeh_VUcVUcVUc");

vector signed char __ATTRS_o_ai
vec_vmrghb(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_mergeh_VScVScVSc");

vector bool char __ATTRS_o_ai
vec_vmrghb(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_mergeh_VBcVBcVBc");

vector unsigned short __ATTRS_o_ai
vec_vmrghh(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_mergeh_VUsVUsVUs");

vector signed short __ATTRS_o_ai
vec_vmrghh(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_mergeh_VSsVSsVSs");

vector bool short __ATTRS_o_ai
vec_vmrghh(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_mergeh_VBsVBsVBs");

vector pixel __ATTRS_o_ai
vec_vmrghh(vector pixel __a, vector pixel __b) __asm__("__IBMBuiltin_vec_mergeh_VpVpVp");

vector unsigned int __ATTRS_o_ai
vec_vmrghw(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_mergeh_VUiVUiVUi");

vector signed int __ATTRS_o_ai
vec_vmrghw(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_mergeh_VSiVSiVSi");

vector bool int __ATTRS_o_ai
vec_vmrghw(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_mergeh_VBiVBiVBi");

vector float __ATTRS_o_ai
vec_vmrghw(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_mergeh_VfVfVf");

vector pixel __ATTRS_o_ai
vec_mergel(vector pixel __a, vector pixel __b) __asm__("__IBMBuiltin_vec_mergel_VpVpVp");

vector float __ATTRS_o_ai
vec_mergel(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_mergel_VfVfVf");

vector unsigned char __ATTRS_o_ai
vec_vmrglb(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_mergel_VUcVUcVUc");

vector signed char __ATTRS_o_ai
vec_vmrglb(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_mergel_VScVScVSc");

vector bool char __ATTRS_o_ai
vec_vmrglb(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_mergel_VBcVBcVBc");

vector unsigned short __ATTRS_o_ai
vec_vmrglh(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_mergel_VUsVUsVUs");

vector signed short __ATTRS_o_ai
vec_vmrglh(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_mergel_VSsVSsVSs");

vector bool short __ATTRS_o_ai
vec_vmrglh(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_mergel_VBsVBsVBs");

vector pixel __ATTRS_o_ai
vec_vmrglh(vector pixel __a, vector pixel __b) __asm__("__IBMBuiltin_vec_mergel_VpVpVp");

vector unsigned int __ATTRS_o_ai
vec_vmrglw(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_mergel_VUiVUiVUi");

vector signed int __ATTRS_o_ai
vec_vmrglw(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_mergel_VSiVSiVSi");

vector bool int __ATTRS_o_ai
vec_vmrglw(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_mergel_VBiVBiVBi");

vector float __ATTRS_o_ai
vec_vmrglw(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_mergel_VfVfVf");

#if defined(__LITTLE_ENDIAN__)
vector unsigned char __ATTRS_o_ai
vec_mergeh_be(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_be_mergeh_VUcVUcVUc");

vector signed char __ATTRS_o_ai
vec_mergeh_be(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_be_mergeh_VScVScVSc");

vector bool char __ATTRS_o_ai
vec_mergeh_be(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_be_mergeh_VBcVBcVBc");

vector unsigned short __ATTRS_o_ai
vec_mergeh_be(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_be_mergeh_VUsVUsVUs");

vector signed short __ATTRS_o_ai
vec_mergeh_be(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_be_mergeh_VSsVSsVSs");

vector bool short __ATTRS_o_ai
vec_mergeh_be(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_be_mergeh_VBsVBsVBs");

vector unsigned int __ATTRS_o_ai
vec_mergeh_be(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_be_mergeh_VUiVUiVUi");

vector signed int __ATTRS_o_ai
vec_mergeh_be(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_be_mergeh_VSiVSiVSi");

vector bool int __ATTRS_o_ai
vec_mergeh_be(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_be_mergeh_VBiVBiVBi");

vector pixel __ATTRS_o_ai
vec_mergeh_be(vector pixel __a, vector pixel __b) __asm__("__IBMBuiltin_vec_be_mergeh_VpVpVp");

vector float __ATTRS_o_ai
vec_mergeh_be(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_be_mergeh_VfVfVf");

vector unsigned char __ATTRS_o_ai
vec_mergel_be(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_be_mergel_VUcVUcVUc");

vector signed char __ATTRS_o_ai
vec_mergel_be(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_be_mergel_VScVScVSc");

vector bool char __ATTRS_o_ai
vec_mergel_be(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_be_mergel_VBcVBcVBc");

vector unsigned short __ATTRS_o_ai
vec_mergel_be(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_be_mergel_VUsVUsVUs");

vector signed short __ATTRS_o_ai
vec_mergel_be(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_be_mergel_VSsVSsVSs");

vector bool short __ATTRS_o_ai
vec_mergel_be(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_be_mergel_VBsVBsVBs");

vector unsigned int __ATTRS_o_ai
vec_mergel_be(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_be_mergel_VUiVUiVUi");

vector signed int __ATTRS_o_ai
vec_mergel_be(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_be_mergel_VSiVSiVSi");

vector bool int __ATTRS_o_ai
vec_mergel_be(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_be_mergel_VBiVBiVBi");

vector pixel __ATTRS_o_ai
vec_mergel_be(vector pixel __a, vector pixel __b) __asm__("__IBMBuiltin_vec_be_mergel_VpVpVp");

vector float __ATTRS_o_ai
vec_mergel_be(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_be_mergel_VfVfVf");

vector unsigned long long __ATTRS_o_ai
vec_mergeh_be(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_be_mergeh_8_VUlVUlVUl");

vector signed long long __ATTRS_o_ai
vec_mergeh_be(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_be_mergeh_8_VSlVSlVSl");

vector bool long long __ATTRS_o_ai
vec_mergeh_be(vector bool long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_be_mergeh_8_VBlVBlVBl");

vector double __ATTRS_o_ai
vec_mergeh_be(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_be_mergeh_8_VdVdVd");

vector unsigned long long __ATTRS_o_ai
vec_mergel_be(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_be_mergel_8_VUlVUlVUl");

vector signed long long __ATTRS_o_ai
vec_mergel_be(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_be_mergel_8_VSlVSlVSl");

vector bool long long __ATTRS_o_ai
vec_mergel_be(vector bool long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_be_mergel_8_VBlVBlVBl");

vector double __ATTRS_o_ai
vec_mergel_be(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_be_mergel_8_VdVdVd");
// P9 vec_parity_lsbb
vector unsigned int __ATTRS_o_ai
vec_parity_lsbb (vector signed int) __asm__ ("__IBMBuiltin_vec_parity_lsbb_VUiVSi");

vector unsigned int __ATTRS_o_ai
vec_parity_lsbb (vector unsigned int) __asm__ ("__IBMBuiltin_vec_parity_lsbb_VUiVUi");

vector unsigned long long __ATTRS_o_ai
vec_parity_lsbb (vector signed long long) __asm__ ("__IBMBuiltin_vec_parity_lsbb_VUllVSll");

vector unsigned long long __ATTRS_o_ai
vec_parity_lsbb (vector unsigned long long) __asm__ ("__IBMBuiltin_vec_parity_lsbb_VUllVUll");
// P9 vec_parity_end
vector unsigned long long __ATTRS_o_ai
vec_permi_be(vector unsigned long long __a, vector unsigned long long __b, signed int __c) __asm__("__IBMBuiltin_vec_be_permi_VUlVUlVUli");

vector signed long long __ATTRS_o_ai
vec_permi_be(vector signed long long __a, vector signed long long __b, signed int __c) __asm__("__IBMBuiltin_vec_be_permi_VSlVSlVSli");

vector bool long long __ATTRS_o_ai
vec_permi_be(vector bool long long __a, vector bool long long __b, signed int __c) __asm__("__IBMBuiltin_vec_be_permi_VBlVBlVBli");

vector double __ATTRS_o_ai
vec_permi_be(vector double __a, vector double __b, signed int __c) __asm__("__IBMBuiltin_vec_be_permi_VdVdVdi");
#endif

vector unsigned short __attribute__((__always_inline__))
vec_mfvscr() __asm__("__IBMBuiltin_vec_mfvscr_VUs");

vector float __ATTRS_o_ai
vec_min(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_min_VfVfVf");

vector unsigned char __ATTRS_o_ai
vec_vminub(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_min_VUcVUcVUc");

vector unsigned char __ATTRS_o_ai
vec_vminub(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_min_VUcVUcVBc");

vector unsigned char __ATTRS_o_ai
vec_vminub(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_min_VUcVBcVUc");

vector signed char __ATTRS_o_ai
vec_vminsb(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_min_VScVScVSc");

vector signed char __ATTRS_o_ai
vec_vminsb(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_min_VScVScVBc");

vector signed char __ATTRS_o_ai
vec_vminsb(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_min_VScVBcVSc");

vector unsigned short __ATTRS_o_ai
vec_vminuh(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_min_VUsVUsVUs");

vector unsigned short __ATTRS_o_ai
vec_vminuh(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_min_VUsVUsVBs");

vector unsigned short __ATTRS_o_ai
vec_vminuh(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_min_VUsVBsVUs");

vector signed short __ATTRS_o_ai
vec_vminsh(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_min_VSsVSsVSs");

vector signed short __ATTRS_o_ai
vec_vminsh(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_min_VSsVSsVBs");

vector signed short __ATTRS_o_ai
vec_vminsh(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_min_VSsVBsVSs");

vector unsigned int __ATTRS_o_ai
vec_vminuw(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_min_VUiVUiVUi");

vector unsigned int __ATTRS_o_ai
vec_vminuw(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_min_VUiVUiVBi");

vector unsigned int __ATTRS_o_ai
vec_vminuw(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_min_VUiVBiVUi");

vector signed int __ATTRS_o_ai
vec_vminsw(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_min_VSiVSiVSi");

vector signed int __ATTRS_o_ai
vec_vminsw(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_min_VSiVSiVBi");

vector signed int __ATTRS_o_ai
vec_vminsw(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_min_VSiVBiVSi");

vector float __attribute__((__always_inline__))
vec_vminfp(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_min_VfVfVf");

vector unsigned short __ATTRS_o_ai
vec_vmladduhm(vector unsigned short __a, vector unsigned short __b, vector unsigned short __c) __asm__("__IBMBuiltin_vec_mladd_VUsVUsVUsVUs");

vector signed short __ATTRS_o_ai
vec_vmladduhm(vector unsigned short __a, vector signed short __b, vector signed short __c) __asm__("__IBMBuiltin_vec_mladd_VSsVUsVSsVSs");

vector signed short __ATTRS_o_ai
vec_vmladduhm(vector signed short __a, vector unsigned short __b, vector unsigned short __c) __asm__("__IBMBuiltin_vec_mladd_VSsVSsVUsVUs");

vector signed short __ATTRS_o_ai
vec_vmladduhm(vector signed short __a, vector signed short __b, vector signed short __c) __asm__("__IBMBuiltin_vec_mladd_VSsVSsVSsVSs");

vector signed short __attribute__((__always_inline__))
vec_mradds(vector signed short __a, vector signed short __b, vector signed short __c) __asm__("__IBMBuiltin_vec_mradds_VSsVSsVSsVSs");

vector signed short __attribute__((__always_inline__))
vec_vmhraddshs(vector signed short __a, vector signed short __b, vector signed short __c) __asm__("__IBMBuiltin_vec_mradds_VSsVSsVSsVSs");

vector unsigned int __ATTRS_o_ai
vec_msum(vector unsigned char __a, vector unsigned char __b, vector unsigned int __c) __asm__("__IBMBuiltin_vec_msum_VUiVUcVUcVUi");

vector signed int __ATTRS_o_ai
vec_msum(vector signed char __a, vector unsigned char __b, vector signed int __c) __asm__("__IBMBuiltin_vec_msum_VSiVScVUcVSi");

vector unsigned int __ATTRS_o_ai
vec_msum(vector unsigned short __a, vector unsigned short __b, vector unsigned int __c) __asm__("__IBMBuiltin_vec_msum_VUiVUsVUsVUi");

vector signed int __ATTRS_o_ai
vec_msum(vector signed short __a, vector signed short __b, vector signed int __c) __asm__("__IBMBuiltin_vec_msum_VSiVSsVSsVSi");

vector unsigned int __attribute__((__always_inline__))
vec_vmsumubm(vector unsigned char __a, vector unsigned char __b, vector unsigned int __c) __asm__("__IBMBuiltin_vec_msum_VUiVUcVUcVUi");

vector signed int __attribute__((__always_inline__))
vec_vmsummbm(vector signed char __a, vector unsigned char __b, vector signed int __c) __asm__("__IBMBuiltin_vec_msum_VSiVScVUcVSi");

vector unsigned int __attribute__((__always_inline__))
vec_vmsumuhm(vector unsigned short __a, vector unsigned short __b, vector unsigned int __c) __asm__("__IBMBuiltin_vec_msum_VUiVUsVUsVUi");

vector signed int __attribute__((__always_inline__))
vec_vmsumshm(vector signed short __a, vector signed short __b, vector signed int __c) __asm__("__IBMBuiltin_vec_msum_VSiVSsVSsVSi");

vector unsigned int __ATTRS_o_ai
vec_msums(vector unsigned short __a, vector unsigned short __b, vector unsigned int __c) __asm__("__IBMBuiltin_vec_msums_VUiVUsVUsVUi");

vector signed int __ATTRS_o_ai
vec_msums(vector signed short __a, vector signed short __b, vector signed int __c) __asm__("__IBMBuiltin_vec_msums_VSiVSsVSsVSi");

vector unsigned int __attribute__((__always_inline__))
vec_vmsumuhs(vector unsigned short __a, vector unsigned short __b, vector unsigned int __c) __asm__("__IBMBuiltin_vec_msums_VUiVUsVUsVUi");

vector signed int __attribute__((__always_inline__))
vec_vmsumshs(vector signed short __a, vector signed short __b, vector signed int __c) __asm__("__IBMBuiltin_vec_msums_VSiVSsVSsVSi");

void __ATTRS_o_ai
vec_mtvscr(vector unsigned char __a) __asm__("__IBMBuiltin_vec_mtvscr_vVUc");

void __ATTRS_o_ai
vec_mtvscr(vector signed char __a) __asm__("__IBMBuiltin_vec_mtvscr_vVSc");

void __ATTRS_o_ai
vec_mtvscr(vector bool char __a) __asm__("__IBMBuiltin_vec_mtvscr_vVBc");

void __ATTRS_o_ai
vec_mtvscr(vector unsigned short __a) __asm__("__IBMBuiltin_vec_mtvscr_vVUs");

void __ATTRS_o_ai
vec_mtvscr(vector signed short __a) __asm__("__IBMBuiltin_vec_mtvscr_vVSs");

void __ATTRS_o_ai
vec_mtvscr(vector bool short __a) __asm__("__IBMBuiltin_vec_mtvscr_vVBs");

void __ATTRS_o_ai
vec_mtvscr(vector pixel __a) __asm__("__IBMBuiltin_vec_mtvscr_vVp");

void __ATTRS_o_ai
vec_mtvscr(vector unsigned int __a) __asm__("__IBMBuiltin_vec_mtvscr_vVUi");

void __ATTRS_o_ai
vec_mtvscr(vector signed int __a) __asm__("__IBMBuiltin_vec_mtvscr_vVSi");

void __ATTRS_o_ai
vec_mtvscr(vector bool int __a) __asm__("__IBMBuiltin_vec_mtvscr_vVBi");

vector unsigned short __attribute__((__always_inline__))
vec_vmuleub(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_mule_VUsVUcVUc");

vector signed short __attribute__((__always_inline__))
vec_vmulesb(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_mule_VSsVScVSc");

vector unsigned int __attribute__((__always_inline__))
vec_vmuleuh(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_mule_VUiVUsVUs");

vector signed int __attribute__((__always_inline__))
vec_vmulesh(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_mule_VSiVSsVSs");

vector signed long long __ATTRS_o_ai
vec_mule(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_mule_VSlVSiVSi");

vector unsigned long long __ATTRS_o_ai
vec_mule(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_mule_VUlVUiVUi");

vector unsigned short __attribute__((__always_inline__))
vec_vmuloub(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_mulo_VUsVUcVUc");

vector signed short __attribute__((__always_inline__))
vec_vmulosb(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_mulo_VSsVScVSc");

vector unsigned int __attribute__((__always_inline__))
vec_vmulouh(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_mulo_VUiVUsVUs");

vector signed int __attribute__((__always_inline__))
vec_vmulosh(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_mulo_VSiVSsVSs");

vector signed long long __ATTRS_o_ai
vec_mulo(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_mulo_VSlVSiVSi");

vector unsigned long long __ATTRS_o_ai
vec_mulo(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_mulo_VUlVUiVUi");

vector float __ATTRS_o_ai
vec_nmsub(vector float __a, vector float __b, vector float __c) __asm__("__IBMBuiltin_vec_nmsub_VfVfVfVf");

vector float __attribute__((__always_inline__))
vec_vnmsubfp(vector float __a, vector float __b, vector float __c) __asm__("__IBMBuiltin_vec_nmsub_VfVfVfVf");

vector float __ATTRS_o_ai
vec_nor(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_nor_VfVfVf");

vector unsigned char __ATTRS_o_ai
vec_vnor(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_nor_VUcVUcVUc");

vector signed char __ATTRS_o_ai
vec_vnor(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_nor_VScVScVSc");

vector bool char __ATTRS_o_ai
vec_vnor(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_nor_VBcVBcVBc");

vector unsigned short __ATTRS_o_ai
vec_vnor(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_nor_VUsVUsVUs");

vector signed short __ATTRS_o_ai
vec_vnor(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_nor_VSsVSsVSs");

vector bool short __ATTRS_o_ai
vec_vnor(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_nor_VBsVBsVBs");

vector unsigned int __ATTRS_o_ai
vec_vnor(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_nor_VUiVUiVUi");

vector signed int __ATTRS_o_ai
vec_vnor(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_nor_VSiVSiVSi");

vector bool int __ATTRS_o_ai
vec_vnor(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_nor_VBiVBiVBi");

vector float __ATTRS_o_ai
vec_vnor(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_nor_VfVfVf");

vector unsigned char __ATTRS_o_ai
vec_or(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_or_VUcVUcVUc");

vector unsigned char __ATTRS_o_ai
vec_or(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_or_VUcVUcVBc");

vector unsigned char __ATTRS_o_ai
vec_or(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_or_VUcVBcVUc");

vector signed char __ATTRS_o_ai
vec_or(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_or_VScVScVSc");

vector signed char __ATTRS_o_ai
vec_or(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_or_VScVScVBc");

vector signed char __ATTRS_o_ai
vec_or(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_or_VScVBcVSc");

vector bool char __ATTRS_o_ai
vec_or(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_or_VBcVBcVBc");

vector unsigned short __ATTRS_o_ai
vec_or(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_or_VUsVUsVUs");

vector unsigned short __ATTRS_o_ai
vec_or(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_or_VUsVUsVBs");

vector unsigned short __ATTRS_o_ai
vec_or(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_or_VUsVBsVUs");

vector signed short __ATTRS_o_ai
vec_or(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_or_VSsVSsVSs");

vector signed short __ATTRS_o_ai
vec_or(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_or_VSsVSsVBs");

vector signed short __ATTRS_o_ai
vec_or(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_or_VSsVBsVSs");

vector bool short __ATTRS_o_ai
vec_or(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_or_VBsVBsVBs");

vector unsigned int __ATTRS_o_ai
vec_or(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_or_VUiVUiVUi");

vector unsigned int __ATTRS_o_ai
vec_or(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_or_VUiVUiVBi");

vector unsigned int __ATTRS_o_ai
vec_or(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_or_VUiVBiVUi");

vector signed int __ATTRS_o_ai
vec_or(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_or_VSiVSiVSi");

vector signed int __ATTRS_o_ai
vec_or(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_or_VSiVSiVBi");

vector signed int __ATTRS_o_ai
vec_or(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_or_VSiVBiVSi");

vector bool int __ATTRS_o_ai
vec_or(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_or_VBiVBiVBi");

vector float __ATTRS_o_ai
vec_or(vector bool int __a, vector float __b) __asm__("__IBMBuiltin_vec_or_VfVBiVf");

vector float __ATTRS_o_ai
vec_or(vector float __a, vector bool int __b) __asm__("__IBMBuiltin_vec_or_VfVfVBi");

vector float __ATTRS_o_ai
vec_or(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_or_VfVfVf");

vector unsigned char __ATTRS_o_ai
vec_vor(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_or_VUcVUcVUc");

vector unsigned char __ATTRS_o_ai
vec_vor(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_or_VUcVUcVBc");

vector unsigned char __ATTRS_o_ai
vec_vor(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_or_VUcVBcVUc");

vector signed char __ATTRS_o_ai
vec_vor(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_or_VScVScVSc");

vector signed char __ATTRS_o_ai
vec_vor(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_or_VScVScVBc");

vector signed char __ATTRS_o_ai
vec_vor(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_or_VScVBcVSc");

vector bool char __ATTRS_o_ai
vec_vor(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_or_VBcVBcVBc");

vector unsigned short __ATTRS_o_ai
vec_vor(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_or_VUsVUsVUs");

vector unsigned short __ATTRS_o_ai
vec_vor(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_or_VUsVUsVBs");

vector unsigned short __ATTRS_o_ai
vec_vor(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_or_VUsVBsVUs");

vector signed short __ATTRS_o_ai
vec_vor(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_or_VSsVSsVSs");

vector signed short __ATTRS_o_ai
vec_vor(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_or_VSsVSsVBs");

vector signed short __ATTRS_o_ai
vec_vor(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_or_VSsVBsVSs");

vector bool short __ATTRS_o_ai
vec_vor(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_or_VBsVBsVBs");

vector unsigned int __ATTRS_o_ai
vec_vor(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_or_VUiVUiVUi");

vector unsigned int __ATTRS_o_ai
vec_vor(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_or_VUiVUiVBi");

vector unsigned int __ATTRS_o_ai
vec_vor(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_or_VUiVBiVUi");

vector signed int __ATTRS_o_ai
vec_vor(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_or_VSiVSiVSi");

vector signed int __ATTRS_o_ai
vec_vor(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_or_VSiVSiVBi");

vector signed int __ATTRS_o_ai
vec_vor(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_or_VSiVBiVSi");

vector bool int __ATTRS_o_ai
vec_vor(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_or_VBiVBiVBi");

vector float __ATTRS_o_ai
vec_vor(vector bool int __a, vector float __b) __asm__("__IBMBuiltin_vec_or_VfVBiVf");

vector float __ATTRS_o_ai
vec_vor(vector float __a, vector bool int __b) __asm__("__IBMBuiltin_vec_or_VfVfVBi");

vector float __ATTRS_o_ai
vec_vor(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_or_VfVfVf");

vector unsigned char __ATTRS_o_ai
vec_vpkuhum(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_pack_VUcVUsVUs");

vector signed char __ATTRS_o_ai
vec_vpkuhum(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_pack_VScVSsVSs");

vector bool char __ATTRS_o_ai
vec_vpkuhum(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_pack_VBcVBsVBs");

vector unsigned short __ATTRS_o_ai
vec_vpkuwum(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_pack_VUsVUiVUi");

vector signed short __ATTRS_o_ai
vec_vpkuwum(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_pack_VSsVSiVSi");

vector bool short __ATTRS_o_ai
vec_vpkuwum(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_pack_VBsVBiVBi");

vector pixel __attribute__((__always_inline__))
vec_packpx(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_packpx_VpVUiVUi");

vector pixel __attribute__((__always_inline__))
vec_vpkpx(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_packpx_VpVUiVUi");

vector unsigned char __attribute__((__always_inline__))
vec_vpkuhus(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_packs_VUcVUsVUs");

vector signed char __attribute__((__always_inline__))
vec_vpkshss(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_packs_VScVSsVSs");

vector unsigned short __attribute__((__always_inline__))
vec_vpkuwus(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_packs_VUsVUiVUi");

vector signed short __attribute__((__always_inline__))
vec_vpkswss(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_packs_VSsVSiVSi");

vector unsigned char __attribute__((__always_inline__))
vec_vpkshus(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_packsu_VUcVSsVSs");

vector unsigned short __attribute__((__always_inline__))
vec_vpkswus(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_packsu_VUsVSiVSi");

vector pixel __ATTRS_o_ai
vec_perm(vector pixel __a, vector pixel __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_VpVpVpVUc");

vector float __ATTRS_o_ai
vec_perm(vector float __a, vector float __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_VfVfVfVUc");

vector unsigned char __ATTRS_o_ai
vec_vperm(vector unsigned char __a, vector unsigned char __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_VUcVUcVUcVUc");

vector signed char __ATTRS_o_ai
vec_vperm(vector signed char __a, vector signed char __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_VScVScVScVUc");

vector bool char __ATTRS_o_ai
vec_vperm(vector bool char __a, vector bool char __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_VBcVBcVBcVUc");

vector unsigned short __ATTRS_o_ai
vec_vperm(vector unsigned short __a, vector unsigned short __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_VUsVUsVUsVUc");

vector signed short __ATTRS_o_ai
vec_vperm(vector signed short __a, vector signed short __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_VSsVSsVSsVUc");

vector bool short __ATTRS_o_ai
vec_vperm(vector bool short __a, vector bool short __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_VBsVBsVBsVUc");

vector pixel __ATTRS_o_ai
vec_vperm(vector pixel __a, vector pixel __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_VpVpVpVUc");

vector unsigned int __ATTRS_o_ai
vec_vperm(vector unsigned int __a, vector unsigned int __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_VUiVUiVUiVUc");

vector signed int __ATTRS_o_ai
vec_vperm(vector signed int __a, vector signed int __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_VSiVSiVSiVUc");

vector bool int __ATTRS_o_ai
vec_vperm(vector bool int __a, vector bool int __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_VBiVBiVBiVUc");

vector float __ATTRS_o_ai
vec_vperm(vector float __a, vector float __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_VfVfVfVUc");

vector float __ATTRS_o_ai
vec_re(vector float __a) __asm__("__IBMBuiltin_vec_re_VfVf");

vector float __attribute__((__always_inline__))
vec_vrefp(vector float __a) __asm__("__IBMBuiltin_vec_re_VfVf");

vector unsigned char __ATTRS_o_ai
vec_vrlb(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_rl_VUcVUcVUc");

vector signed char __ATTRS_o_ai
vec_vrlb(vector signed char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_rl_VScVScVUc");

vector unsigned short __ATTRS_o_ai
vec_vrlh(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_rl_VUsVUsVUs");

vector signed short __ATTRS_o_ai
vec_vrlh(vector signed short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_rl_VSsVSsVUs");
// P9 vec_rlmi
vector unsigned int __ATTRS_o_ai
vec_rlmi (vector unsigned int, vector unsigned int, vector unsigned int) __asm__ ("__IBMBuiltin_vec_rlmi_VUiVUiVUiVUi");

vector unsigned long long __ATTRS_o_ai
vec_rlmi (vector unsigned long long, vector unsigned long long, vector unsigned long long) __asm__ ("__IBMBuiltin_vec_rlmi_VUllVUllVUllVUll");
// P9 vec_rlmi end
// P9 vec_rlnm
vector unsigned int __ATTRS_o_ai
vec_rlnm (vector unsigned int, vector unsigned int, vector unsigned int) __asm__ ("__IBMBuiltin_vec_rlnm_VUiVUiVUiVUi");

vector unsigned long long __ATTRS_o_ai
vec_rlnm (vector unsigned long long, vector unsigned long long, vector unsigned long long) __asm__ ("__IBMBuiltin_vec_rlnm_VUllVUllVUllVUll");
// P9 vec_rlnm end

vector unsigned int __ATTRS_o_ai
vec_vrlw(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_rl_VUiVUiVUi");

vector signed int __ATTRS_o_ai
vec_vrlw(vector signed int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_rl_VSiVSiVUi");

vector float __ATTRS_o_ai
vec_round(vector float __a) __asm__("__IBMBuiltin_vec_round_VfVf");

vector float __attribute__((__always_inline__))
vec_vrfin(vector float __a) __asm__("__IBMBuiltin_vec_round_VfVf");

vector float __ATTRS_o_ai
vec_rsqrte(vector float __a) __asm__("__IBMBuiltin_vec_rsqrte_VfVf");

vector float __attribute__((__always_inline__))
vec_vrsqrtefp(vector float __a) __asm__("__IBMBuiltin_vec_rsqrte_VfVf");

vector float __ATTRS_o_ai
vec_sel(vector float __a, vector float __b, vector unsigned int __c) __asm__("__IBMBuiltin_vec_sel_VfVfVfVUi");

vector float __ATTRS_o_ai
vec_sel(vector float __a, vector float __b, vector bool int __c) __asm__("__IBMBuiltin_vec_sel_VfVfVfVBi");

vector unsigned char __ATTRS_o_ai
vec_vsel(vector unsigned char __a, vector unsigned char __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_sel_VUcVUcVUcVUc");

vector unsigned char __ATTRS_o_ai
vec_vsel(vector unsigned char __a, vector unsigned char __b, vector bool char __c) __asm__("__IBMBuiltin_vec_sel_VUcVUcVUcVBc");

vector signed char __ATTRS_o_ai
vec_vsel(vector signed char __a, vector signed char __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_sel_VScVScVScVUc");

vector signed char __ATTRS_o_ai
vec_vsel(vector signed char __a, vector signed char __b, vector bool char __c) __asm__("__IBMBuiltin_vec_sel_VScVScVScVBc");

vector bool char __ATTRS_o_ai
vec_vsel(vector bool char __a, vector bool char __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_sel_VBcVBcVBcVUc");

vector bool char __ATTRS_o_ai
vec_vsel(vector bool char __a, vector bool char __b, vector bool char __c) __asm__("__IBMBuiltin_vec_sel_VBcVBcVBcVBc");

vector unsigned short __ATTRS_o_ai
vec_vsel(vector unsigned short __a, vector unsigned short __b, vector unsigned short __c) __asm__("__IBMBuiltin_vec_sel_VUsVUsVUsVUs");

vector unsigned short __ATTRS_o_ai
vec_vsel(vector unsigned short __a, vector unsigned short __b, vector bool short __c) __asm__("__IBMBuiltin_vec_sel_VUsVUsVUsVBs");

vector signed short __ATTRS_o_ai
vec_vsel(vector signed short __a, vector signed short __b, vector unsigned short __c) __asm__("__IBMBuiltin_vec_sel_VSsVSsVSsVUs");

vector signed short __ATTRS_o_ai
vec_vsel(vector signed short __a, vector signed short __b, vector bool short __c) __asm__("__IBMBuiltin_vec_sel_VSsVSsVSsVBs");

vector bool short __ATTRS_o_ai
vec_vsel(vector bool short __a, vector bool short __b, vector unsigned short __c) __asm__("__IBMBuiltin_vec_sel_VBsVBsVBsVUs");

vector bool short __ATTRS_o_ai
vec_vsel(vector bool short __a, vector bool short __b, vector bool short __c) __asm__("__IBMBuiltin_vec_sel_VBsVBsVBsVBs");

vector unsigned int __ATTRS_o_ai
vec_vsel(vector unsigned int __a, vector unsigned int __b, vector unsigned int __c) __asm__("__IBMBuiltin_vec_sel_VUiVUiVUiVUi");

vector unsigned int __ATTRS_o_ai
vec_vsel(vector unsigned int __a, vector unsigned int __b, vector bool int __c) __asm__("__IBMBuiltin_vec_sel_VUiVUiVUiVBi");

vector signed int __ATTRS_o_ai
vec_vsel(vector signed int __a, vector signed int __b, vector unsigned int __c) __asm__("__IBMBuiltin_vec_sel_VSiVSiVSiVUi");

vector signed int __ATTRS_o_ai
vec_vsel(vector signed int __a, vector signed int __b, vector bool int __c) __asm__("__IBMBuiltin_vec_sel_VSiVSiVSiVBi");

vector bool int __ATTRS_o_ai
vec_vsel(vector bool int __a, vector bool int __b, vector unsigned int __c) __asm__("__IBMBuiltin_vec_sel_VBiVBiVBiVUi");

vector bool int __ATTRS_o_ai
vec_vsel(vector bool int __a, vector bool int __b, vector bool int __c) __asm__("__IBMBuiltin_vec_sel_VBiVBiVBiVBi");

vector float __ATTRS_o_ai
vec_vsel(vector float __a, vector float __b, vector unsigned int __c) __asm__("__IBMBuiltin_vec_sel_VfVfVfVUi");

vector float __ATTRS_o_ai
vec_vsel(vector float __a, vector float __b, vector bool int __c) __asm__("__IBMBuiltin_vec_sel_VfVfVfVBi");

vector unsigned char __ATTRS_o_ai
vec_sl(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sl_VUcVUcVUc");

vector signed char __ATTRS_o_ai
vec_sl(vector signed char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sl_VScVScVUc");

vector unsigned short __ATTRS_o_ai
vec_sl(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sl_VUsVUsVUs");

vector signed short __ATTRS_o_ai
vec_sl(vector signed short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sl_VSsVSsVUs");

vector unsigned int __ATTRS_o_ai
vec_sl(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sl_VUiVUiVUi");

vector signed int __ATTRS_o_ai
vec_sl(vector signed int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sl_VSiVSiVUi");

vector unsigned char __ATTRS_o_ai
vec_vslb(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sl_VUcVUcVUc");

vector signed char __ATTRS_o_ai
vec_vslb(vector signed char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sl_VScVScVUc");

vector unsigned short __ATTRS_o_ai
vec_vslh(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sl_VUsVUsVUs");

vector signed short __ATTRS_o_ai
vec_vslh(vector signed short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sl_VSsVSsVUs");

vector unsigned int __ATTRS_o_ai
vec_vslw(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sl_VUiVUiVUi");

vector signed int __ATTRS_o_ai
vec_vslw(vector signed int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sl_VSiVSiVUi");

vector unsigned char __ATTRS_o_ai
vec_sld(vector unsigned char __a, vector unsigned char __b, signed int __c) __asm__("__IBMBuiltin_vec_sld_VUcVUcVUci");

vector signed char __ATTRS_o_ai
vec_sld(vector signed char __a, vector signed char __b, signed int __c) __asm__("__IBMBuiltin_vec_sld_VScVScVSci");

vector unsigned short __ATTRS_o_ai
vec_sld(vector unsigned short __a, vector unsigned short __b, signed int __c) __asm__("__IBMBuiltin_vec_sld_VUsVUsVUsi");

vector signed short __ATTRS_o_ai
vec_sld(vector signed short __a, vector signed short __b, signed int __c) __asm__("__IBMBuiltin_vec_sld_VSsVSsVSsi");

vector pixel __ATTRS_o_ai
vec_sld(vector pixel __a, vector pixel __b, signed int __c) __asm__("__IBMBuiltin_vec_sld_VpVpVpi");

vector unsigned int __ATTRS_o_ai
vec_sld(vector unsigned int __a, vector unsigned int __b, signed int __c) __asm__("__IBMBuiltin_vec_sld_VUiVUiVUii");

vector signed int __ATTRS_o_ai
vec_sld(vector signed int __a, vector signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_sld_VSiVSiVSii");

vector float __ATTRS_o_ai
vec_sld(vector float __a, vector float __b, signed int __c) __asm__("__IBMBuiltin_vec_sld_VfVfVfi");

vector unsigned char __ATTRS_o_ai
vec_vsldoi(vector unsigned char __a, vector unsigned char __b, signed int __c) __asm__("__IBMBuiltin_vec_sld_VUcVUcVUci");

vector signed char __ATTRS_o_ai
vec_vsldoi(vector signed char __a, vector signed char __b, signed int __c) __asm__("__IBMBuiltin_vec_sld_VScVScVSci");

vector unsigned short __ATTRS_o_ai
vec_vsldoi(vector unsigned short __a, vector unsigned short __b, signed int __c) __asm__("__IBMBuiltin_vec_sld_VUsVUsVUsi");

vector signed short __ATTRS_o_ai
vec_vsldoi(vector signed short __a, vector signed short __b, signed int __c) __asm__("__IBMBuiltin_vec_sld_VSsVSsVSsi");

vector pixel __ATTRS_o_ai
vec_vsldoi(vector pixel __a, vector pixel __b, signed int __c) __asm__("__IBMBuiltin_vec_sld_VpVpVpi");

vector unsigned int __ATTRS_o_ai
vec_vsldoi(vector unsigned int __a, vector unsigned int __b, signed int __c) __asm__("__IBMBuiltin_vec_sld_VUiVUiVUii");

vector signed int __ATTRS_o_ai
vec_vsldoi(vector signed int __a, vector signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_sld_VSiVSiVSii");

vector float __ATTRS_o_ai
vec_vsldoi(vector float __a, vector float __b, signed int __c) __asm__("__IBMBuiltin_vec_sld_VfVfVfi");

vector pixel __ATTRS_o_ai
vec_sll(vector pixel __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sll_VpVpVUc");

vector pixel __ATTRS_o_ai
vec_sll(vector pixel __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sll_VpVpVUs");

vector pixel __ATTRS_o_ai
vec_sll(vector pixel __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sll_VpVpVUi");

vector unsigned char __ATTRS_o_ai
vec_vsl(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sll_VUcVUcVUc");

vector unsigned char __ATTRS_o_ai
vec_vsl(vector unsigned char __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sll_VUcVUcVUs");

vector unsigned char __ATTRS_o_ai
vec_vsl(vector unsigned char __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sll_VUcVUcVUi");

vector signed char __ATTRS_o_ai
vec_vsl(vector signed char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sll_VScVScVUc");

vector signed char __ATTRS_o_ai
vec_vsl(vector signed char __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sll_VScVScVUs");

vector signed char __ATTRS_o_ai
vec_vsl(vector signed char __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sll_VScVScVUi");

vector bool char __ATTRS_o_ai
vec_vsl(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sll_VBcVBcVUc");

vector bool char __ATTRS_o_ai
vec_vsl(vector bool char __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sll_VBcVBcVUs");

vector bool char __ATTRS_o_ai
vec_vsl(vector bool char __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sll_VBcVBcVUi");

vector unsigned short __ATTRS_o_ai
vec_vsl(vector unsigned short __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sll_VUsVUsVUc");

vector unsigned short __ATTRS_o_ai
vec_vsl(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sll_VUsVUsVUs");

vector unsigned short __ATTRS_o_ai
vec_vsl(vector unsigned short __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sll_VUsVUsVUi");

vector signed short __ATTRS_o_ai
vec_vsl(vector signed short __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sll_VSsVSsVUc");

vector signed short __ATTRS_o_ai
vec_vsl(vector signed short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sll_VSsVSsVUs");

vector signed short __ATTRS_o_ai
vec_vsl(vector signed short __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sll_VSsVSsVUi");

vector bool short __ATTRS_o_ai
vec_vsl(vector bool short __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sll_VBsVBsVUc");

vector bool short __ATTRS_o_ai
vec_vsl(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sll_VBsVBsVUs");

vector bool short __ATTRS_o_ai
vec_vsl(vector bool short __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sll_VBsVBsVUi");

vector pixel __ATTRS_o_ai
vec_vsl(vector pixel __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sll_VpVpVUc");

vector pixel __ATTRS_o_ai
vec_vsl(vector pixel __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sll_VpVpVUs");

vector pixel __ATTRS_o_ai
vec_vsl(vector pixel __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sll_VpVpVUi");

vector unsigned int __ATTRS_o_ai
vec_vsl(vector unsigned int __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sll_VUiVUiVUc");

vector unsigned int __ATTRS_o_ai
vec_vsl(vector unsigned int __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sll_VUiVUiVUs");

vector unsigned int __ATTRS_o_ai
vec_vsl(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sll_VUiVUiVUi");

vector signed int __ATTRS_o_ai
vec_vsl(vector signed int __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sll_VSiVSiVUc");

vector signed int __ATTRS_o_ai
vec_vsl(vector signed int __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sll_VSiVSiVUs");

vector signed int __ATTRS_o_ai
vec_vsl(vector signed int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sll_VSiVSiVUi");

vector bool int __ATTRS_o_ai
vec_vsl(vector bool int __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sll_VBiVBiVUc");

vector bool int __ATTRS_o_ai
vec_vsl(vector bool int __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sll_VBiVBiVUs");

vector bool int __ATTRS_o_ai
vec_vsl(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sll_VBiVBiVUi");

vector unsigned char __ATTRS_o_ai
vec_slo(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_slo_VUcVUcVUc");

vector unsigned char __ATTRS_o_ai
vec_slo(vector unsigned char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_slo_VUcVUcVSc");

vector signed char __ATTRS_o_ai
vec_slo(vector signed char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_slo_VScVScVUc");

vector signed char __ATTRS_o_ai
vec_slo(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_slo_VScVScVSc");

vector unsigned short __ATTRS_o_ai
vec_slo(vector unsigned short __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_slo_VUsVUsVUc");

vector unsigned short __ATTRS_o_ai
vec_slo(vector unsigned short __a, vector signed char __b) __asm__("__IBMBuiltin_vec_slo_VUsVUsVSc");

vector signed short __ATTRS_o_ai
vec_slo(vector signed short __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_slo_VSsVSsVUc");

vector signed short __ATTRS_o_ai
vec_slo(vector signed short __a, vector signed char __b) __asm__("__IBMBuiltin_vec_slo_VSsVSsVSc");

vector pixel __ATTRS_o_ai
vec_slo(vector pixel __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_slo_VpVpVUc");

vector pixel __ATTRS_o_ai
vec_slo(vector pixel __a, vector signed char __b) __asm__("__IBMBuiltin_vec_slo_VpVpVSc");

vector unsigned int __ATTRS_o_ai
vec_slo(vector unsigned int __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_slo_VUiVUiVUc");

vector unsigned int __ATTRS_o_ai
vec_slo(vector unsigned int __a, vector signed char __b) __asm__("__IBMBuiltin_vec_slo_VUiVUiVSc");

vector signed int __ATTRS_o_ai
vec_slo(vector signed int __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_slo_VSiVSiVUc");

vector signed int __ATTRS_o_ai
vec_slo(vector signed int __a, vector signed char __b) __asm__("__IBMBuiltin_vec_slo_VSiVSiVSc");

vector float __ATTRS_o_ai
vec_slo(vector float __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_slo_VfVfVUc");

vector float __ATTRS_o_ai
vec_slo(vector float __a, vector signed char __b) __asm__("__IBMBuiltin_vec_slo_VfVfVSc");

vector unsigned char __ATTRS_o_ai
vec_vslo(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_slo_VUcVUcVUc");

vector unsigned char __ATTRS_o_ai
vec_vslo(vector unsigned char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_slo_VUcVUcVSc");

vector signed char __ATTRS_o_ai
vec_vslo(vector signed char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_slo_VScVScVUc");

vector signed char __ATTRS_o_ai
vec_vslo(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_slo_VScVScVSc");

vector unsigned short __ATTRS_o_ai
vec_vslo(vector unsigned short __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_slo_VUsVUsVUc");

vector unsigned short __ATTRS_o_ai
vec_vslo(vector unsigned short __a, vector signed char __b) __asm__("__IBMBuiltin_vec_slo_VUsVUsVSc");

vector signed short __ATTRS_o_ai
vec_vslo(vector signed short __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_slo_VSsVSsVUc");

vector signed short __ATTRS_o_ai
vec_vslo(vector signed short __a, vector signed char __b) __asm__("__IBMBuiltin_vec_slo_VSsVSsVSc");

vector pixel __ATTRS_o_ai
vec_vslo(vector pixel __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_slo_VpVpVUc");

vector pixel __ATTRS_o_ai
vec_vslo(vector pixel __a, vector signed char __b) __asm__("__IBMBuiltin_vec_slo_VpVpVSc");

vector unsigned int __ATTRS_o_ai
vec_vslo(vector unsigned int __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_slo_VUiVUiVUc");

vector unsigned int __ATTRS_o_ai
vec_vslo(vector unsigned int __a, vector signed char __b) __asm__("__IBMBuiltin_vec_slo_VUiVUiVSc");

vector signed int __ATTRS_o_ai
vec_vslo(vector signed int __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_slo_VSiVSiVUc");

vector signed int __ATTRS_o_ai
vec_vslo(vector signed int __a, vector signed char __b) __asm__("__IBMBuiltin_vec_slo_VSiVSiVSc");

vector float __ATTRS_o_ai
vec_vslo(vector float __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_slo_VfVfVUc");

vector float __ATTRS_o_ai
vec_vslo(vector float __a, vector signed char __b) __asm__("__IBMBuiltin_vec_slo_VfVfVSc");

vector unsigned char __ATTRS_o_ai
vec_splat(vector unsigned char __a, signed int __b) __asm__("__IBMBuiltin_vec_splat_VUcVUci");

vector signed char __ATTRS_o_ai
vec_splat(vector signed char __a, signed int __b) __asm__("__IBMBuiltin_vec_splat_VScVSci");

vector bool char __ATTRS_o_ai
vec_splat(vector bool char __a, signed int __b) __asm__("__IBMBuiltin_vec_splat_VBcVBci");

vector unsigned short __ATTRS_o_ai
vec_splat(vector unsigned short __a, signed int __b) __asm__("__IBMBuiltin_vec_splat_VUsVUsi");

vector signed short __ATTRS_o_ai
vec_splat(vector signed short __a, signed int __b) __asm__("__IBMBuiltin_vec_splat_VSsVSsi");

vector bool short __ATTRS_o_ai
vec_splat(vector bool short __a, signed int __b) __asm__("__IBMBuiltin_vec_splat_VBsVBsi");

vector pixel __ATTRS_o_ai
vec_splat(vector pixel __a, signed int __b) __asm__("__IBMBuiltin_vec_splat_VpVpi");

vector unsigned int __ATTRS_o_ai
vec_splat(vector unsigned int __a, signed int __b) __asm__("__IBMBuiltin_vec_splat_VUiVUii");

vector signed int __ATTRS_o_ai
vec_splat(vector signed int __a, signed int __b) __asm__("__IBMBuiltin_vec_splat_VSiVSii");

vector bool int __ATTRS_o_ai
vec_splat(vector bool int __a, signed int __b) __asm__("__IBMBuiltin_vec_splat_VBiVBii");

vector float __ATTRS_o_ai
vec_splat(vector float __a, signed int __b) __asm__("__IBMBuiltin_vec_splat_VfVfi");

vector unsigned char __ATTRS_o_ai
vec_vspltb(vector unsigned char __a, signed int __b) __asm__("__IBMBuiltin_vec_splat_VUcVUci");

vector signed char __ATTRS_o_ai
vec_vspltb(vector signed char __a, signed int __b) __asm__("__IBMBuiltin_vec_splat_VScVSci");

vector bool char __ATTRS_o_ai
vec_vspltb(vector bool char __a, signed int __b) __asm__("__IBMBuiltin_vec_splat_VBcVBci");

vector unsigned short __ATTRS_o_ai
vec_vsplth(vector unsigned short __a, signed int __b) __asm__("__IBMBuiltin_vec_splat_VUsVUsi");

vector signed short __ATTRS_o_ai
vec_vsplth(vector signed short __a, signed int __b) __asm__("__IBMBuiltin_vec_splat_VSsVSsi");

vector bool short __ATTRS_o_ai
vec_vsplth(vector bool short __a, signed int __b) __asm__("__IBMBuiltin_vec_splat_VBsVBsi");

vector pixel __ATTRS_o_ai
vec_vsplth(vector pixel __a, signed int __b) __asm__("__IBMBuiltin_vec_splat_VpVpi");

vector unsigned int __ATTRS_o_ai
vec_vspltw(vector unsigned int __a, signed int __b) __asm__("__IBMBuiltin_vec_splat_VUiVUii");

vector signed int __ATTRS_o_ai
vec_vspltw(vector signed int __a, signed int __b) __asm__("__IBMBuiltin_vec_splat_VSiVSii");

vector bool int __ATTRS_o_ai
vec_vspltw(vector bool int __a, signed int __b) __asm__("__IBMBuiltin_vec_splat_VBiVBii");

vector float __ATTRS_o_ai
vec_vspltw(vector float __a, signed int __b) __asm__("__IBMBuiltin_vec_splat_VfVfi");

vector signed char __attribute__((__always_inline__))
vec_splat_s8(signed int __a) __asm__("__IBMBuiltin_vec_splat_s8_VSci");

vector signed char __attribute__((__always_inline__))
vec_vspltisb(signed int __a) __asm__("__IBMBuiltin_vec_splat_s8_VSci");

vector signed short __attribute__((__always_inline__))
vec_splat_s16(signed int __a) __asm__("__IBMBuiltin_vec_splat_s16_VSsi");

vector signed short __attribute__((__always_inline__))
vec_vspltish(signed int __a) __asm__("__IBMBuiltin_vec_splat_s16_VSsi");

vector signed int __attribute__((__always_inline__))
vec_splat_s32(signed int __a) __asm__("__IBMBuiltin_vec_splat_s32_VSii");

vector signed int __attribute__((__always_inline__))
vec_vspltisw(signed int __a) __asm__("__IBMBuiltin_vec_splat_s32_VSii");

vector unsigned char __attribute__((__always_inline__))
vec_splat_u8(signed int __a) __asm__("__IBMBuiltin_vec_splat_u8_VUci");

vector unsigned short __attribute__((__always_inline__))
vec_splat_u16(signed int __a) __asm__("__IBMBuiltin_vec_splat_u16_VUsi");

vector unsigned int __attribute__((__always_inline__))
vec_splat_u32(signed int __a) __asm__("__IBMBuiltin_vec_splat_u32_VUii");

vector unsigned char __ATTRS_o_ai
vec_sr(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sr_VUcVUcVUc");

vector signed char __ATTRS_o_ai
vec_sr(vector signed char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sr_VScVScVUc");

vector unsigned short __ATTRS_o_ai
vec_sr(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sr_VUsVUsVUs");

vector signed short __ATTRS_o_ai
vec_sr(vector signed short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sr_VSsVSsVUs");

vector unsigned int __ATTRS_o_ai
vec_sr(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sr_VUiVUiVUi");

vector signed int __ATTRS_o_ai
vec_sr(vector signed int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sr_VSiVSiVUi");

vector unsigned char __ATTRS_o_ai
vec_vsrb(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sr_VUcVUcVUc");

vector signed char __ATTRS_o_ai
vec_vsrb(vector signed char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sr_VScVScVUc");

vector unsigned short __ATTRS_o_ai
vec_vsrh(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sr_VUsVUsVUs");

vector signed short __ATTRS_o_ai
vec_vsrh(vector signed short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sr_VSsVSsVUs");

vector unsigned int __ATTRS_o_ai
vec_vsrw(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sr_VUiVUiVUi");

vector signed int __ATTRS_o_ai
vec_vsrw(vector signed int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sr_VSiVSiVUi");

vector unsigned char __ATTRS_o_ai
vec_sra(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sra_VUcVUcVUc");

vector signed char __ATTRS_o_ai
vec_sra(vector signed char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sra_VScVScVUc");

vector unsigned short __ATTRS_o_ai
vec_sra(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sra_VUsVUsVUs");

vector signed short __ATTRS_o_ai
vec_sra(vector signed short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sra_VSsVSsVUs");

vector unsigned int __ATTRS_o_ai
vec_sra(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sra_VUiVUiVUi");

vector signed int __ATTRS_o_ai
vec_sra(vector signed int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sra_VSiVSiVUi");

vector unsigned char __ATTRS_o_ai
vec_vsrab(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sra_VUcVUcVUc");

vector signed char __ATTRS_o_ai
vec_vsrab(vector signed char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sra_VScVScVUc");

vector unsigned short __ATTRS_o_ai
vec_vsrah(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sra_VUsVUsVUs");

vector signed short __ATTRS_o_ai
vec_vsrah(vector signed short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sra_VSsVSsVUs");

vector unsigned int __ATTRS_o_ai
vec_vsraw(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sra_VUiVUiVUi");

vector signed int __ATTRS_o_ai
vec_vsraw(vector signed int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sra_VSiVSiVUi");

vector pixel __ATTRS_o_ai
vec_srl(vector pixel __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_srl_VpVpVUc");

vector pixel __ATTRS_o_ai
vec_srl(vector pixel __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_srl_VpVpVUs");

vector pixel __ATTRS_o_ai
vec_srl(vector pixel __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_srl_VpVpVUi");

vector unsigned char __ATTRS_o_ai
vec_vsr(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_srl_VUcVUcVUc");

vector unsigned char __ATTRS_o_ai
vec_vsr(vector unsigned char __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_srl_VUcVUcVUs");

vector unsigned char __ATTRS_o_ai
vec_vsr(vector unsigned char __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_srl_VUcVUcVUi");

vector signed char __ATTRS_o_ai
vec_vsr(vector signed char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_srl_VScVScVUc");

vector signed char __ATTRS_o_ai
vec_vsr(vector signed char __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_srl_VScVScVUs");

vector signed char __ATTRS_o_ai
vec_vsr(vector signed char __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_srl_VScVScVUi");

vector bool char __ATTRS_o_ai
vec_vsr(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_srl_VBcVBcVUc");

vector bool char __ATTRS_o_ai
vec_vsr(vector bool char __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_srl_VBcVBcVUs");

vector bool char __ATTRS_o_ai
vec_vsr(vector bool char __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_srl_VBcVBcVUi");

vector unsigned short __ATTRS_o_ai
vec_vsr(vector unsigned short __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_srl_VUsVUsVUc");

vector unsigned short __ATTRS_o_ai
vec_vsr(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_srl_VUsVUsVUs");

vector unsigned short __ATTRS_o_ai
vec_vsr(vector unsigned short __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_srl_VUsVUsVUi");

vector signed short __ATTRS_o_ai
vec_vsr(vector signed short __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_srl_VSsVSsVUc");

vector signed short __ATTRS_o_ai
vec_vsr(vector signed short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_srl_VSsVSsVUs");

vector signed short __ATTRS_o_ai
vec_vsr(vector signed short __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_srl_VSsVSsVUi");

vector bool short __ATTRS_o_ai
vec_vsr(vector bool short __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_srl_VBsVBsVUc");

vector bool short __ATTRS_o_ai
vec_vsr(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_srl_VBsVBsVUs");

vector bool short __ATTRS_o_ai
vec_vsr(vector bool short __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_srl_VBsVBsVUi");

vector pixel __ATTRS_o_ai
vec_vsr(vector pixel __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_srl_VpVpVUc");

vector pixel __ATTRS_o_ai
vec_vsr(vector pixel __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_srl_VpVpVUs");

vector pixel __ATTRS_o_ai
vec_vsr(vector pixel __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_srl_VpVpVUi");

vector unsigned int __ATTRS_o_ai
vec_vsr(vector unsigned int __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_srl_VUiVUiVUc");

vector unsigned int __ATTRS_o_ai
vec_vsr(vector unsigned int __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_srl_VUiVUiVUs");

vector unsigned int __ATTRS_o_ai
vec_vsr(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_srl_VUiVUiVUi");

vector signed int __ATTRS_o_ai
vec_vsr(vector signed int __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_srl_VSiVSiVUc");

vector signed int __ATTRS_o_ai
vec_vsr(vector signed int __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_srl_VSiVSiVUs");

vector signed int __ATTRS_o_ai
vec_vsr(vector signed int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_srl_VSiVSiVUi");

vector bool int __ATTRS_o_ai
vec_vsr(vector bool int __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_srl_VBiVBiVUc");

vector bool int __ATTRS_o_ai
vec_vsr(vector bool int __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_srl_VBiVBiVUs");

vector bool int __ATTRS_o_ai
vec_vsr(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_srl_VBiVBiVUi");

vector unsigned char __ATTRS_o_ai
vec_sro(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sro_VUcVUcVUc");

vector unsigned char __ATTRS_o_ai
vec_sro(vector unsigned char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_sro_VUcVUcVSc");

vector signed char __ATTRS_o_ai
vec_sro(vector signed char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sro_VScVScVUc");

vector signed char __ATTRS_o_ai
vec_sro(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_sro_VScVScVSc");

vector unsigned short __ATTRS_o_ai
vec_sro(vector unsigned short __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sro_VUsVUsVUc");

vector unsigned short __ATTRS_o_ai
vec_sro(vector unsigned short __a, vector signed char __b) __asm__("__IBMBuiltin_vec_sro_VUsVUsVSc");

vector signed short __ATTRS_o_ai
vec_sro(vector signed short __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sro_VSsVSsVUc");

vector signed short __ATTRS_o_ai
vec_sro(vector signed short __a, vector signed char __b) __asm__("__IBMBuiltin_vec_sro_VSsVSsVSc");

vector pixel __ATTRS_o_ai
vec_sro(vector pixel __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sro_VpVpVUc");

vector pixel __ATTRS_o_ai
vec_sro(vector pixel __a, vector signed char __b) __asm__("__IBMBuiltin_vec_sro_VpVpVSc");

vector unsigned int __ATTRS_o_ai
vec_sro(vector unsigned int __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sro_VUiVUiVUc");

vector unsigned int __ATTRS_o_ai
vec_sro(vector unsigned int __a, vector signed char __b) __asm__("__IBMBuiltin_vec_sro_VUiVUiVSc");

vector signed int __ATTRS_o_ai
vec_sro(vector signed int __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sro_VSiVSiVUc");

vector signed int __ATTRS_o_ai
vec_sro(vector signed int __a, vector signed char __b) __asm__("__IBMBuiltin_vec_sro_VSiVSiVSc");

vector float __ATTRS_o_ai
vec_sro(vector float __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sro_VfVfVUc");

vector float __ATTRS_o_ai
vec_sro(vector float __a, vector signed char __b) __asm__("__IBMBuiltin_vec_sro_VfVfVSc");

vector unsigned char __ATTRS_o_ai
vec_vsro(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sro_VUcVUcVUc");

vector unsigned char __ATTRS_o_ai
vec_vsro(vector unsigned char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_sro_VUcVUcVSc");

vector signed char __ATTRS_o_ai
vec_vsro(vector signed char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sro_VScVScVUc");

vector signed char __ATTRS_o_ai
vec_vsro(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_sro_VScVScVSc");

vector unsigned short __ATTRS_o_ai
vec_vsro(vector unsigned short __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sro_VUsVUsVUc");

vector unsigned short __ATTRS_o_ai
vec_vsro(vector unsigned short __a, vector signed char __b) __asm__("__IBMBuiltin_vec_sro_VUsVUsVSc");

vector signed short __ATTRS_o_ai
vec_vsro(vector signed short __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sro_VSsVSsVUc");

vector signed short __ATTRS_o_ai
vec_vsro(vector signed short __a, vector signed char __b) __asm__("__IBMBuiltin_vec_sro_VSsVSsVSc");

vector pixel __ATTRS_o_ai
vec_vsro(vector pixel __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sro_VpVpVUc");

vector pixel __ATTRS_o_ai
vec_vsro(vector pixel __a, vector signed char __b) __asm__("__IBMBuiltin_vec_sro_VpVpVSc");

vector unsigned int __ATTRS_o_ai
vec_vsro(vector unsigned int __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sro_VUiVUiVUc");

vector unsigned int __ATTRS_o_ai
vec_vsro(vector unsigned int __a, vector signed char __b) __asm__("__IBMBuiltin_vec_sro_VUiVUiVSc");

vector signed int __ATTRS_o_ai
vec_vsro(vector signed int __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sro_VSiVSiVUc");

vector signed int __ATTRS_o_ai
vec_vsro(vector signed int __a, vector signed char __b) __asm__("__IBMBuiltin_vec_sro_VSiVSiVSc");

vector float __ATTRS_o_ai
vec_vsro(vector float __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sro_VfVfVUc");

vector float __ATTRS_o_ai
vec_vsro(vector float __a, vector signed char __b) __asm__("__IBMBuiltin_vec_sro_VfVfVSc");

void __ATTRS_o_ai
vec_st(vector unsigned char __a, signed int __b, vector unsigned char * __c) __asm__("__IBMBuiltin_vec_st_vVUciVUcA");

void __ATTRS_o_ai
vec_st(vector unsigned char __a, signed int __b, unsigned char * __c) __asm__("__IBMBuiltin_vec_st_vVUcicA");

void __ATTRS_o_ai
vec_st(vector signed char __a, signed int __b, vector signed char * __c) __asm__("__IBMBuiltin_vec_st_vVSciVScA");

void __ATTRS_o_ai
vec_st(vector signed char __a, signed int __b, signed char * __c) __asm__("__IBMBuiltin_vec_st_vVScicA");

void __ATTRS_o_ai
vec_st(vector bool char __a, signed int __b, vector bool char * __c) __asm__("__IBMBuiltin_vec_st_vVBciVBcA");

void __ATTRS_o_ai
vec_st(vector bool char __a, signed int __b, unsigned char * __c) __asm__("__IBMBuiltin_vec_st_vVBcicA");

void __ATTRS_o_ai
vec_st(vector bool char __a, signed int __b, signed char * __c) __asm__("__IBMBuiltin_vec_st_vVBcicA");

void __ATTRS_o_ai
vec_st(vector unsigned short __a, signed int __b, vector unsigned short * __c) __asm__("__IBMBuiltin_vec_st_vVUsiVUsA");

void __ATTRS_o_ai
vec_st(vector unsigned short __a, signed int __b, unsigned short * __c) __asm__("__IBMBuiltin_vec_st_vVUsisA");

void __ATTRS_o_ai
vec_st(vector signed short __a, signed int __b, vector signed short * __c) __asm__("__IBMBuiltin_vec_st_vVSsiVSsA");

void __ATTRS_o_ai
vec_st(vector signed short __a, signed int __b, signed short * __c) __asm__("__IBMBuiltin_vec_st_vVSsisA");

void __ATTRS_o_ai
vec_st(vector bool short __a, signed int __b, vector bool short * __c) __asm__("__IBMBuiltin_vec_st_vVBsiVBsA");

void __ATTRS_o_ai
vec_st(vector bool short __a, signed int __b, unsigned short * __c) __asm__("__IBMBuiltin_vec_st_vVBsisA");

void __ATTRS_o_ai
vec_st(vector bool short __a, signed int __b, signed short * __c) __asm__("__IBMBuiltin_vec_st_vVBsisA");

void __ATTRS_o_ai
vec_st(vector pixel __a, signed int __b, vector pixel * __c) __asm__("__IBMBuiltin_vec_st_vVpiVpA");

void __ATTRS_o_ai
vec_st(vector pixel __a, signed int __b, unsigned short * __c) __asm__("__IBMBuiltin_vec_st_vVpisA");

void __ATTRS_o_ai
vec_st(vector pixel __a, signed int __b, signed short * __c) __asm__("__IBMBuiltin_vec_st_vVpisA");

void __ATTRS_o_ai
vec_st(vector unsigned int __a, signed int __b, vector unsigned int * __c) __asm__("__IBMBuiltin_vec_st_vVUiiVUiA");

void __ATTRS_o_ai
vec_st(vector unsigned int __a, signed int __b, unsigned int * __c) __asm__("__IBMBuiltin_vec_st_vVUiiiA");

void __ATTRS_o_ai
vec_st(vector unsigned int __a, signed int __b, unsigned long * __c) __asm__("__IBMBuiltin_vec_st_vVUiilA");

void __ATTRS_o_ai
vec_st(vector signed int __a, signed int __b, vector signed int * __c) __asm__("__IBMBuiltin_vec_st_vVSiiVSiA");

void __ATTRS_o_ai
vec_st(vector signed int __a, signed int __b, signed int * __c) __asm__("__IBMBuiltin_vec_st_vVSiiiA");

void __ATTRS_o_ai
vec_st(vector signed int __a, signed int __b, signed long * __c) __asm__("__IBMBuiltin_vec_st_vVSiilA");

void __ATTRS_o_ai
vec_st(vector signed int __a, signed int __b, unsigned long * __c) __asm__("__IBMBuiltin_vec_st_vVSiilA");

void __ATTRS_o_ai
vec_st(vector bool int __a, signed int __b, vector bool int * __c) __asm__("__IBMBuiltin_vec_st_vVBiiVBiA");

void __ATTRS_o_ai
vec_st(vector bool int __a, signed int __b, unsigned int * __c) __asm__("__IBMBuiltin_vec_st_vVBiiiA");

void __ATTRS_o_ai
vec_st(vector bool int __a, signed int __b, signed int * __c) __asm__("__IBMBuiltin_vec_st_vVBiiiA");

void __ATTRS_o_ai
vec_st(vector bool int __a, signed int __b, unsigned long * __c) __asm__("__IBMBuiltin_vec_st_vVBiilA");

void __ATTRS_o_ai
vec_st(vector bool int __a, signed int __b, signed long * __c) __asm__("__IBMBuiltin_vec_st_vVBiilA");

void __ATTRS_o_ai
vec_st(vector float __a, signed int __b, vector float * __c) __asm__("__IBMBuiltin_vec_st_vVfiVfA");

void __ATTRS_o_ai
vec_st(vector float __a, signed int __b, float * __c) __asm__("__IBMBuiltin_vec_st_vVfifA");

void __ATTRS_o_ai
vec_stvx(vector unsigned char __a, signed int __b, vector unsigned char * __c) __asm__("__IBMBuiltin_vec_st_vVUciVUcA");

void __ATTRS_o_ai
vec_stvx(vector unsigned char __a, signed int __b, unsigned char * __c) __asm__("__IBMBuiltin_vec_st_vVUcicA");

void __ATTRS_o_ai
vec_stvx(vector signed char __a, signed int __b, vector signed char * __c) __asm__("__IBMBuiltin_vec_st_vVSciVScA");

void __ATTRS_o_ai
vec_stvx(vector signed char __a, signed int __b, signed char * __c) __asm__("__IBMBuiltin_vec_st_vVScicA");

void __ATTRS_o_ai
vec_stvx(vector bool char __a, signed int __b, vector bool char * __c) __asm__("__IBMBuiltin_vec_st_vVBciVBcA");

void __ATTRS_o_ai
vec_stvx(vector bool char __a, signed int __b, unsigned char * __c) __asm__("__IBMBuiltin_vec_st_vVBcicA");

void __ATTRS_o_ai
vec_stvx(vector bool char __a, signed int __b, signed char * __c) __asm__("__IBMBuiltin_vec_st_vVBcicA");

void __ATTRS_o_ai
vec_stvx(vector unsigned short __a, signed int __b, vector unsigned short * __c) __asm__("__IBMBuiltin_vec_st_vVUsiVUsA");

void __ATTRS_o_ai
vec_stvx(vector unsigned short __a, signed int __b, unsigned short * __c) __asm__("__IBMBuiltin_vec_st_vVUsisA");

void __ATTRS_o_ai
vec_stvx(vector signed short __a, signed int __b, vector signed short * __c) __asm__("__IBMBuiltin_vec_st_vVSsiVSsA");

void __ATTRS_o_ai
vec_stvx(vector signed short __a, signed int __b, signed short * __c) __asm__("__IBMBuiltin_vec_st_vVSsisA");

void __ATTRS_o_ai
vec_stvx(vector bool short __a, signed int __b, vector bool short * __c) __asm__("__IBMBuiltin_vec_st_vVBsiVBsA");

void __ATTRS_o_ai
vec_stvx(vector bool short __a, signed int __b, unsigned short * __c) __asm__("__IBMBuiltin_vec_st_vVBsisA");

void __ATTRS_o_ai
vec_stvx(vector bool short __a, signed int __b, signed short * __c) __asm__("__IBMBuiltin_vec_st_vVBsisA");

void __ATTRS_o_ai
vec_stvx(vector pixel __a, signed int __b, vector pixel * __c) __asm__("__IBMBuiltin_vec_st_vVpiVpA");

void __ATTRS_o_ai
vec_stvx(vector pixel __a, signed int __b, unsigned short * __c) __asm__("__IBMBuiltin_vec_st_vVpisA");

void __ATTRS_o_ai
vec_stvx(vector pixel __a, signed int __b, signed short * __c) __asm__("__IBMBuiltin_vec_st_vVpisA");

void __ATTRS_o_ai
vec_stvx(vector unsigned int __a, signed int __b, vector unsigned int * __c) __asm__("__IBMBuiltin_vec_st_vVUiiVUiA");

void __ATTRS_o_ai
vec_stvx(vector unsigned int __a, signed int __b, unsigned int * __c) __asm__("__IBMBuiltin_vec_st_vVUiiiA");

void __ATTRS_o_ai
vec_stvx(vector unsigned int __a, signed int __b, unsigned long * __c) __asm__("__IBMBuiltin_vec_st_vVUiilA");

void __ATTRS_o_ai
vec_stvx(vector signed int __a, signed int __b, vector signed int * __c) __asm__("__IBMBuiltin_vec_st_vVSiiVSiA");

void __ATTRS_o_ai
vec_stvx(vector signed int __a, signed int __b, signed int * __c) __asm__("__IBMBuiltin_vec_st_vVSiiiA");

void __ATTRS_o_ai
vec_stvx(vector signed int __a, signed int __b, signed long * __c) __asm__("__IBMBuiltin_vec_st_vVSiilA");

void __ATTRS_o_ai
vec_stvx(vector bool int __a, signed int __b, vector bool int * __c) __asm__("__IBMBuiltin_vec_st_vVBiiVBiA");

void __ATTRS_o_ai
vec_stvx(vector bool int __a, signed int __b, unsigned int * __c) __asm__("__IBMBuiltin_vec_st_vVBiiiA");

void __ATTRS_o_ai
vec_stvx(vector bool int __a, signed int __b, unsigned long * __c) __asm__("__IBMBuiltin_vec_st_vVBiilA");

void __ATTRS_o_ai
vec_stvx(vector bool int __a, signed int __b, signed int * __c) __asm__("__IBMBuiltin_vec_st_vVBiiiA");

void __ATTRS_o_ai
vec_stvx(vector bool int __a, signed int __b, signed long * __c) __asm__("__IBMBuiltin_vec_st_vVBiilA");

void __ATTRS_o_ai
vec_stvx(vector float __a, signed int __b, vector float * __c) __asm__("__IBMBuiltin_vec_st_vVfiVfA");

void __ATTRS_o_ai
vec_stvx(vector float __a, signed int __b, float * __c) __asm__("__IBMBuiltin_vec_st_vVfifA");

void __ATTRS_o_ai
vec_ste(vector unsigned char __a, signed int __b, unsigned char * __c) __asm__("__IBMBuiltin_vec_ste_b_vVUcicA");

void __ATTRS_o_ai
vec_ste(vector signed char __a, signed int __b, signed char * __c) __asm__("__IBMBuiltin_vec_ste_b_vVScicA");

void __ATTRS_o_ai
vec_ste(vector bool char __a, signed int __b, unsigned char * __c) __asm__("__IBMBuiltin_vec_ste_b_vVBcicA");

void __ATTRS_o_ai
vec_ste(vector bool char __a, signed int __b, signed char * __c) __asm__("__IBMBuiltin_vec_ste_b_vVBcicA");

void __ATTRS_o_ai
vec_ste(vector unsigned short __a, signed int __b, unsigned short * __c) __asm__("__IBMBuiltin_vec_ste_h_vVUsisA");

void __ATTRS_o_ai
vec_ste(vector signed short __a, signed int __b, signed short * __c) __asm__("__IBMBuiltin_vec_ste_h_vVSsisA");

void __ATTRS_o_ai
vec_ste(vector bool short __a, signed int __b, unsigned short * __c) __asm__("__IBMBuiltin_vec_ste_h_vVBsisA");

void __ATTRS_o_ai
vec_ste(vector bool short __a, signed int __b, signed short * __c) __asm__("__IBMBuiltin_vec_ste_h_vVBsisA");

void __ATTRS_o_ai
vec_ste(vector pixel __a, signed int __b, unsigned short * __c) __asm__("__IBMBuiltin_vec_ste_h_vVpisA");

void __ATTRS_o_ai
vec_ste(vector pixel __a, signed int __b, signed short * __c) __asm__("__IBMBuiltin_vec_ste_h_vVpisA");

void __ATTRS_o_ai
vec_ste(vector unsigned int __a, signed int __b, unsigned int * __c) __asm__("__IBMBuiltin_vec_ste_w_vVUiiiA");

void __ATTRS_o_ai
vec_ste(vector unsigned int __a, signed int __b, unsigned long * __c) __asm__("__IBMBuiltin_vec_ste_w_vVUiilA");

void __ATTRS_o_ai
vec_ste(vector signed int __a, signed int __b, signed int * __c) __asm__("__IBMBuiltin_vec_ste_w_vVSiiiA");

void __ATTRS_o_ai
vec_ste(vector signed int __a, signed int __b, signed long * __c) __asm__("__IBMBuiltin_vec_ste_w_vVSiilA");

void __ATTRS_o_ai
vec_ste(vector bool int __a, signed int __b, unsigned int * __c) __asm__("__IBMBuiltin_vec_ste_w_vVBiiiA");

void __ATTRS_o_ai
vec_ste(vector bool int __a, signed int __b, unsigned long * __c) __asm__("__IBMBuiltin_vec_ste_w_vVBiilA");

void __ATTRS_o_ai
vec_ste(vector bool int __a, signed int __b, signed int * __c) __asm__("__IBMBuiltin_vec_ste_w_vVBiiiA");

void __ATTRS_o_ai
vec_ste(vector bool int __a, signed int __b, signed long * __c) __asm__("__IBMBuiltin_vec_ste_w_vVBiilA");

void __ATTRS_o_ai
vec_ste(vector float __a, signed int __b, float * __c) __asm__("__IBMBuiltin_vec_ste_w_vVfifA");

void __ATTRS_o_ai
vec_stvehx(vector unsigned short __a, signed int __b, unsigned short * __c) __asm__("__IBMBuiltin_vec_ste_h_vVUsisA");

void __ATTRS_o_ai
vec_stvehx(vector signed short __a, signed int __b, signed short * __c) __asm__("__IBMBuiltin_vec_ste_h_vVSsisA");

void __ATTRS_o_ai
vec_stvehx(vector bool short __a, signed int __b, unsigned short * __c) __asm__("__IBMBuiltin_vec_ste_h_vVBsisA");

void __ATTRS_o_ai
vec_stvehx(vector bool short __a, signed int __b, signed short * __c) __asm__("__IBMBuiltin_vec_ste_h_vVBsisA");

void __ATTRS_o_ai
vec_stvehx(vector pixel __a, signed int __b, unsigned short * __c) __asm__("__IBMBuiltin_vec_ste_h_vVpisA");

void __ATTRS_o_ai
vec_stvehx(vector pixel __a, signed int __b, signed short * __c) __asm__("__IBMBuiltin_vec_ste_h_vVpisA");

void __ATTRS_o_ai
vec_stvewx(vector unsigned int __a, signed int __b, unsigned int * __c) __asm__("__IBMBuiltin_vec_ste_w_vVUiiiA");

void __ATTRS_o_ai
vec_stvewx(vector unsigned int __a, signed int __b, unsigned long * __c) __asm__("__IBMBuiltin_vec_ste_w_vVUiilA");

void __ATTRS_o_ai
vec_stvewx(vector signed int __a, signed int __b, signed int * __c) __asm__("__IBMBuiltin_vec_ste_w_vVSiiiA");

void __ATTRS_o_ai
vec_stvewx(vector signed int __a, signed int __b, signed long * __c) __asm__("__IBMBuiltin_vec_ste_w_vVSiilA");

void __ATTRS_o_ai
vec_stvewx(vector bool int __a, signed int __b, unsigned int * __c) __asm__("__IBMBuiltin_vec_ste_w_vVBiiiA");

void __ATTRS_o_ai
vec_stvewx(vector bool int __a, signed int __b, unsigned long * __c) __asm__("__IBMBuiltin_vec_ste_w_vVBiilA");

void __ATTRS_o_ai
vec_stvewx(vector bool int __a, signed int __b, signed int * __c) __asm__("__IBMBuiltin_vec_ste_w_vVBiiiA");

void __ATTRS_o_ai
vec_stvewx(vector bool int __a, signed int __b, signed long * __c) __asm__("__IBMBuiltin_vec_ste_w_vVBiilA");

void __ATTRS_o_ai
vec_stvewx(vector float __a, signed int __b, float * __c) __asm__("__IBMBuiltin_vec_ste_w_vVfifA");

void __ATTRS_o_ai
vec_stl(vector unsigned char __a, signed int __b, vector unsigned char * __c) __asm__("__IBMBuiltin_vec_stl_vVUciVUcA");

void __ATTRS_o_ai
vec_stl(vector unsigned char __a, signed int __b, unsigned char * __c) __asm__("__IBMBuiltin_vec_stl_vVUcicA");

void __ATTRS_o_ai
vec_stl(vector signed char __a, signed int __b, vector signed char * __c) __asm__("__IBMBuiltin_vec_stl_vVSciVScA");

void __ATTRS_o_ai
vec_stl(vector signed char __a, signed int __b, signed char * __c) __asm__("__IBMBuiltin_vec_stl_vVScicA");

void __ATTRS_o_ai
vec_stl(vector bool char __a, signed int __b, vector bool char * __c) __asm__("__IBMBuiltin_vec_stl_vVBciVBcA");

void __ATTRS_o_ai
vec_stl(vector bool char __a, signed int __b, unsigned char * __c) __asm__("__IBMBuiltin_vec_stl_vVBcicA");

void __ATTRS_o_ai
vec_stl(vector bool char __a, signed int __b, signed char * __c) __asm__("__IBMBuiltin_vec_stl_vVBcicA");

void __ATTRS_o_ai
vec_stl(vector unsigned short __a, signed int __b, vector unsigned short * __c) __asm__("__IBMBuiltin_vec_stl_vVUsiVUsA");

void __ATTRS_o_ai
vec_stl(vector unsigned short __a, signed int __b, unsigned short * __c) __asm__("__IBMBuiltin_vec_stl_vVUsisA");

void __ATTRS_o_ai
vec_stl(vector signed short __a, signed int __b, vector signed short * __c) __asm__("__IBMBuiltin_vec_stl_vVSsiVSsA");

void __ATTRS_o_ai
vec_stl(vector signed short __a, signed int __b, signed short * __c) __asm__("__IBMBuiltin_vec_stl_vVSsisA");

void __ATTRS_o_ai
vec_stl(vector bool short __a, signed int __b, vector bool short * __c) __asm__("__IBMBuiltin_vec_stl_vVBsiVBsA");

void __ATTRS_o_ai
vec_stl(vector bool short __a, signed int __b, unsigned short * __c) __asm__("__IBMBuiltin_vec_stl_vVBsisA");

void __ATTRS_o_ai
vec_stl(vector bool short __a, signed int __b, signed short * __c) __asm__("__IBMBuiltin_vec_stl_vVBsisA");

void __ATTRS_o_ai
vec_stl(vector pixel __a, signed int __b, vector pixel * __c) __asm__("__IBMBuiltin_vec_stl_vVpiVpA");

void __ATTRS_o_ai
vec_stl(vector pixel __a, signed int __b, unsigned short * __c) __asm__("__IBMBuiltin_vec_stl_vVpisA");

void __ATTRS_o_ai
vec_stl(vector pixel __a, signed int __b, signed short * __c) __asm__("__IBMBuiltin_vec_stl_vVpisA");

void __ATTRS_o_ai
vec_stl(vector unsigned int __a, signed int __b, vector unsigned int * __c) __asm__("__IBMBuiltin_vec_stl_vVUiiVUiA");

void __ATTRS_o_ai
vec_stl(vector unsigned int __a, signed int __b, unsigned int * __c) __asm__("__IBMBuiltin_vec_stl_vVUiiiA");

void __ATTRS_o_ai
vec_stl(vector unsigned int __a, signed int __b, unsigned long * __c) __asm__("__IBMBuiltin_vec_stl_vVUiilA");

void __ATTRS_o_ai
vec_stl(vector signed int __a, signed int __b, vector signed int * __c) __asm__("__IBMBuiltin_vec_stl_vVSiiVSiA");

void __ATTRS_o_ai
vec_stl(vector signed int __a, signed int __b, signed int * __c) __asm__("__IBMBuiltin_vec_stl_vVSiiiA");

void __ATTRS_o_ai
vec_stl(vector signed int __a, signed int __b, signed long * __c) __asm__("__IBMBuiltin_vec_stl_vVSiilA");

void __ATTRS_o_ai
vec_stl(vector bool int __a, signed int __b, vector bool int * __c) __asm__("__IBMBuiltin_vec_stl_vVBiiVBiA");

void __ATTRS_o_ai
vec_stl(vector bool int __a, signed int __b, unsigned int * __c) __asm__("__IBMBuiltin_vec_stl_vVBiiiA");

void __ATTRS_o_ai
vec_stl(vector bool int __a, signed int __b, unsigned long * __c) __asm__("__IBMBuiltin_vec_stl_vVBiilA");

void __ATTRS_o_ai
vec_stl(vector bool int __a, signed int __b, signed int * __c) __asm__("__IBMBuiltin_vec_stl_vVBiiiA");

void __ATTRS_o_ai
vec_stl(vector bool int __a, signed int __b, signed long * __c) __asm__("__IBMBuiltin_vec_stl_vVBiilA");

void __ATTRS_o_ai
vec_stl(vector float __a, signed int __b, vector float * __c) __asm__("__IBMBuiltin_vec_stl_vVfiVfA");

void __ATTRS_o_ai
vec_stl(vector float __a, signed int __b, float * __c) __asm__("__IBMBuiltin_vec_stl_vVfifA");

void __ATTRS_o_ai
vec_stvxl(vector unsigned char __a, signed int __b, vector unsigned char * __c) __asm__("__IBMBuiltin_vec_stl_vVUciVUcA");

void __ATTRS_o_ai
vec_stvxl(vector unsigned char __a, signed int __b, unsigned char * __c) __asm__("__IBMBuiltin_vec_stl_vVUcicA");

void __ATTRS_o_ai
vec_stvxl(vector signed char __a, signed int __b, vector signed char * __c) __asm__("__IBMBuiltin_vec_stl_vVSciVScA");

void __ATTRS_o_ai
vec_stvxl(vector signed char __a, signed int __b, signed char * __c) __asm__("__IBMBuiltin_vec_stl_vVScicA");

void __ATTRS_o_ai
vec_stvxl(vector bool char __a, signed int __b, vector bool char * __c) __asm__("__IBMBuiltin_vec_stl_vVBciVBcA");

void __ATTRS_o_ai
vec_stvxl(vector bool char __a, signed int __b, unsigned char * __c) __asm__("__IBMBuiltin_vec_stl_vVBcicA");

void __ATTRS_o_ai
vec_stvxl(vector bool char __a, signed int __b, signed char * __c) __asm__("__IBMBuiltin_vec_stl_vVBcicA");

void __ATTRS_o_ai
vec_stvxl(vector unsigned short __a, signed int __b, vector unsigned short * __c) __asm__("__IBMBuiltin_vec_stl_vVUsiVUsA");

void __ATTRS_o_ai
vec_stvxl(vector unsigned short __a, signed int __b, unsigned short * __c) __asm__("__IBMBuiltin_vec_stl_vVUsisA");

void __ATTRS_o_ai
vec_stvxl(vector signed short __a, signed int __b, vector signed short * __c) __asm__("__IBMBuiltin_vec_stl_vVSsiVSsA");

void __ATTRS_o_ai
vec_stvxl(vector signed short __a, signed int __b, signed short * __c) __asm__("__IBMBuiltin_vec_stl_vVSsisA");

void __ATTRS_o_ai
vec_stvxl(vector bool short __a, signed int __b, vector bool short * __c) __asm__("__IBMBuiltin_vec_stl_vVBsiVBsA");

void __ATTRS_o_ai
vec_stvxl(vector bool short __a, signed int __b, unsigned short * __c) __asm__("__IBMBuiltin_vec_stl_vVBsisA");

void __ATTRS_o_ai
vec_stvxl(vector bool short __a, signed int __b, signed short * __c) __asm__("__IBMBuiltin_vec_stl_vVBsisA");

void __ATTRS_o_ai
vec_stvxl(vector pixel __a, signed int __b, vector pixel * __c) __asm__("__IBMBuiltin_vec_stl_vVpiVpA");

void __ATTRS_o_ai
vec_stvxl(vector pixel __a, signed int __b, unsigned short * __c) __asm__("__IBMBuiltin_vec_stl_vVpisA");

void __ATTRS_o_ai
vec_stvxl(vector pixel __a, signed int __b, signed short * __c) __asm__("__IBMBuiltin_vec_stl_vVpisA");

void __ATTRS_o_ai
vec_stvxl(vector unsigned int __a, signed int __b, vector unsigned int * __c) __asm__("__IBMBuiltin_vec_stl_vVUiiVUiA");

void __ATTRS_o_ai
vec_stvxl(vector unsigned int __a, signed int __b, unsigned int * __c) __asm__("__IBMBuiltin_vec_stl_vVUiiiA");

void __ATTRS_o_ai
vec_stvxl(vector unsigned int __a, signed int __b, unsigned long * __c) __asm__("__IBMBuiltin_vec_stl_vVUiilA");

void __ATTRS_o_ai
vec_stvxl(vector signed int __a, signed int __b, vector signed int * __c) __asm__("__IBMBuiltin_vec_stl_vVSiiVSiA");

void __ATTRS_o_ai
vec_stvxl(vector signed int __a, signed int __b, signed int * __c) __asm__("__IBMBuiltin_vec_stl_vVSiiiA");

void __ATTRS_o_ai
vec_stvxl(vector signed int __a, signed int __b, signed long * __c) __asm__("__IBMBuiltin_vec_stl_vVSiilA");

void __ATTRS_o_ai
vec_stvxl(vector bool int __a, signed int __b, vector bool int * __c) __asm__("__IBMBuiltin_vec_stl_vVBiiVBiA");

void __ATTRS_o_ai
vec_stvxl(vector bool int __a, signed int __b, unsigned int * __c) __asm__("__IBMBuiltin_vec_stl_vVBiiiA");

void __ATTRS_o_ai
vec_stvxl(vector bool int __a, signed int __b, unsigned long * __c) __asm__("__IBMBuiltin_vec_stl_vVBiilA");

void __ATTRS_o_ai
vec_stvxl(vector bool int __a, signed int __b, signed int * __c) __asm__("__IBMBuiltin_vec_stl_vVBiiiA");

void __ATTRS_o_ai
vec_stvxl(vector bool int __a, signed int __b, signed long * __c) __asm__("__IBMBuiltin_vec_stl_vVBiilA");

void __ATTRS_o_ai
vec_stvxl(vector float __a, signed int __b, vector float * __c) __asm__("__IBMBuiltin_vec_stl_vVfiVfA");

void __ATTRS_o_ai
vec_stvxl(vector float __a, signed int __b, float * __c) __asm__("__IBMBuiltin_vec_stl_vVfifA");

vector unsigned char __ATTRS_o_ai
vec_sub(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sub_VUcVUcVUc");

vector unsigned char __ATTRS_o_ai
vec_sub(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_sub_VUcVUcVBc");

vector unsigned char __ATTRS_o_ai
vec_sub(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sub_VUcVBcVUc");

vector signed char __ATTRS_o_ai
vec_sub(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_sub_VScVScVSc");

vector signed char __ATTRS_o_ai
vec_sub(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_sub_VScVScVBc");

vector signed char __ATTRS_o_ai
vec_sub(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_sub_VScVBcVSc");

vector unsigned short __ATTRS_o_ai
vec_sub(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sub_VUsVUsVUs");

vector unsigned short __ATTRS_o_ai
vec_sub(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_sub_VUsVUsVBs");

vector unsigned short __ATTRS_o_ai
vec_sub(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sub_VUsVBsVUs");

vector signed short __ATTRS_o_ai
vec_sub(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_sub_VSsVSsVSs");

vector signed short __ATTRS_o_ai
vec_sub(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_sub_VSsVSsVBs");

vector signed short __ATTRS_o_ai
vec_sub(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_sub_VSsVBsVSs");

vector unsigned int __ATTRS_o_ai
vec_sub(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sub_VUiVUiVUi");

vector unsigned int __ATTRS_o_ai
vec_sub(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_sub_VUiVUiVBi");

vector unsigned int __ATTRS_o_ai
vec_sub(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sub_VUiVBiVUi");

vector signed int __ATTRS_o_ai
vec_sub(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_sub_VSiVSiVSi");

vector signed int __ATTRS_o_ai
vec_sub(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_sub_VSiVSiVBi");

vector signed int __ATTRS_o_ai
vec_sub(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_sub_VSiVBiVSi");

vector float __ATTRS_o_ai
vec_sub(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_sub_VfVfVf");

vector unsigned char __ATTRS_o_ai
vec_vsububm(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sub_VUcVUcVUc");

vector unsigned char __ATTRS_o_ai
vec_vsububm(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_sub_VUcVUcVBc");

vector unsigned char __ATTRS_o_ai
vec_vsububm(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sub_VUcVBcVUc");

vector signed char __ATTRS_o_ai
vec_vsububm(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_sub_VScVScVSc");

vector signed char __ATTRS_o_ai
vec_vsububm(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_sub_VScVScVBc");

vector signed char __ATTRS_o_ai
vec_vsububm(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_sub_VScVBcVSc");

vector unsigned short __ATTRS_o_ai
vec_vsubuhm(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sub_VUsVUsVUs");

vector unsigned short __ATTRS_o_ai
vec_vsubuhm(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_sub_VUsVUsVBs");

vector unsigned short __ATTRS_o_ai
vec_vsubuhm(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sub_VUsVBsVUs");

vector signed short __ATTRS_o_ai
vec_vsubuhm(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_sub_VSsVSsVSs");

vector signed short __ATTRS_o_ai
vec_vsubuhm(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_sub_VSsVSsVBs");

vector signed short __ATTRS_o_ai
vec_vsubuhm(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_sub_VSsVBsVSs");

vector unsigned int __ATTRS_o_ai
vec_vsubuwm(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sub_VUiVUiVUi");

vector unsigned int __ATTRS_o_ai
vec_vsubuwm(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_sub_VUiVUiVBi");

vector unsigned int __ATTRS_o_ai
vec_vsubuwm(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sub_VUiVBiVUi");

vector signed int __ATTRS_o_ai
vec_vsubuwm(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_sub_VSiVSiVSi");

vector signed int __ATTRS_o_ai
vec_vsubuwm(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_sub_VSiVSiVBi");

vector signed int __ATTRS_o_ai
vec_vsubuwm(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_sub_VSiVBiVSi");

vector float __attribute__((__always_inline__))
vec_vsubfp(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_sub_VfVfVf");

vector unsigned int __attribute__((__always_inline__))
vec_vsubcuw(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_subc_VUiVUiVUi");

vector unsigned char __ATTRS_o_ai
vec_subs(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_subs_VUcVUcVUc");

vector unsigned char __ATTRS_o_ai
vec_subs(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_subs_VUcVUcVBc");

vector unsigned char __ATTRS_o_ai
vec_subs(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_subs_VUcVBcVUc");

vector signed char __ATTRS_o_ai
vec_subs(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_subs_VScVScVSc");

vector signed char __ATTRS_o_ai
vec_subs(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_subs_VScVScVBc");

vector signed char __ATTRS_o_ai
vec_subs(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_subs_VScVBcVSc");

vector unsigned short __ATTRS_o_ai
vec_subs(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_subs_VUsVUsVUs");

vector unsigned short __ATTRS_o_ai
vec_subs(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_subs_VUsVUsVBs");

vector unsigned short __ATTRS_o_ai
vec_subs(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_subs_VUsVBsVUs");

vector signed short __ATTRS_o_ai
vec_subs(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_subs_VSsVSsVSs");

vector signed short __ATTRS_o_ai
vec_subs(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_subs_VSsVSsVBs");

vector signed short __ATTRS_o_ai
vec_subs(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_subs_VSsVBsVSs");

vector unsigned int __ATTRS_o_ai
vec_subs(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_subs_VUiVUiVUi");

vector unsigned int __ATTRS_o_ai
vec_subs(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_subs_VUiVUiVBi");

vector unsigned int __ATTRS_o_ai
vec_subs(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_subs_VUiVBiVUi");

vector signed int __ATTRS_o_ai
vec_subs(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_subs_VSiVSiVSi");

vector signed int __ATTRS_o_ai
vec_subs(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_subs_VSiVSiVBi");

vector signed int __ATTRS_o_ai
vec_subs(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_subs_VSiVBiVSi");

vector unsigned char __ATTRS_o_ai
vec_vsububs(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_subs_VUcVUcVUc");

vector unsigned char __ATTRS_o_ai
vec_vsububs(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_subs_VUcVUcVBc");

vector unsigned char __ATTRS_o_ai
vec_vsububs(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_subs_VUcVBcVUc");

vector signed char __ATTRS_o_ai
vec_vsubsbs(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_subs_VScVScVSc");

vector signed char __ATTRS_o_ai
vec_vsubsbs(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_subs_VScVScVBc");

vector signed char __ATTRS_o_ai
vec_vsubsbs(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_subs_VScVBcVSc");

vector unsigned short __ATTRS_o_ai
vec_vsubuhs(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_subs_VUsVUsVUs");

vector unsigned short __ATTRS_o_ai
vec_vsubuhs(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_subs_VUsVUsVBs");

vector unsigned short __ATTRS_o_ai
vec_vsubuhs(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_subs_VUsVBsVUs");

vector signed short __ATTRS_o_ai
vec_vsubshs(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_subs_VSsVSsVSs");

vector signed short __ATTRS_o_ai
vec_vsubshs(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_subs_VSsVSsVBs");

vector signed short __ATTRS_o_ai
vec_vsubshs(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_subs_VSsVBsVSs");

vector unsigned int __ATTRS_o_ai
vec_vsubuws(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_subs_VUiVUiVUi");

vector unsigned int __ATTRS_o_ai
vec_vsubuws(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_subs_VUiVUiVBi");

vector unsigned int __ATTRS_o_ai
vec_vsubuws(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_subs_VUiVBiVUi");

vector signed int __ATTRS_o_ai
vec_vsubsws(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_subs_VSiVSiVSi");

vector signed int __ATTRS_o_ai
vec_vsubsws(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_subs_VSiVSiVBi");

vector signed int __ATTRS_o_ai
vec_vsubsws(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_subs_VSiVBiVSi");

vector unsigned int __ATTRS_o_ai
vec_sum4s(vector unsigned char __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sum4s_VUiVUcVUi");

vector signed int __ATTRS_o_ai
vec_sum4s(vector signed char __a, vector signed int __b) __asm__("__IBMBuiltin_vec_sum4s_VSiVScVSi");

vector signed int __ATTRS_o_ai
vec_sum4s(vector signed short __a, vector signed int __b) __asm__("__IBMBuiltin_vec_sum4s_VSiVSsVSi");

vector unsigned int __attribute__((__always_inline__))
vec_vsum4ubs(vector unsigned char __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sum4s_VUiVUcVUi");

vector signed int __attribute__((__always_inline__))
vec_vsum4sbs(vector signed char __a, vector signed int __b) __asm__("__IBMBuiltin_vec_sum4s_VSiVScVSi");

vector signed int __attribute__((__always_inline__))
vec_vsum4shs(vector signed short __a, vector signed int __b) __asm__("__IBMBuiltin_vec_sum4s_VSiVSsVSi");

vector signed int __attribute__((__always_inline__))
vec_sum2s(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_sum2s_VSiVSiVSi");

vector signed int __attribute__((__always_inline__))
vec_vsum2sws(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_sum2s_VSiVSiVSi");

vector signed int __attribute__((__always_inline__))
vec_sums(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_sums_VSiVSiVSi");

vector signed int __attribute__((__always_inline__))
vec_vsumsws(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_sums_VSiVSiVSi");
// P9 vec_test_data_class
vector bool long long __ATTRS_o_ai
vec_test_data_class (vector double,const int) __asm__ ("__IBMBuiltin_vec_test_data_class_VBlVdiC");

vector bool int __ATTRS_o_ai
vec_test_data_class (vector float, const int) __asm__ ("__IBMBuiltin_vec_test_data_class_VBiVfiC");
// P9 vec_test_data_class end
vector float __ATTRS_o_ai
vec_trunc(vector float __a) __asm__("__IBMBuiltin_vec_trunc_VfVf");

vector float __attribute__((__always_inline__))
vec_vrfiz(vector float __a) __asm__("__IBMBuiltin_vec_trunc_VfVf");

vector signed short __ATTRS_o_ai
vec_unpackh(vector signed char __a) __asm__("__IBMBuiltin_vec_unpackh_VSsVSc");

vector bool short __ATTRS_o_ai
vec_unpackh(vector bool char __a) __asm__("__IBMBuiltin_vec_unpackh_VBsVBc");

vector unsigned int __ATTRS_o_ai
vec_unpackh(vector pixel __a) __asm__("__IBMBuiltin_vec_unpackhp_VUiVp");

vector signed int __ATTRS_o_ai
vec_unpackh(vector signed short __a) __asm__("__IBMBuiltin_vec_unpackh_VSiVSs");

vector bool int __ATTRS_o_ai
vec_unpackh(vector bool short __a) __asm__("__IBMBuiltin_vec_unpackh_VBiVBs");

vector signed short __ATTRS_o_ai
vec_vupkhsb(vector signed char __a) __asm__("__IBMBuiltin_vec_unpackh_VSsVSc");

vector bool short __ATTRS_o_ai
vec_vupkhsb(vector bool char __a) __asm__("__IBMBuiltin_vec_unpackh_VBsVBc");

vector unsigned int __attribute__((__always_inline__))
vec_vupkhpx(vector pixel __a) __asm__("__IBMBuiltin_vec_unpackhp_VUiVp");

vector signed int __ATTRS_o_ai
vec_vupkhsh(vector signed short __a) __asm__("__IBMBuiltin_vec_unpackh_VSiVSs");

vector bool int __ATTRS_o_ai
vec_vupkhsh(vector bool short __a) __asm__("__IBMBuiltin_vec_unpackh_VBiVBs");

vector signed short __ATTRS_o_ai
vec_unpackl(vector signed char __a) __asm__("__IBMBuiltin_vec_unpackl_VSsVSc");

vector bool short __ATTRS_o_ai
vec_unpackl(vector bool char __a) __asm__("__IBMBuiltin_vec_unpackl_VBsVBc");

vector unsigned int __ATTRS_o_ai
vec_unpackl(vector pixel __a) __asm__("__IBMBuiltin_vec_unpacklp_VUiVp");

vector signed int __ATTRS_o_ai
vec_unpackl(vector signed short __a) __asm__("__IBMBuiltin_vec_unpackl_VSiVSs");

vector bool int __ATTRS_o_ai
vec_unpackl(vector bool short __a) __asm__("__IBMBuiltin_vec_unpackl_VBiVBs");

vector signed short __ATTRS_o_ai
vec_vupklsb(vector signed char __a) __asm__("__IBMBuiltin_vec_unpackl_VSsVSc");

vector bool short __ATTRS_o_ai
vec_vupklsb(vector bool char __a) __asm__("__IBMBuiltin_vec_unpackl_VBsVBc");

vector unsigned int __attribute__((__always_inline__))
vec_vupklpx(vector pixel __a) __asm__("__IBMBuiltin_vec_unpacklp_VUiVp");

vector signed int __ATTRS_o_ai
vec_vupklsh(vector signed short __a) __asm__("__IBMBuiltin_vec_unpackl_VSiVSs");

vector bool int __ATTRS_o_ai
vec_vupklsh(vector bool short __a) __asm__("__IBMBuiltin_vec_unpackl_VBiVBs");
// P9 vec_xl_len
vector signed char __ATTRS_o_ai
vec_xl_len (signed char *, size_t) __asm__ ("__IBMBuiltin_vec_xl_len_VScScAi");

vector unsigned char __ATTRS_o_ai
vec_xl_len (unsigned char *, size_t) __asm__ ("__IBMBuiltin_vec_xl_len_VUcUcAi");

vector signed int __ATTRS_o_ai
vec_xl_len (signed int *, size_t) __asm__ ("__IBMBuiltin_vec_xl_len_VSiSiAi");

vector unsigned int __ATTRS_o_ai
vec_xl_len (unsigned int *, size_t) __asm__ ("__IBMBuiltin_vec_xl_len_VUiUiAi");

vector signed long long __ATTRS_o_ai
vec_xl_len (signed long long *, size_t) __asm__ ("__IBMBuiltin_vec_xl_len_VSllSllAi");

vector unsigned long long __ATTRS_o_ai
vec_xl_len (unsigned long long *, size_t) __asm__ ("__IBMBuiltin_vec_xl_len_VUllUllAi");

vector signed short __ATTRS_o_ai
vec_xl_len (signed short *, size_t) __asm__ ("__IBMBuiltin_vec_xl_len_VSsSsAi");

vector unsigned short __ATTRS_o_ai
vec_xl_len (unsigned short *, size_t) __asm__ ("__IBMBuiltin_vec_xl_len_VUsUsAi");

vector double __ATTRS_o_ai
vec_xl_len (double *, size_t) __asm__ ("__IBMBuiltin_vec_xl_len_VddAi");

vector float __ATTRS_o_ai
vec_xl_len (float *, size_t) __asm__ ("__IBMBuiltin_vec_xl_len_VffAi");
// P9 vec_xl_len end

// P9 vec_xst_zeroing
vector signed char __ATTRS_o_ai
vec_xl_zeroing(signed long __a, const signed char * __b) __asm__("__IBMBuiltin___vec_xl_zeroing_VSclcAC");

vector unsigned char __ATTRS_o_ai
vec_xl_zeroing(signed long __a, const unsigned char * __b) __asm__("__IBMBuiltin___vec_xl_zeroing_VUclUcAC");

vector signed short __ATTRS_o_ai
vec_xl_zeroing(signed long __a, const signed short * __b) __asm__("__IBMBuiltin___vec_xl_zeroing_VSslsAC");

vector unsigned short __ATTRS_o_ai
vec_xl_zeroing(signed long __a, const unsigned short * __b) __asm__("__IBMBuiltin___vec_xl_zeroing_VUslUsAC");
// P9 vec_xl_zeroing end
#if defined(__LITTLE_ENDIAN__)
// P9 vec_xl_zeroing_be
vector signed char __ATTRS_o_ai
vec_xl_zeroing_be(signed long __a, const signed char * __b) __asm__("__IBMBuiltin___vec_xl_zeroing_be_VSclcAC");

vector unsigned char __ATTRS_o_ai
vec_xl_zeroing_be(signed long __a, const unsigned char * __b) __asm__("__IBMBuiltin___vec_xl_zeroing_be_VUclUcAC");

vector signed short __ATTRS_o_ai
vec_xl_zeroing_be(signed long __a, const signed short * __b) __asm__("__IBMBuiltin___vec_xl_zeroing_be_VSslsAC");

vector unsigned short __ATTRS_o_ai
vec_xl_zeroing_be(signed long __a, const unsigned short * __b) __asm__("__IBMBuiltin___vec_xl_zeroing_be_VUslUsAC");
// P9 vec_xl_zeroing_be end
#endif

// P9 vec_xst_zeroing
void __ATTRS_o_ai
vec_xst_zeroing(vector signed char __a, signed long __b, const signed char * __c) __asm__("__IBMBuiltin___vec_xst_zeroing_vVSclcAC");

void __ATTRS_o_ai
vec_xst_zeroing(vector unsigned char __a, signed long __b, const unsigned char * __c) __asm__("__IBMBuiltin___vec_xst_zeroing_vVUclUcAC");

void __ATTRS_o_ai
vec_xst_zeroing(vector signed short __a, signed long __b, const signed short * __c) __asm__("__IBMBuiltin___vec_xst_zeroing_vVSslsAC");

void __ATTRS_o_ai
vec_xst_zeroing(vector unsigned short __a, signed long __b, const unsigned short * __c) __asm__("__IBMBuiltin___vec_xst_zeroing_vVUslUsAC");
// P9 vec_xst_zeroing end
#if defined(__LITTLE_ENDIAN__)
// P9 vec_xst_zeroing_be
void __ATTRS_o_ai
vec_xst_zeroing_be(vector signed char __a, signed long __b, const signed char * __c) __asm__("__IBMBuiltin___vec_xst_zeroing_be_vVSclcAC");

void __ATTRS_o_ai
vec_xst_zeroing_be(vector unsigned char __a, signed long __b, const unsigned char * __c) __asm__("__IBMBuiltin___vec_xst_zeroing_be_vVUclUcAC");

void __ATTRS_o_ai
vec_xst_zeroing_be(vector signed short __a, signed long __b, const signed short * __c) __asm__("__IBMBuiltin___vec_xst_zeroing_be_vVSslsAC");

void __ATTRS_o_ai
vec_xst_zeroing_be(vector unsigned short __a, signed long __b, const unsigned short * __c) __asm__("__IBMBuiltin___vec_xst_zeroing_be_vVUslUsAC");
// P9 vec_xst_zeroing_be end
#endif

vector unsigned char __ATTRS_o_ai
vec_xor(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_xor_VUcVUcVUc");

vector unsigned char __ATTRS_o_ai
vec_xor(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_xor_VUcVUcVBc");

vector unsigned char __ATTRS_o_ai
vec_xor(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_xor_VUcVBcVUc");

vector signed char __ATTRS_o_ai
vec_xor(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_xor_VScVScVSc");

vector signed char __ATTRS_o_ai
vec_xor(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_xor_VScVScVBc");

vector signed char __ATTRS_o_ai
vec_xor(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_xor_VScVBcVSc");

vector bool char __ATTRS_o_ai
vec_xor(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_xor_VBcVBcVBc");

vector unsigned short __ATTRS_o_ai
vec_xor(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_xor_VUsVUsVUs");

vector unsigned short __ATTRS_o_ai
vec_xor(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_xor_VUsVUsVBs");

vector unsigned short __ATTRS_o_ai
vec_xor(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_xor_VUsVBsVUs");

vector signed short __ATTRS_o_ai
vec_xor(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_xor_VSsVSsVSs");

vector signed short __ATTRS_o_ai
vec_xor(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_xor_VSsVSsVBs");

vector signed short __ATTRS_o_ai
vec_xor(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_xor_VSsVBsVSs");

vector bool short __ATTRS_o_ai
vec_xor(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_xor_VBsVBsVBs");

vector unsigned int __ATTRS_o_ai
vec_xor(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_xor_VUiVUiVUi");

vector unsigned int __ATTRS_o_ai
vec_xor(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_xor_VUiVUiVBi");

vector unsigned int __ATTRS_o_ai
vec_xor(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_xor_VUiVBiVUi");

vector signed int __ATTRS_o_ai
vec_xor(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_xor_VSiVSiVSi");

vector signed int __ATTRS_o_ai
vec_xor(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_xor_VSiVSiVBi");

vector signed int __ATTRS_o_ai
vec_xor(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_xor_VSiVBiVSi");

vector bool int __ATTRS_o_ai
vec_xor(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_xor_VBiVBiVBi");

vector float __ATTRS_o_ai
vec_xor(vector bool int __a, vector float __b) __asm__("__IBMBuiltin_vec_xor_VfVBiVf");

vector float __ATTRS_o_ai
vec_xor(vector float __a, vector bool int __b) __asm__("__IBMBuiltin_vec_xor_VfVfVBi");

vector float __ATTRS_o_ai
vec_xor(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_xor_VfVfVf");

vector unsigned char __ATTRS_o_ai
vec_vxor(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_xor_VUcVUcVUc");

vector unsigned char __ATTRS_o_ai
vec_vxor(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_xor_VUcVUcVBc");

vector unsigned char __ATTRS_o_ai
vec_vxor(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_xor_VUcVBcVUc");

vector signed char __ATTRS_o_ai
vec_vxor(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_xor_VScVScVSc");

vector signed char __ATTRS_o_ai
vec_vxor(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_xor_VScVScVBc");

vector signed char __ATTRS_o_ai
vec_vxor(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_xor_VScVBcVSc");

vector bool char __ATTRS_o_ai
vec_vxor(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_xor_VBcVBcVBc");

vector unsigned short __ATTRS_o_ai
vec_vxor(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_xor_VUsVUsVUs");

vector unsigned short __ATTRS_o_ai
vec_vxor(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_xor_VUsVUsVBs");

vector unsigned short __ATTRS_o_ai
vec_vxor(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_xor_VUsVBsVUs");

vector signed short __ATTRS_o_ai
vec_vxor(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_xor_VSsVSsVSs");

vector signed short __ATTRS_o_ai
vec_vxor(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_xor_VSsVSsVBs");

vector signed short __ATTRS_o_ai
vec_vxor(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_xor_VSsVBsVSs");

vector bool short __ATTRS_o_ai
vec_vxor(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_xor_VBsVBsVBs");

vector unsigned int __ATTRS_o_ai
vec_vxor(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_xor_VUiVUiVUi");

vector unsigned int __ATTRS_o_ai
vec_vxor(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_xor_VUiVUiVBi");

vector unsigned int __ATTRS_o_ai
vec_vxor(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_xor_VUiVBiVUi");

vector signed int __ATTRS_o_ai
vec_vxor(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_xor_VSiVSiVSi");

vector signed int __ATTRS_o_ai
vec_vxor(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_xor_VSiVSiVBi");

vector signed int __ATTRS_o_ai
vec_vxor(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_xor_VSiVBiVSi");

vector bool int __ATTRS_o_ai
vec_vxor(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_xor_VBiVBiVBi");

vector float __ATTRS_o_ai
vec_vxor(vector bool int __a, vector float __b) __asm__("__IBMBuiltin_vec_xor_VfVBiVf");

vector float __ATTRS_o_ai
vec_vxor(vector float __a, vector bool int __b) __asm__("__IBMBuiltin_vec_xor_VfVfVBi");

vector float __ATTRS_o_ai
vec_vxor(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_xor_VfVfVf");
// P9 vec_xst_len
void __ATTRS_o_ai
vec_xst_len (vector signed char, signed char *, size_t) __asm__ ("__IBMBuiltin_vec_xst_len_vVScScAi");

void __ATTRS_o_ai
vec_xst_len (vector unsigned char, unsigned char *, size_t) __asm__ ("__IBMBuiltin_vec_xst_len_vVUcUcAi");

void __ATTRS_o_ai
vec_xst_len (vector signed int, signed int *, size_t) __asm__ ("__IBMBuiltin_vec_xst_len_vVSiSiAi");

void __ATTRS_o_ai
vec_xst_len (vector unsigned int, unsigned int *, size_t) __asm__ ("__IBMBuiltin_vec_xst_len_vVUiUiAi");

void __ATTRS_o_ai
vec_xst_len (vector signed long long, signed long long *, size_t) __asm__ ("__IBMBuiltin_vec_xst_len_vVSllSllAi");

void __ATTRS_o_ai
vec_xst_len (vector unsigned long long, unsigned long long *, size_t) __asm__ ("__IBMBuiltin_vec_xst_len_vVUllUllAi");

void __ATTRS_o_ai
vec_xst_len (vector signed short, signed short *, size_t) __asm__ ("__IBMBuiltin_vec_xst_len_vVSsSsAi");

void __ATTRS_o_ai
vec_xst_len (vector unsigned short, unsigned short *, size_t) __asm__ ("__IBMBuiltin_vec_xst_len_vVUsUsAi");

void __ATTRS_o_ai
vec_xst_len (vector double, double *, size_t) __asm__ ("__IBMBuiltin_vec_xst_len_vVddAi");

void __ATTRS_o_ai
vec_xst_len (vector float, float *, size_t) __asm__ ("__IBMBuiltin_vec_xst_len_vVffAi");
// P9 vec_slv
vector unsigned char __ATTRS_o_ai
vec_slv (vector unsigned char, vector unsigned char) __asm__ ("__IBMBuiltin_vec_slv_VUcVUcVUc");
// P9 vec_slv end

// P9 vec_srv
vector unsigned char __ATTRS_o_ai
vec_srv (vector unsigned char, vector unsigned char) __asm__ ("__IBMBuiltin_vec_srv_VUcVUcVUc");
// P9 vec_slv end

// P9 vec_extsbw
vector signed int __ATTRS_o_ai
vec_extsbw (vector signed char) __asm__ ("__IBMBuiltin_vec_extsbw_VSiVSc");

vector signed int __ATTRS_o_ai
vec_extsbw (vector unsigned char) __asm__ ("__IBMBuiltin_vec_extsbw_VSiVUc");
// P9 vec_extsbw end

// P9 vec_extshw
vector signed int __ATTRS_o_ai
vec_extshw (vector signed short) __asm__ ("__IBMBuiltin_vec_extshw_VSiVSs");

vector signed int __ATTRS_o_ai
vec_extshw (vector unsigned short) __asm__ ("__IBMBuiltin_vec_extshw_VSiVUs");
// P9 vec_extshw end

// P9 vec_extsbd
vector signed long long __ATTRS_o_ai
vec_extsbd (vector signed char) __asm__ ("__IBMBuiltin_vec_extsbd_VSlVSc");

vector signed long long __ATTRS_o_ai
vec_extsbd (vector unsigned char) __asm__ ("__IBMBuiltin_vec_extsbd_VSlVUc");
// P9 vec_extsbd end

// P9 vec_extshd
vector signed long long __ATTRS_o_ai
vec_extshd (vector signed short) __asm__ ("__IBMBuiltin_vec_extshd_VSlVSs");

vector signed long long __ATTRS_o_ai
vec_extshd (vector unsigned short) __asm__ ("__IBMBuiltin_vec_extshd_VSlVUs");
// P9 vec_extshd end

// P9 vec_extswd
vector signed long long __ATTRS_o_ai
vec_extswd (vector signed int) __asm__ ("__IBMBuiltin_vec_extswd_VSlVSi");

vector signed long long __ATTRS_o_ai
vec_extswd (vector unsigned int) __asm__ ("__IBMBuiltin_vec_extswd_VSlVUi");
// P9 vec_extswd end

// P9 vec_load_splats
vector signed int __ATTRS_o_ai
vec_load_splats (long long, signed int*) __asm__ ("__IBMBuiltin_vec_load_splats_VSiliA");

vector unsigned int __ATTRS_o_ai
vec_load_splats (long long, unsigned int*) __asm__ ("__IBMBuiltin_vec_load_splats_VUilUiA");

vector float __ATTRS_o_ai
vec_load_splats (long long, float*) __asm__ ("__IBMBuiltin_vec_load_splats_VflfA");

vector signed int __ATTRS_o_ai
vec_load_splats (unsigned long long, signed int*) __asm__ ("__IBMBuiltin_vec_load_splats_VSiUliA");

vector unsigned int __ATTRS_o_ai
vec_load_splats (unsigned long long, unsigned int*) __asm__ ("__IBMBuiltin_vec_load_splats_VUiUlUiA");

vector float __ATTRS_o_ai
vec_load_splats (unsigned long long, float*) __asm__ ("__IBMBuiltin_vec_load_splats_VfUlfA");
// P9 vec_load_splats end

// P9 vec_xst_len_r
void vec_xst_len_r (vector unsigned char, unsigned char*, size_t) __asm__ ("__IBMBuiltin_vec_xst_len_r_vVUcUcAi");
// P9 vec_xst_len_r end

// P9 vec_xl_len_r
vector unsigned char vec_xl_len_r (unsigned char *, size_t) __asm__ ("__IBMBuiltin_vec_xl_len_r_VUcUcAi");
// P9 vec_xl_len_r end

// P9 vec_xst_len_l
void vec_xst_len_l (vector unsigned char, unsigned char*, size_t) __asm__ ("__IBMBuiltin_vec_xst_len_l_vVUcUcAi");
// P9 vec_xst_len_r end

// P9 vec_xl_len_l
vector unsigned char vec_xl_len_l (unsigned char *, size_t) __asm__ ("__IBMBuiltin_vec_xl_len_l_VUcUcAi");
// P9 vec_xl_len_l end

signed int __ATTRS_o_ai
vec_all_eq(vector pixel __a, vector pixel __b) __asm__("__IBMBuiltin_vec_all_eq_iVpVp");

signed int __ATTRS_o_ai
vec_all_eq(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_all_eq_iVfVf");

signed int __ATTRS_o_ai
vec_all_ge(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_all_ge_iVfVf");

signed int __ATTRS_o_ai
vec_all_gt(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_all_gt_iVfVf");

signed int __attribute__((__always_inline__))
vec_all_in(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_all_in_iVfVf");

signed int __ATTRS_o_ai
vec_all_le(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_all_le_iVfVf");

signed int __ATTRS_o_ai
vec_all_lt(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_all_lt_iVfVf");

signed int __ATTRS_o_ai
vec_all_nan(vector float __a) __asm__("__IBMBuiltin_vec_all_nan_iVf");

signed int __ATTRS_o_ai
vec_all_ne(vector pixel __a, vector pixel __b) __asm__("__IBMBuiltin_vec_all_ne_iVpVp");

signed int __ATTRS_o_ai
vec_all_ne(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_all_ne_iVfVf");

signed int __ATTRS_o_ai
vec_all_nge(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_all_nge_iVfVf");

signed int __ATTRS_o_ai
vec_all_ngt(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_all_ngt_iVfVf");

signed int __ATTRS_o_ai
vec_all_nle(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_all_nle_iVfVf");

signed int __ATTRS_o_ai
vec_all_nlt(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_all_nlt_iVfVf");

signed int __ATTRS_o_ai
vec_all_numeric(vector float __a) __asm__("__IBMBuiltin_vec_all_numeric_iVf");

signed int __ATTRS_o_ai
vec_any_eq(vector pixel __a, vector pixel __b) __asm__("__IBMBuiltin_vec_any_eq_iVpVp");

signed int __ATTRS_o_ai
vec_any_eq(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_any_eq_iVfVf");

signed int __ATTRS_o_ai
vec_any_ge(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_any_ge_iVfVf");

signed int __ATTRS_o_ai
vec_any_gt(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_any_gt_iVfVf");

signed int __ATTRS_o_ai
vec_any_le(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_any_le_iVfVf");

signed int __ATTRS_o_ai
vec_any_lt(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_any_lt_iVfVf");

signed int __ATTRS_o_ai
vec_any_nan(vector float __a) __asm__("__IBMBuiltin_vec_any_nan_iVf");

signed int __ATTRS_o_ai
vec_any_ne(vector pixel __a, vector pixel __b) __asm__("__IBMBuiltin_vec_any_ne_iVpVp");

signed int __ATTRS_o_ai
vec_any_ne(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_any_ne_iVfVf");

signed int __ATTRS_o_ai
vec_any_nge(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_any_nge_iVfVf");

signed int __ATTRS_o_ai
vec_any_ngt(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_any_ngt_iVfVf");

signed int __ATTRS_o_ai
vec_any_nle(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_any_nle_iVfVf");

signed int __ATTRS_o_ai
vec_any_nlt(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_any_nlt_iVfVf");

signed int __ATTRS_o_ai
vec_any_numeric(vector float __a) __asm__("__IBMBuiltin_vec_any_numeric_iVf");

signed int __attribute__((__always_inline__))
vec_any_out(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_any_out_iVfVf");

vector unsigned char __ATTRS_o_ai
vec_lvx(signed long __a, const vector unsigned char * __b) __asm__("__IBMBuiltin_vec_ld_VUclVUcAC");

vector unsigned char __ATTRS_o_ai
vec_lvx(signed long __a, const unsigned char * __b) __asm__("__IBMBuiltin_vec_ld_VUclcAC");

vector signed char __ATTRS_o_ai
vec_lvx(signed long __a, const vector signed char * __b) __asm__("__IBMBuiltin_vec_ld_VSclVScAC");

vector signed char __ATTRS_o_ai
vec_lvx(signed long __a, const signed char * __b) __asm__("__IBMBuiltin_vec_ld_VSclcAC");

vector bool char __ATTRS_o_ai
vec_lvx(signed long __a, const vector bool char * __b) __asm__("__IBMBuiltin_vec_ld_VBclVBcAC");

vector unsigned short __ATTRS_o_ai
vec_lvx(signed long __a, const vector unsigned short * __b) __asm__("__IBMBuiltin_vec_ld_VUslVUsAC");

vector unsigned short __ATTRS_o_ai
vec_lvx(signed long __a, const unsigned short * __b) __asm__("__IBMBuiltin_vec_ld_VUslsAC");

vector signed short __ATTRS_o_ai
vec_lvx(signed long __a, const vector signed short * __b) __asm__("__IBMBuiltin_vec_ld_VSslVSsAC");

vector signed short __ATTRS_o_ai
vec_lvx(signed long __a, const signed short * __b) __asm__("__IBMBuiltin_vec_ld_VSslsAC");

vector bool short __ATTRS_o_ai
vec_lvx(signed long __a, const vector bool short * __b) __asm__("__IBMBuiltin_vec_ld_VBslVBsAC");

vector pixel __ATTRS_o_ai
vec_lvx(signed long __a, const vector pixel * __b) __asm__("__IBMBuiltin_vec_ld_VplVpAC");

vector unsigned int __ATTRS_o_ai
vec_lvx(signed long __a, const vector unsigned int * __b) __asm__("__IBMBuiltin_vec_ld_VUilVUiAC");

vector unsigned int __ATTRS_o_ai
vec_lvx(signed long __a, const unsigned int * __b) __asm__("__IBMBuiltin_vec_ld_VUiliAC");

vector signed int __ATTRS_o_ai
vec_lvx(signed long __a, const vector signed int * __b) __asm__("__IBMBuiltin_vec_ld_VSilVSiAC");

vector signed int __ATTRS_o_ai
vec_lvx(signed long __a, const signed int * __b) __asm__("__IBMBuiltin_vec_ld_VSiliAC");

vector bool int __ATTRS_o_ai
vec_lvx(signed long __a, const vector bool int * __b) __asm__("__IBMBuiltin_vec_ld_VBilVBiAC");

vector float __ATTRS_o_ai
vec_lvx(signed long __a, const vector float * __b) __asm__("__IBMBuiltin_vec_ld_VflVfAC");

vector float __ATTRS_o_ai
vec_lvx(signed long __a, const float * __b) __asm__("__IBMBuiltin_vec_ld_VflfAC");

void __ATTRS_o_ai
vec_stvebx(vector unsigned char __a, signed long __b, unsigned char * __c) __asm__("__IBMBuiltin_vec_ste_b_vVUclcA");

void __ATTRS_o_ai
vec_stvebx(vector signed char __a, signed long __b, signed char * __c) __asm__("__IBMBuiltin_vec_ste_b_vVSclcA");

void __ATTRS_o_ai
vec_stvebx(vector bool char __a, signed long __b, unsigned char * __c) __asm__("__IBMBuiltin_vec_ste_b_vVBclcA");

void __ATTRS_o_ai
vec_stvebx(vector bool char __a, signed long __b, signed char * __c) __asm__("__IBMBuiltin_vec_ste_b_vVBclcA");

vector unsigned int __ATTRS_o_ai
vec_ld(signed int __a, const unsigned long * __b) __asm__("__IBMBuiltin_vec_ld_VUiilAC");

vector signed int __ATTRS_o_ai
vec_ld(signed int __a, const signed long * __b) __asm__("__IBMBuiltin_vec_ld_VSiilAC");

vector unsigned int __ATTRS_o_ai
vec_lvx(signed int __a, const unsigned long * __b) __asm__("__IBMBuiltin_vec_ld_VUiilAC");

vector signed int __ATTRS_o_ai
vec_lvx(signed int __a, const signed long * __b) __asm__("__IBMBuiltin_vec_ld_VSiilAC");

vector unsigned int __ATTRS_o_ai
vec_lde(signed int __a, const unsigned long * __b) __asm__("__IBMBuiltin_vec_lde_w_VUiilAC");

vector signed int __ATTRS_o_ai
vec_lde(signed int __a, const signed long * __b) __asm__("__IBMBuiltin_vec_lde_w_VSiilAC");

vector unsigned int __ATTRS_o_ai
vec_lvewx(signed int __a, const unsigned long * __b) __asm__("__IBMBuiltin_vec_lde_w_VUiilAC");

vector signed int __ATTRS_o_ai
vec_lvewx(signed int __a, const signed long * __b) __asm__("__IBMBuiltin_vec_lde_w_VSiilAC");

vector unsigned int __ATTRS_o_ai
vec_lvxl(signed int __a, const unsigned long * __b) __asm__("__IBMBuiltin_vec_ldl_VUiilAC");

vector signed int __ATTRS_o_ai
vec_lvxl(signed int __a, const signed long * __b) __asm__("__IBMBuiltin_vec_ldl_VSiilAC");

vector unsigned int __ATTRS_o_ai
vec_ldl(signed int __a, const unsigned long * __b) __asm__("__IBMBuiltin_vec_ldl_VUiilAC");

vector signed int __ATTRS_o_ai
vec_ldl(signed int __a, const signed long * __b) __asm__("__IBMBuiltin_vec_ldl_VSiilAC");

vector double __ATTRS_o_ai
vec_recipdiv(vector double __a, vector double __b) __asm__("__IBMBuiltin___vec_recipdiv_8_VdVdVd");

vector double __ATTRS_o_ai
vec_nearbyint(vector double __a) __asm__("__IBMBuiltin___vec_nearbyint_8_VdVd");

vector double __ATTRS_o_ai
vec_rsqrt(vector double __a) __asm__("__IBMBuiltin___vec_rsqrt_8_VdVd");

vector float __ATTRS_o_ai
vec_rint(vector float __a) __asm__("__IBMBuiltin_vec_roundc_VfVf");

vector double __ATTRS_o_ai
vec_rint(vector double __a) __asm__("__IBMBuiltin_vec_roundc_VdVd");

vector double __ATTRS_o_ai
vec_perm(vector double __a, vector double __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_VdVdVdVUc");

vector signed long long __ATTRS_o_ai
vec_perm(vector signed long long __a, vector signed long long __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_VSlVSlVSlVUc");

vector unsigned long long __ATTRS_o_ai
vec_perm(vector unsigned long long __a, vector unsigned long long __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_VUlVUlVUlVUc");

vector double __ATTRS_o_ai
vec_xxpermdi (vector double, vector double, int) __asm__("__IBMBuiltin_vec_xxpermdi_VdVdVdi");

vector float __ATTRS_o_ai
vec_xxpermdi (vector float, vector float, int) __asm__("__IBMBuiltin_vec_xxpermdi_VfVfVfi");

vector long long __ATTRS_o_ai
vec_xxpermdi (vector long long, vector long long, int) __asm__("__IBMBuiltin_vec_xxpermdi_VSlVSlVSli");

vector unsigned long long __ATTRS_o_ai
vec_xxpermdi (vector unsigned long long, vector unsigned long long, int) __asm__("__IBMBuiltin_vec_xxpermdi_VUlVUlVUli");

vector int __ATTRS_o_ai
vec_xxpermdi (vector int, vector int, int) __asm__("__IBMBuiltin_vec_xxpermdi_VSiVSiVSii");

vector unsigned int __ATTRS_o_ai
vec_xxpermdi (vector unsigned int,vector unsigned int, int) __asm__("__IBMBuiltin_vec_xxpermdi_VUiVUiVUii");

vector short __ATTRS_o_ai
vec_xxpermdi (vector short, vector short, int) __asm__("__IBMBuiltin_vec_xxpermdi_VSsVSsVSsi");

vector unsigned short __ATTRS_o_ai
vec_xxpermdi (vector unsigned short, vector unsigned short, int) __asm__("__IBMBuiltin_vec_xxpermdi_VUsVUsVUsi");

vector signed char __ATTRS_o_ai
vec_xxpermdi (vector signed char, vector signed char, int) __asm__("__IBMBuiltin_vec_xxpermdi_VScVScVSci");

vector unsigned char __ATTRS_o_ai
vec_xxpermdi (vector unsigned char,vector unsigned char, int) __asm__("__IBMBuiltin_vec_xxpermdi_VUcVUcVUci");

vector signed char __ATTRS_o_ai
vec_xld2(signed int __a, signed char * __b) __asm__("__IBMBuiltin_vec_xld2_VScicA");

vector unsigned char __ATTRS_o_ai
vec_xld2(signed int __a, unsigned char * __b) __asm__("__IBMBuiltin_vec_xld2_VUcicA");

vector signed short __ATTRS_o_ai
vec_xld2(signed int __a, signed short * __b) __asm__("__IBMBuiltin_vec_xld2_VSsisA");

vector unsigned short __ATTRS_o_ai
vec_xld2(signed int __a, unsigned short * __b) __asm__("__IBMBuiltin_vec_xld2_VUsisA");

vector signed int __ATTRS_o_ai
vec_xld2(signed int __a, signed int * __b) __asm__("__IBMBuiltin_vec_xld2_VSiiiA");

vector unsigned int __ATTRS_o_ai
vec_xld2(signed int __a, unsigned int * __b) __asm__("__IBMBuiltin_vec_xld2_VUiiiA");

vector float __ATTRS_o_ai
vec_xld2(signed int __a, float * __b) __asm__("__IBMBuiltin_vec_xld2_VfifA");

vector double __ATTRS_o_ai
vec_xld2(signed int __a, double * __b) __asm__("__IBMBuiltin_vec_xld2_VdidA");

vector unsigned long long __ATTRS_o_ai
vec_xld2(signed int __a, unsigned long long * __b) __asm__("__IBMBuiltin_vec_xld2_VUlilA");

vector signed long long __ATTRS_o_ai
vec_xld2(signed int __a, signed long long * __b) __asm__("__IBMBuiltin_vec_xld2_VSlilA");

vector double __ATTRS_o_ai
vec_xlds(signed int __a, double * __b) __asm__("__IBMBuiltin_vec_xlds_VdidA");

vector unsigned long long __ATTRS_o_ai
vec_xlds(signed int __a, unsigned long long * __b) __asm__("__IBMBuiltin_vec_xlds_VUlilA");

vector signed long long __ATTRS_o_ai
vec_xlds(signed int __a, signed long long * __b) __asm__("__IBMBuiltin_vec_xlds_VSlilA");

vector signed char __ATTRS_o_ai
vec_xlw4(signed int __a, signed char * __b) __asm__("__IBMBuiltin_vec_xlw4_VScicA");

vector unsigned char __ATTRS_o_ai
vec_xlw4(signed int __a, unsigned char * __b) __asm__("__IBMBuiltin_vec_xlw4_VUcicA");

vector signed short __ATTRS_o_ai
vec_xlw4(signed int __a, signed short * __b) __asm__("__IBMBuiltin_vec_xlw4_VSsisA");

vector unsigned short __ATTRS_o_ai
vec_xlw4(signed int __a, unsigned short * __b) __asm__("__IBMBuiltin_vec_xlw4_VUsisA");

vector float __ATTRS_o_ai
vec_xlw4(signed int __a, float * __b) __asm__("__IBMBuiltin_vec_xlw4_VfifA");

vector unsigned int __ATTRS_o_ai
vec_xlw4(signed int __a, unsigned int * __b) __asm__("__IBMBuiltin_vec_xlw4_VUiiiA");

vector signed int __ATTRS_o_ai
vec_xlw4(signed int __a, signed int * __b) __asm__("__IBMBuiltin_vec_xlw4_VSiiiA");

void __ATTRS_o_ai
vec_xstd2(vector signed char __a, signed int __b, signed char * __c) __asm__("__IBMBuiltin_vec_xstd2_vVScicA");

void __ATTRS_o_ai
vec_xstd2(vector unsigned char __a, signed int __b, unsigned char * __c) __asm__("__IBMBuiltin_vec_xstd2_vVUcicA");

void __ATTRS_o_ai
vec_xstd2(vector signed short __a, signed int __b, signed short * __c) __asm__("__IBMBuiltin_vec_xstd2_vVSsisA");

void __ATTRS_o_ai
vec_xstd2(vector unsigned short __a, signed int __b, unsigned short * __c) __asm__("__IBMBuiltin_vec_xstd2_vVUsisA");

void __ATTRS_o_ai
vec_xstd2(vector signed int __a, signed int __b, signed int * __c) __asm__("__IBMBuiltin_vec_xstd2_vVSiiiA");

void __ATTRS_o_ai
vec_xstd2(vector unsigned int __a, signed int __b, unsigned int * __c) __asm__("__IBMBuiltin_vec_xstd2_vVUiiiA");

void __ATTRS_o_ai
vec_xstd2(vector float __a, signed int __b, float * __c) __asm__("__IBMBuiltin_vec_xstd2_vVfifA");

void __ATTRS_o_ai
vec_xstd2(vector double __a, signed int __b, double * __c) __asm__("__IBMBuiltin_vec_xstd2_vVdidA");

void __ATTRS_o_ai
vec_xstd2(vector unsigned long long __a, signed int __b, unsigned long long * __c) __asm__("__IBMBuiltin_vec_xstd2_vVUlilA");

void __ATTRS_o_ai
vec_xstd2(vector signed long long __a, signed int __b, signed long long * __c) __asm__("__IBMBuiltin_vec_xstd2_vVSlilA");

void __ATTRS_o_ai
vec_xstw4(vector signed char __a, signed int __b, signed char * __c) __asm__("__IBMBuiltin_vec_xstw4_vVScicA");

void __ATTRS_o_ai
vec_xstw4(vector unsigned char __a, signed int __b, unsigned char * __c) __asm__("__IBMBuiltin_vec_xstw4_vVUcicA");

void __ATTRS_o_ai
vec_xstw4(vector signed short __a, signed int __b, signed short * __c) __asm__("__IBMBuiltin_vec_xstw4_vVSsisA");

void __ATTRS_o_ai
vec_xstw4(vector unsigned short __a, signed int __b, unsigned short * __c) __asm__("__IBMBuiltin_vec_xstw4_vVUsisA");

void __ATTRS_o_ai
vec_xstw4(vector float __a, signed int __b, float * __c) __asm__("__IBMBuiltin_vec_xstw4_vVfifA");

void __ATTRS_o_ai
vec_xstw4(vector unsigned int __a, signed int __b, unsigned int * __c) __asm__("__IBMBuiltin_vec_xstw4_vVUiiiA");

void __ATTRS_o_ai
vec_xstw4(vector signed int __a, signed int __b, signed int * __c) __asm__("__IBMBuiltin_vec_xstw4_vVSiiiA");

vector float __ATTRS_o_ai
vec_promote(float __a, signed int __b) __asm__("__IBMBuiltin_vec_promote_f4_Vffi");

float __ATTRS_o_ai
vec_extract(vector float __a, signed int __b) __asm__("__IBMBuiltin_vec_extract_f4_fVfi");

vector float __ATTRS_o_ai
vec_splats(float __a) __asm__("__IBMBuiltin_vec_splats_f4_Vff");

vector float __ATTRS_o_ai
vec_insert(float __a, vector float __b, signed int __c) __asm__("__IBMBuiltin_vec_insert_f4_VffVfi");

vector float __ATTRS_o_ai
vec_nabs(vector float __a) __asm__("__IBMBuiltin_vec_nabs_VfVf");

vector float __ATTRS_o_ai
vec_neg(vector float __a) __asm__("__IBMBuiltin_vec_neg_VfVf");

vector double __ATTRS_o_ai
vec_neg(vector double __a) __asm__("__IBMBuiltin_vec_neg_VdVd");

vector signed long long __ATTRS_o_ai
vec_neg(vector signed long long __a) __asm__("__IBMBuiltin_vec_neg_VSlVSl");

vector signed int __ATTRS_o_ai
vec_neg(vector signed int __a) __asm__("__IBMBuiltin_vec_neg_VSiVSi");

vector signed short __ATTRS_o_ai
vec_neg(vector signed short __a) __asm__("__IBMBuiltin_vec_neg_VSsVSs");

vector signed char __ATTRS_o_ai
vec_neg(vector signed char __a) __asm__("__IBMBuiltin_vec_neg_VScVSc");

vector double __ATTRS_o_ai
vec_re(vector double __a) __asm__("__IBMBuiltin_vec_re_8_VdVd");

vector double __ATTRS_o_ai
vec_rsqrte(vector double __a) __asm__("__IBMBuiltin_vec_rsqrte_8_VdVd");

vector float __ATTRS_o_ai
vec_sqrt(vector float __a) __asm__("__IBMBuiltin_vec_sqrt_VfVf");

vector double __ATTRS_o_ai
vec_round(vector double __a) __asm__("__IBMBuiltin_vec_round_8_VdVd");

vector float __ATTRS_o_ai
vec_roundc(vector float __a) __asm__("__IBMBuiltin_vec_roundc_VfVf");

vector double __ATTRS_o_ai
vec_floor(vector double __a) __asm__("__IBMBuiltin_vec_floor_8_VdVd");

vector float __ATTRS_o_ai
vec_roundm(vector float __a) __asm__("__IBMBuiltin_vec_floor_VfVf");

vector double __ATTRS_o_ai
vec_roundm(vector double __a) __asm__("__IBMBuiltin_vec_floor_8_VdVd");

vector double __ATTRS_o_ai
vec_ceil(vector double __a) __asm__("__IBMBuiltin_vec_ceil_8_VdVd");

vector float __ATTRS_o_ai
vec_roundp(vector float __a) __asm__("__IBMBuiltin_vec_ceil_VfVf");

vector double __ATTRS_o_ai
vec_roundp(vector double __a) __asm__("__IBMBuiltin_vec_ceil_8_VdVd");

vector double __ATTRS_o_ai
vec_trunc(vector double __a) __asm__("__IBMBuiltin_vec_trunc_8_VdVd");

vector float __ATTRS_o_ai
vec_roundz(vector float __a) __asm__("__IBMBuiltin_vec_trunc_VfVf");

vector double __ATTRS_o_ai
vec_roundz(vector double __a) __asm__("__IBMBuiltin_vec_trunc_8_VdVd");

vector double __ATTRS_o_ai
vec_add(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_add_8_VdVdVd");

vector signed long long __ATTRS_o_ai
vec_add(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_add_8_VSlVSlVSl");

vector signed long long __ATTRS_o_ai
vec_add(vector signed long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_add_8_VSlVSlVUl");

vector unsigned long long __ATTRS_o_ai
vec_add(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_add_8_VUlVUlVUl");

vector double __ATTRS_o_ai
vec_sub(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_sub_8_VdVdVd");

vector signed long long __ATTRS_o_ai
vec_sub(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_sub_8_VSlVSlVSl");

vector signed long long __ATTRS_o_ai
vec_sub(vector signed long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_sub_8_VSlVSlVUl");

vector unsigned long long __ATTRS_o_ai
vec_sub(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_sub_8_VUlVUlVUl");

vector float __ATTRS_o_ai
vec_mul(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_mul_VfVfVf");

vector double __ATTRS_o_ai
vec_mul(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_mul_VdVdVd");

vector unsigned char __ATTRS_o_ai
vec_mul(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_mul_VUcVUcVUc");

vector signed char __ATTRS_o_ai
vec_mul(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_mul_VScVScVSc");

vector unsigned short __ATTRS_o_ai
vec_mul(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_mul_VUsVUsVUs");

vector signed short __ATTRS_o_ai
vec_mul(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_mul_VSsVSsVSs");

vector unsigned int __ATTRS_o_ai
vec_mul(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_mul_VUiVUiVUi");

vector signed int __ATTRS_o_ai
vec_mul(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_mul_VSiVSiVSi");

vector unsigned long long __ATTRS_o_ai
vec_mul(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_mul_VUlVUlVUl");

vector signed long long __ATTRS_o_ai
vec_mul(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_mul_VSlVSlVSl");

vector float __ATTRS_o_ai
vec_div(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_div_VfVfVf");

vector double __ATTRS_o_ai
vec_div(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_div_VdVdVd");

vector unsigned char __ATTRS_o_ai
vec_div(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_div_VUcVUcVUc");

vector signed char __ATTRS_o_ai
vec_div(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_div_VScVScVSc");

vector unsigned short __ATTRS_o_ai
vec_div(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_div_VUsVUsVUs");

vector signed short __ATTRS_o_ai
vec_div(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_div_VSsVSsVSs");

vector unsigned int __ATTRS_o_ai
vec_div(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_div_VUiVUiVUi");

vector signed int __ATTRS_o_ai
vec_div(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_div_VSiVSiVSi");

vector unsigned long long __ATTRS_o_ai
vec_div(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_div_VUlVUlVUl");

vector signed long long __ATTRS_o_ai
vec_div(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_div_VSlVSlVSl");

vector double __ATTRS_o_ai
vec_max(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_max_8_VdVdVd");

vector double __ATTRS_o_ai
vec_min(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_min_8_VdVdVd");

vector double __ATTRS_o_ai
vec_cpsgn(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_cpsgn_VdVdVd");

vector float __ATTRS_o_ai
vec_cpsgn(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_cpsgn_VfVfVf");

vector signed long long __ATTRS_o_ai
vec_sl(vector signed long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_sl_8_VSlVSlVUl");

vector unsigned long long __ATTRS_o_ai
vec_sl(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_sl_8_VUlVUlVUl");

vector signed long long __ATTRS_o_ai
vec_sr(vector signed long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_sr_8_VSlVSlVUl");

vector unsigned long long __ATTRS_o_ai
vec_sr(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_sr_8_VUlVUlVUl");

vector signed long long __ATTRS_o_ai
vec_sra(vector signed long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_sra_8_VSlVSlVUl");

vector unsigned long long __ATTRS_o_ai
vec_sra(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_sra_8_VUlVUlVUl");

signed int __ATTRS_o_ai
vec_all_ngt(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_all_ngt_8_iVdVd");

signed int __ATTRS_o_ai
vec_all_nlt(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_all_nlt_8_iVdVd");

signed int __ATTRS_o_ai
vec_all_nge(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_all_nge_8_iVdVd");

signed int __ATTRS_o_ai
vec_all_nle(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_all_nle_8_iVdVd");

signed int __ATTRS_o_ai
vec_any_ngt(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_any_ngt_8_iVdVd");

signed int __ATTRS_o_ai
vec_any_nlt(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_any_nlt_8_iVdVd");

signed int __ATTRS_o_ai
vec_any_nge(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_any_nge_8_iVdVd");

signed int __ATTRS_o_ai
vec_any_nle(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_any_nle_8_iVdVd");

signed int __ATTRS_o_ai
vec_all_nan(vector double __a) __asm__("__IBMBuiltin_vec_all_nan_8_iVd");

signed int __ATTRS_o_ai
vec_all_numeric(vector double __a) __asm__("__IBMBuiltin_vec_all_numeric_8_iVd");

signed int __ATTRS_o_ai
vec_any_nan(vector double __a) __asm__("__IBMBuiltin_vec_any_nan_8_iVd");

signed int __ATTRS_o_ai
vec_any_numeric(vector double __a) __asm__("__IBMBuiltin_vec_any_numeric_8_iVd");

vector double __ATTRS_o_ai
vec_cvf(vector float __a) __asm__("__IBMBuiltin_vec_cvf_VdVf");

vector float __ATTRS_o_ai
vec_cvf(vector double __a) __asm__("__IBMBuiltin_vec_cvf_VfVd");

vector signed int __ATTRS_o_ai
vec_cts(vector double __a, signed int __b) __asm__("__IBMBuiltin_vec_cts_8_VSiVdi");

vector signed long long __ATTRS_o_ai
vec_ctsl(vector float __a, signed int __b) __asm__("__IBMBuiltin_vec_ctsl_VSlVfi");

vector unsigned int __ATTRS_o_ai
vec_ctu(vector double __a, signed int __b) __asm__("__IBMBuiltin_vec_ctu_8_VUiVdi");

vector unsigned long long __ATTRS_o_ai
vec_ctul(vector float __a, signed int __b) __asm__("__IBMBuiltin_vec_ctul_VUlVfi");

vector float __ATTRS_o_ai
vec_ctf(vector signed long long __a, signed int __b) __asm__("__IBMBuiltin_vec_ctf_8_VfVSli");

vector float __ATTRS_o_ai
vec_ctf(vector unsigned long long __a, signed int __b) __asm__("__IBMBuiltin_vec_ctf_8_VfVUli");

vector double __ATTRS_o_ai
vec_ctd(vector signed int __a, signed int __b) __asm__("__IBMBuiltin_vec_ctd_VdVSii");

vector double __ATTRS_o_ai
vec_ctd(vector unsigned int __a, signed int __b) __asm__("__IBMBuiltin_vec_ctd_VdVUii");

vector double __ATTRS_o_ai
vec_madd(vector double __a, vector double __b, vector double __c) __asm__("__IBMBuiltin_vec_madd_8_VdVdVdVd");

vector float __ATTRS_o_ai
vec_msub(vector float __a, vector float __b, vector float __c) __asm__("__IBMBuiltin_vec_msub_VfVfVfVf");

vector float __ATTRS_o_ai
vec_nmadd(vector float __a, vector float __b, vector float __c) __asm__("__IBMBuiltin_vec_nmadd_VfVfVfVf");

vector double __ATTRS_o_ai
vec_nmadd(vector double __a, vector double __b, vector double __c) __asm__("__IBMBuiltin_vec_nmadd_VdVdVdVd");

vector double __ATTRS_o_ai
vec_nmsub(vector double __a, vector double __b, vector double __c) __asm__("__IBMBuiltin_vec_nmsub_8_VdVdVdVd");

vector double __ATTRS_o_ai
vec_and(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_and_8_VdVdVd");

vector double __ATTRS_o_ai
vec_and(vector double __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_and_8_VdVdVBl");

vector double __ATTRS_o_ai
vec_and(vector bool long long __a, vector double __b) __asm__("__IBMBuiltin_vec_and_8_VdVBlVd");

vector unsigned long long __ATTRS_o_ai
vec_and(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_and_8_VUlVUlVUl");

vector unsigned long long __ATTRS_o_ai
vec_and(vector unsigned long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_and_8_VUlVUlVBl");

vector unsigned long long __ATTRS_o_ai
vec_and(vector bool long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_and_8_VUlVBlVUl");

vector bool long long __ATTRS_o_ai
vec_and(vector bool long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_and_8_VBlVBlVBl");

vector signed long long __ATTRS_o_ai
vec_and(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_and_8_VSlVSlVSl");

vector signed long long __ATTRS_o_ai
vec_and(vector signed long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_and_8_VSlVSlVBl");

vector signed long long __ATTRS_o_ai
vec_and(vector bool long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_and_8_VSlVBlVSl");

vector double __ATTRS_o_ai
vec_or(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_or_8_VdVdVd");

vector double __ATTRS_o_ai
vec_or(vector double __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_or_8_VdVdVBl");

vector double __ATTRS_o_ai
vec_or(vector bool long long __a, vector double __b) __asm__("__IBMBuiltin_vec_or_8_VdVBlVd");

vector unsigned long long __ATTRS_o_ai
vec_or(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_or_8_VUlVUlVUl");

vector unsigned long long __ATTRS_o_ai
vec_or(vector unsigned long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_or_8_VUlVUlVBl");

vector unsigned long long __ATTRS_o_ai
vec_or(vector bool long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_or_8_VUlVBlVUl");

vector bool long long __ATTRS_o_ai
vec_or(vector bool long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_or_8_VBlVBlVBl");

vector signed long long __ATTRS_o_ai
vec_or(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_or_8_VSlVSlVSl");

vector signed long long __ATTRS_o_ai
vec_or(vector signed long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_or_8_VSlVSlVBl");

vector signed long long __ATTRS_o_ai
vec_or(vector bool long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_or_8_VSlVBlVSl");

vector double __ATTRS_o_ai
vec_xor(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_xor_8_VdVdVd");

vector double __ATTRS_o_ai
vec_xor(vector double __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_xor_8_VdVdVBl");

vector double __ATTRS_o_ai
vec_xor(vector bool long long __a, vector double __b) __asm__("__IBMBuiltin_vec_xor_8_VdVBlVd");

vector unsigned long long __ATTRS_o_ai
vec_xor(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_xor_8_VUlVUlVUl");

vector unsigned long long __ATTRS_o_ai
vec_xor(vector unsigned long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_xor_8_VUlVUlVBl");

vector unsigned long long __ATTRS_o_ai
vec_xor(vector bool long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_xor_8_VUlVBlVUl");

vector bool long long __ATTRS_o_ai
vec_xor(vector bool long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_xor_8_VBlVBlVBl");

vector signed long long __ATTRS_o_ai
vec_xor(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_xor_8_VSlVSlVSl");

vector signed long long __ATTRS_o_ai
vec_xor(vector signed long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_xor_8_VSlVSlVBl");

vector signed long long __ATTRS_o_ai
vec_xor(vector bool long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_xor_8_VSlVBlVSl");

vector bool char __ATTRS_o_ai
vec_sldw(vector bool char __a, vector bool char __b, signed int __c) __asm__("__IBMBuiltin_vec_sldw_VBcVBcVBci");

vector bool short __ATTRS_o_ai
vec_sldw(vector bool short __a, vector bool short __b, signed int __c) __asm__("__IBMBuiltin_vec_sldw_VBsVBsVBsi");

vector bool int __ATTRS_o_ai
vec_sldw(vector bool int __a, vector bool int __b, signed int __c) __asm__("__IBMBuiltin_vec_sldw_VBiVBiVBii");

vector float __ATTRS_o_ai
vec_sldw(vector float __a, vector float __b, signed int __c) __asm__("__IBMBuiltin_vec_sldw_VfVfVfi");

vector unsigned long long __ATTRS_o_ai
vec_sldw(vector unsigned long long __a, vector unsigned long long __b, signed int __c) __asm__("__IBMBuiltin_vec_sldw_VUlVUlVUli");

vector signed long long __ATTRS_o_ai
vec_sldw(vector signed long long __a, vector signed long long __b, signed int __c) __asm__("__IBMBuiltin_vec_sldw_VSlVSlVSli");

vector bool long long __ATTRS_o_ai
vec_sldw(vector bool long long __a, vector bool long long __b, signed int __c) __asm__("__IBMBuiltin_vec_sldw_VBlVBlVBli");

vector double __ATTRS_o_ai
vec_sldw(vector double __a, vector double __b, signed int __c) __asm__("__IBMBuiltin_vec_sldw_VdVdVdi");

vector double __ATTRS_o_ai
vec_xxsldi (vector double, vector double, int) __asm__("__IBMBuiltin_vec_sldw_VdVdVdi");

vector float __ATTRS_o_ai
vec_xxsldi (vector float, vector float, int) __asm__("__IBMBuiltin_vec_sldw_VfVfVfi");

vector long long __ATTRS_o_ai
vec_xxsldi (vector long long, vector long long, int) __asm__("__IBMBuiltin_vec_sldw_VSlVSlVSli");

vector unsigned long long __ATTRS_o_ai
vec_xxsldi (vector unsigned long long, vector unsigned long long, int) __asm__("__IBMBuiltin_vec_sldw_VUlVUlVUli");

vector int __ATTRS_o_ai
vec_xxsldi (vector int, vector int, int) __asm__("__IBMBuiltin_vec_sldw_VSiVSiVSii");

vector unsigned int __ATTRS_o_ai
vec_xxsldi (vector unsigned int,vector unsigned int, int) __asm__("__IBMBuiltin_vec_sldw_VUiVUiVUii");

vector short __ATTRS_o_ai
vec_xxsldi (vector short, vector short, int) __asm__("__IBMBuiltin_vec_sldw_VSsVSsVSsi");

vector unsigned short __ATTRS_o_ai
vec_xxsldi (vector unsigned short, vector unsigned short, int) __asm__("__IBMBuiltin_vec_sldw_VUsVUsVUsi");

vector signed char __ATTRS_o_ai
vec_xxsldi (vector signed char, vector signed char, int) __asm__("__IBMBuiltin_vec_sldw_VScVScVSci");

vector unsigned char __ATTRS_o_ai
vec_xxsldi (vector unsigned char,vector unsigned char, int) __asm__("__IBMBuiltin_vec_sldw_VUcVUcVUci");

vector unsigned long long __ATTRS_o_ai
vec_splat(vector unsigned long long __a, signed int __b) __asm__("__IBMBuiltin_vec_splat_8_VUlVUli");

vector signed long long __ATTRS_o_ai
vec_splat(vector signed long long __a, signed int __b) __asm__("__IBMBuiltin_vec_splat_8_VSlVSli");

vector bool long long __ATTRS_o_ai
vec_splat(vector bool long long __a, signed int __b) __asm__("__IBMBuiltin_vec_splat_8_VBlVBli");

vector double __ATTRS_o_ai
vec_splat(vector double __a, signed int __b) __asm__("__IBMBuiltin_vec_splat_8_VdVdi");

vector float __ATTRS_o_ai
vec_xld2(signed long __a, float * __b) __asm__("__IBMBuiltin_vec_xld2_VflfA");

vector double __ATTRS_o_ai
vec_xld2(signed long __a, double * __b) __asm__("__IBMBuiltin_vec_xld2_VdldA");

vector unsigned long long __ATTRS_o_ai
vec_xld2(signed long __a, unsigned long long * __b) __asm__("__IBMBuiltin_vec_xld2_VUlllA");

vector signed long long __ATTRS_o_ai
vec_xld2(signed long __a, signed long long * __b) __asm__("__IBMBuiltin_vec_xld2_VSlllA");

vector double __ATTRS_o_ai
vec_xlds(signed long __a, double * __b) __asm__("__IBMBuiltin_vec_xlds_VdldA");

vector unsigned long long __ATTRS_o_ai
vec_xlds(signed long __a, unsigned long long * __b) __asm__("__IBMBuiltin_vec_xlds_VUlllA");

vector signed long long __ATTRS_o_ai
vec_xlds(signed long __a, signed long long * __b) __asm__("__IBMBuiltin_vec_xlds_VSlllA");

vector float __ATTRS_o_ai
vec_xlw4(signed long __a, float * __b) __asm__("__IBMBuiltin_vec_xlw4_VflfA");

void __ATTRS_o_ai
vec_xstd2(vector float __a, signed long __b, float * __c) __asm__("__IBMBuiltin_vec_xstd2_vVflfA");

void __ATTRS_o_ai
vec_xstd2(vector double __a, signed long __b, double * __c) __asm__("__IBMBuiltin_vec_xstd2_vVdldA");

void __ATTRS_o_ai
vec_xstd2(vector unsigned long long __a, signed long __b, unsigned long long * __c) __asm__("__IBMBuiltin_vec_xstd2_vVUlllA");

void __ATTRS_o_ai
vec_xstd2(vector signed long long __a, signed long __b, signed long long * __c) __asm__("__IBMBuiltin_vec_xstd2_vVSlllA");

void __ATTRS_o_ai
vec_xstw4(vector float __a, signed long __b, float * __c) __asm__("__IBMBuiltin_vec_xstw4_vVflfA");

vector signed char __ATTRS_o_ai
vec_vclz(vector signed char __a) __asm__("__IBMBuiltin_vec_cntlz_VScVSc");

vector unsigned char __ATTRS_o_ai
vec_vclz(vector unsigned char __a) __asm__("__IBMBuiltin_vec_cntlz_VUcVUc");

vector unsigned int __ATTRS_o_ai
vec_vclz(vector unsigned int __a) __asm__("__IBMBuiltin_vec_cntlz_VUiVUi");

vector signed long long __ATTRS_o_ai
vec_vclz(vector signed long long __a) __asm__("__IBMBuiltin_vec_cntlz_VSlVSl");

vector unsigned long long __ATTRS_o_ai
vec_vclz(vector unsigned long long __a) __asm__("__IBMBuiltin_vec_cntlz_VUlVUl");

vector unsigned short __ATTRS_o_ai
vec_vclz(vector unsigned short __a) __asm__("__IBMBuiltin_vec_cntlz_VUsVUs");

vector signed int __ATTRS_o_ai
vec_vclz(vector signed int __a) __asm__("__IBMBuiltin_vec_cntlz_VSiVSi");

vector signed short __ATTRS_o_ai
vec_vclz(vector signed short __a) __asm__("__IBMBuiltin_vec_cntlz_VSsVSs");

vector unsigned char __attribute__((__always_inline__))
__vcipher(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin___vcipher_VUcVUcVUc");

vector unsigned char __attribute__((__always_inline__))
__vcipherlast(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin___vcipherlast_VUcVUcVUc");

vector unsigned char __attribute__((__always_inline__))
__vncipher(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin___vncipher_VUcVUcVUc");

vector unsigned char __attribute__((__always_inline__))
__vncipherlast(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin___vncipherlast_VUcVUcVUc");

vector unsigned char __attribute__((__always_inline__))
__vsbox(vector unsigned char __a) __asm__("__IBMBuiltin___vsbox_VUcVUc");

vector unsigned long long __attribute__((__always_inline__))
__vshasigmad(vector unsigned long long __a, signed int __b, signed int __c) __asm__("__IBMBuiltin___vshasigmad_VUlVUlii");

vector unsigned int __attribute__((__always_inline__))
__vshasigmaw(vector unsigned int __a, signed int __b, signed int __c) __asm__("__IBMBuiltin___vshasigmaw_VUiVUiii");

vector unsigned char __attribute__((__always_inline__))
__vpmsumb(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin___vpmsumb_VUcVUcVUc");

vector unsigned short __attribute__((__always_inline__))
__vpmsumh(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin___vpmsumh_VUsVUsVUs");

vector unsigned int __attribute__((__always_inline__))
__vpmsumw(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin___vpmsumw_VUiVUiVUi");

vector unsigned long long __attribute__((__always_inline__))
__vpmsumd(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin___vpmsumd_VUlVUlVUl");

vector unsigned char __attribute__((__always_inline__))
vec_cipher_be(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin___vcipher_VUcVUcVUc");

vector unsigned char __attribute__((__always_inline__))
vec_cipherlast_be(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin___vcipherlast_VUcVUcVUc");

vector unsigned char __attribute__((__always_inline__))
vec_ncipher_be(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin___vncipher_VUcVUcVUc");

vector unsigned char __attribute__((__always_inline__))
vec_ncipherlast_be(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin___vncipherlast_VUcVUcVUc");

vector unsigned char __attribute__((__always_inline__))
vec_sbox_be(vector unsigned char __a) __asm__("__IBMBuiltin___vsbox_VUcVUc");

vector unsigned long long __ATTRS_o_ai
vec_shasigma_be(vector unsigned long long __a, signed int __b, signed int __c) __asm__("__IBMBuiltin___vshasigmad_VUlVUlii");

vector unsigned int __ATTRS_o_ai
vec_shasigma_be(vector unsigned int __a, signed int __b, signed int __c) __asm__("__IBMBuiltin___vshasigmaw_VUiVUiii");

vector unsigned short __ATTRS_o_ai
vec_pmsum_be(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin___vpmsumb_VUcVUcVUc");

vector unsigned int __ATTRS_o_ai
vec_pmsum_be(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin___vpmsumh_VUsVUsVUs");

vector unsigned long long __ATTRS_o_ai
vec_pmsum_be(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin___vpmsumw_VUiVUiVUi");

vector unsigned char __attribute__((__always_inline__))
__vpermxor(vector unsigned char __a, vector unsigned char __b, vector unsigned char __c) __asm__("__IBMBuiltin___vpermxor_VUcVUcVUcVUc");

vector unsigned char __attribute__((__always_inline__))
__bcdadd(vector unsigned char __a, vector unsigned char __b, signed long __c) __asm__("__IBMBuiltin___bcdadd_VUcVUcVUcl");

vector unsigned char __attribute__((__always_inline__))
__bcdsub(vector unsigned char __a, vector unsigned char __b, signed long __c) __asm__("__IBMBuiltin___bcdsub_VUcVUcVUcl");

signed long __attribute__((__always_inline__))
__bcdadd_ofl(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin___bcdadd_ofl_lVUcVUc");

signed long __attribute__((__always_inline__))
__bcdsub_ofl(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin___bcdsub_ofl_lVUcVUc");

signed long __attribute__((__always_inline__))
__bcd_invalid(vector unsigned char __a) __asm__("__IBMBuiltin___bcd_invalid_lVUc");

signed long __attribute__((__always_inline__))
__bcdcmpeq(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin___bcdcmpeq_lVUcVUc");

signed long __attribute__((__always_inline__))
__bcdcmpgt(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin___bcdcmpgt_lVUcVUc");

signed long __attribute__((__always_inline__))
__bcdcmpge(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin___bcdcmpge_lVUcVUc");

signed long __attribute__((__always_inline__))
__bcdcmplt(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin___bcdcmplt_lVUcVUc");

signed long __attribute__((__always_inline__))
__bcdcmple(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin___bcdcmple_lVUcVUc");

vector unsigned char __attribute__((__always_inline__))
__vec_ldrmb (char *ptr, size_t cnt) __asm__("__IBMBuiltin___vec_ldrmb_VUccAi");

void __attribute__((__always_inline__))
__vec_strmb (char *ptr, size_t cnt, vector unsigned char data) __asm__("__IBMBuiltin___vec_strmb_vcAiVUc");

vector unsigned long long __ATTRS_o_ai
vec_gbb(vector unsigned long long __a) __asm__("__IBMBuiltin_vec_gbb_VUlVUl");

vector signed long long __ATTRS_o_ai
vec_gbb(vector signed long long __a) __asm__("__IBMBuiltin_vec_gbb_VSlVSl");

vector unsigned char __ATTRS_o_ai
vec_vgbbd(vector unsigned char __a) __asm__("__IBMBuiltin_vec_gbb_VUcVUc");

vector signed char __ATTRS_o_ai
vec_vgbbd(vector signed char __a) __asm__("__IBMBuiltin_vec_gbb_VScVSc");

vector unsigned long long __ATTRS_o_ai
vec_cntlz(vector unsigned long long __a) __asm__("__IBMBuiltin_vec_cntlz_VUlVUl");

vector signed long long __ATTRS_o_ai
vec_cntlz(vector signed long long __a) __asm__("__IBMBuiltin_vec_cntlz_VSlVSl");

vector unsigned long long __ATTRS_o_ai
vec_popcnt(vector unsigned long long __a) __asm__("__IBMBuiltin_vec_popcnt_VUlVUl");

vector unsigned long long __ATTRS_o_ai
vec_popcnt(vector signed long long __a) __asm__("__IBMBuiltin_vec_popcnt_VUlVSl");

vector unsigned int __attribute__((__always_inline__))
vec_vpkudum(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_pack_8_VUiVUlVUl");

vector unsigned int __attribute__((__always_inline__))
vec_vpkudus(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_packs_8_VUiVUlVUl");

vector unsigned int __attribute__((__always_inline__))
vec_vpksdus(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_packsu_8_VUiVSlVSl");

vector signed int __attribute__((__always_inline__))
vec_vpksdss(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_packs_8_VSiVSlVSl");

vector signed long long __ATTRS_o_ai
vec_unpackh(vector signed int __a) __asm__("__IBMBuiltin_vec_unpackh_8_VSlVSi");

vector bool long long __ATTRS_o_ai
vec_unpackh(vector bool int __a) __asm__("__IBMBuiltin_vec_unpackh_8_VBlVBi");

vector signed long long __attribute__((__always_inline__))
vec_vupkhsw(vector signed int __a) __asm__("__IBMBuiltin_vec_unpackh_8_VSlVSi");

vector signed long long __ATTRS_o_ai
vec_unpackl(vector signed int __a) __asm__("__IBMBuiltin_vec_unpackl_8_VSlVSi");

vector bool long long __ATTRS_o_ai
vec_unpackl(vector bool int __a) __asm__("__IBMBuiltin_vec_unpackl_8_VBlVBi");

vector signed long long __attribute__((__always_inline__))
vec_vupklsw(vector signed int __a) __asm__("__IBMBuiltin_vec_unpackl_8_VSlVSi");

vector unsigned long long __attribute__((__always_inline__))
vec_vaddudm(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_add_8_VUlVUlVUl");

vector unsigned long long __attribute__((__always_inline__))
vec_vsubudm(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_sub_8_VUlVUlVUl");

vector unsigned long long __ATTRS_o_ai
vec_max(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_max_8_d_VUlVUlVUl");

vector signed long long __ATTRS_o_ai
vec_max(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_max_8_d_VSlVSlVSl");

vector bool long long __ATTRS_o_ai
vec_max(vector bool long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_max_8_d_VBlVBlVBl");

vector unsigned long long __ATTRS_o_ai
vec_min(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_min_8_d_VUlVUlVUl");

vector signed long long __ATTRS_o_ai
vec_min(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_min_8_d_VSlVSlVSl");

vector bool long long __ATTRS_o_ai
vec_min(vector bool long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_min_8_d_VBlVBlVBl");

vector unsigned long long __ATTRS_o_ai
vec_vrld(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_rl_8_VUlVUlVUl");

vector signed long long __ATTRS_o_ai
vec_vrld(vector signed long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_rl_8_VSlVSlVUl");

vector unsigned long long __ATTRS_o_ai
vec_vsld(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_sl_8_VUlVUlVUl");

vector signed long long __ATTRS_o_ai
vec_vsld(vector signed long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_sl_8_VSlVSlVUl");

vector unsigned long long __ATTRS_o_ai
vec_vsrd(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_sr_8_VUlVUlVUl");

vector signed long long __ATTRS_o_ai
vec_vsrd(vector signed long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_sr_8_VSlVSlVUl");

vector unsigned long long __ATTRS_o_ai
vec_vsrad(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_sra_8_VUlVUlVUl");

vector signed long long __ATTRS_o_ai
vec_vsrad(vector signed long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_sra_8_VSlVSlVUl");

vector bool long long __attribute__((__always_inline__))
vec_vcmpleud(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_cmple_8_VBlVUlVUl");

vector bool long long __ATTRS_o_ai
vec_vcmpequd(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_cmpeq_8_VBlVUlVUl");

vector bool long long __ATTRS_o_ai
vec_vcmpequd(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_cmpeq_8_VBlVSlVSl");

vector bool long long __attribute__((__always_inline__))
vec_vcmpgtsd(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_cmpgt_8_VBlVSlVSl");

vector bool long long __attribute__((__always_inline__))
vec_vcmpgtud(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_cmpgt_8_VBlVUlVUl");

vector bool long long __attribute__((__always_inline__))
vec_vcmpgesd(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_cmpge_8_VBlVSlVSl");

vector bool long long __attribute__((__always_inline__))
vec_vcmpgeud(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_cmpge_8_VBlVUlVUl");

vector bool long long __attribute__((__always_inline__))
vec_vcmpltsd(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_cmplt_8_VBlVSlVSl");

vector bool long long __attribute__((__always_inline__))
vec_vcmpltud(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_cmplt_8_VBlVUlVUl");

vector bool long long __attribute__((__always_inline__))
vec_vcmplesd(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_cmple_8_VBlVSlVSl");

vector unsigned char __ATTRS_o_ai
vec_eqv(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_eqv_VUcVUcVUc");

vector signed char __ATTRS_o_ai
vec_eqv(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_eqv_VScVScVSc");

vector unsigned long long __ATTRS_o_ai
vec_eqv(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_eqv_VUlVUlVUl");

vector signed long long __ATTRS_o_ai
vec_eqv(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_eqv_VSlVSlVSl");

vector unsigned long long __ATTRS_o_ai
vec_eqv(vector unsigned long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_eqv_VUlVUlVBl");

vector signed long long __ATTRS_o_ai
vec_eqv(vector signed long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_eqv_VSlVSlVBl");

vector unsigned long long __ATTRS_o_ai
vec_eqv(vector bool long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_eqv_VUlVBlVUl");

vector signed long long __ATTRS_o_ai
vec_eqv(vector bool long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_eqv_VSlVBlVSl");

vector bool long long __ATTRS_o_ai
vec_eqv(vector bool long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_eqv_VBlVBlVBl");

vector unsigned int __ATTRS_o_ai
vec_eqv(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_eqv_VUiVUiVUi");

vector signed int __ATTRS_o_ai
vec_eqv(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_eqv_VSiVSiVSi");

vector unsigned int __ATTRS_o_ai
vec_eqv(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_eqv_VUiVUiVBi");

vector signed int __ATTRS_o_ai
vec_eqv(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_eqv_VSiVSiVBi");

vector unsigned int __ATTRS_o_ai
vec_eqv(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_eqv_VUiVBiVUi");

vector signed int __ATTRS_o_ai
vec_eqv(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_eqv_VSiVBiVSi");

vector bool int __ATTRS_o_ai
vec_eqv(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_eqv_VBiVBiVBi");

vector unsigned short __ATTRS_o_ai
vec_eqv(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_eqv_VUsVUsVUs");

vector signed short __ATTRS_o_ai
vec_eqv(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_eqv_VSsVSsVSs");

vector unsigned short __ATTRS_o_ai
vec_eqv(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_eqv_VUsVUsVBs");

vector signed short __ATTRS_o_ai
vec_eqv(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_eqv_VSsVSsVBs");

vector unsigned short __ATTRS_o_ai
vec_eqv(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_eqv_VUsVBsVUs");

vector signed short __ATTRS_o_ai
vec_eqv(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_eqv_VSsVBsVSs");

vector bool short __ATTRS_o_ai
vec_eqv(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_eqv_VBsVBsVBs");

vector unsigned char __ATTRS_o_ai
vec_eqv(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_eqv_VUcVUcVBc");

vector signed char __ATTRS_o_ai
vec_eqv(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_eqv_VScVScVBc");

vector unsigned char __ATTRS_o_ai
vec_eqv(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_eqv_VUcVBcVUc");

vector signed char __ATTRS_o_ai
vec_eqv(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_eqv_VScVBcVSc");

vector bool char __ATTRS_o_ai
vec_eqv(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_eqv_VBcVBcVBc");

vector float __ATTRS_o_ai
vec_eqv(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_eqv_VfVfVf");

vector float __ATTRS_o_ai
vec_eqv(vector bool int __a, vector float __b) __asm__("__IBMBuiltin_vec_eqv_VfVBiVf");

vector float __ATTRS_o_ai
vec_eqv(vector float __a, vector bool int __b) __asm__("__IBMBuiltin_vec_eqv_VfVfVBi");

vector double __ATTRS_o_ai
vec_eqv(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_eqv_VdVdVd");

vector double __ATTRS_o_ai
vec_eqv(vector bool long long __a, vector double __b) __asm__("__IBMBuiltin_vec_eqv_VdVBlVd");

vector double __ATTRS_o_ai
vec_eqv(vector double __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_eqv_VdVdVBl");

vector unsigned char __ATTRS_o_ai
vec_nand(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_nand_VUcVUcVUc");

vector signed char __ATTRS_o_ai
vec_nand(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_nand_VScVScVSc");

vector unsigned long long __ATTRS_o_ai
vec_nand(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_nand_VUlVUlVUl");

vector signed long long __ATTRS_o_ai
vec_nand(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_nand_VSlVSlVSl");

vector unsigned long long __ATTRS_o_ai
vec_nand(vector unsigned long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_nand_VUlVUlVBl");

vector signed long long __ATTRS_o_ai
vec_nand(vector signed long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_nand_VSlVSlVBl");

vector unsigned long long __ATTRS_o_ai
vec_nand(vector bool long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_nand_VUlVBlVUl");

vector signed long long __ATTRS_o_ai
vec_nand(vector bool long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_nand_VSlVBlVSl");

vector bool long long __ATTRS_o_ai
vec_nand(vector bool long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_nand_VBlVBlVBl");

vector unsigned int __ATTRS_o_ai
vec_nand(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_nand_VUiVUiVUi");

vector signed int __ATTRS_o_ai
vec_nand(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_nand_VSiVSiVSi");

vector unsigned int __ATTRS_o_ai
vec_nand(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_nand_VUiVUiVBi");

vector signed int __ATTRS_o_ai
vec_nand(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_nand_VSiVSiVBi");

vector unsigned int __ATTRS_o_ai
vec_nand(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_nand_VUiVBiVUi");

vector signed int __ATTRS_o_ai
vec_nand(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_nand_VSiVBiVSi");

vector bool int __ATTRS_o_ai
vec_nand(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_nand_VBiVBiVBi");

vector unsigned short __ATTRS_o_ai
vec_nand(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_nand_VUsVUsVUs");

vector signed short __ATTRS_o_ai
vec_nand(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_nand_VSsVSsVSs");

vector unsigned short __ATTRS_o_ai
vec_nand(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_nand_VUsVUsVBs");

vector signed short __ATTRS_o_ai
vec_nand(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_nand_VSsVSsVBs");

vector unsigned short __ATTRS_o_ai
vec_nand(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_nand_VUsVBsVUs");

vector signed short __ATTRS_o_ai
vec_nand(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_nand_VSsVBsVSs");

vector bool short __ATTRS_o_ai
vec_nand(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_nand_VBsVBsVBs");

vector unsigned char __ATTRS_o_ai
vec_nand(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_nand_VUcVUcVBc");

vector signed char __ATTRS_o_ai
vec_nand(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_nand_VScVScVBc");

vector unsigned char __ATTRS_o_ai
vec_nand(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_nand_VUcVBcVUc");

vector signed char __ATTRS_o_ai
vec_nand(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_nand_VScVBcVSc");

vector bool char __ATTRS_o_ai
vec_nand(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_nand_VBcVBcVBc");

vector float __ATTRS_o_ai
vec_nand(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_nand_VfVfVf");

vector float __ATTRS_o_ai
vec_nand(vector bool int __a, vector float __b) __asm__("__IBMBuiltin_vec_nand_VfVBiVf");

vector float __ATTRS_o_ai
vec_nand(vector float __a, vector bool int __b) __asm__("__IBMBuiltin_vec_nand_VfVfVBi");

vector double __ATTRS_o_ai
vec_nand(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_nand_VdVdVd");

vector double __ATTRS_o_ai
vec_nand(vector bool long long __a, vector double __b) __asm__("__IBMBuiltin_vec_nand_VdVBlVd");

vector double __ATTRS_o_ai
vec_nand(vector double __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_nand_VdVdVBl");

vector unsigned char __ATTRS_o_ai
vec_orc(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_orc_VUcVUcVUc");

vector signed char __ATTRS_o_ai
vec_orc(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_orc_VScVScVSc");

vector unsigned long long __ATTRS_o_ai
vec_orc(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_orc_VUlVUlVUl");

vector signed long long __ATTRS_o_ai
vec_orc(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_orc_VSlVSlVSl");

vector unsigned long long __ATTRS_o_ai
vec_orc(vector unsigned long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_orc_VUlVUlVBl");

vector signed long long __ATTRS_o_ai
vec_orc(vector signed long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_orc_VSlVSlVBl");

vector unsigned long long __ATTRS_o_ai
vec_orc(vector bool long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_orc_VUlVBlVUl");

vector signed long long __ATTRS_o_ai
vec_orc(vector bool long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_orc_VSlVBlVSl");

vector bool long long __ATTRS_o_ai
vec_orc(vector bool long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_orc_VBlVBlVBl");

vector unsigned int __ATTRS_o_ai
vec_orc(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_orc_VUiVUiVUi");

vector signed int __ATTRS_o_ai
vec_orc(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_orc_VSiVSiVSi");

vector unsigned int __ATTRS_o_ai
vec_orc(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_orc_VUiVUiVBi");

vector signed int __ATTRS_o_ai
vec_orc(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_orc_VSiVSiVBi");

vector unsigned int __ATTRS_o_ai
vec_orc(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_orc_VUiVBiVUi");

vector signed int __ATTRS_o_ai
vec_orc(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_orc_VSiVBiVSi");

vector bool int __ATTRS_o_ai
vec_orc(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_orc_VBiVBiVBi");

vector unsigned short __ATTRS_o_ai
vec_orc(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_orc_VUsVUsVUs");

vector signed short __ATTRS_o_ai
vec_orc(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_orc_VSsVSsVSs");

vector unsigned short __ATTRS_o_ai
vec_orc(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_orc_VUsVUsVBs");

vector signed short __ATTRS_o_ai
vec_orc(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_orc_VSsVSsVBs");

vector unsigned short __ATTRS_o_ai
vec_orc(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_orc_VUsVBsVUs");

vector signed short __ATTRS_o_ai
vec_orc(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_orc_VSsVBsVSs");

vector bool short __ATTRS_o_ai
vec_orc(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_orc_VBsVBsVBs");

vector unsigned char __ATTRS_o_ai
vec_orc(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_orc_VUcVUcVBc");

vector signed char __ATTRS_o_ai
vec_orc(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_orc_VScVScVBc");

vector unsigned char __ATTRS_o_ai
vec_orc(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_orc_VUcVBcVUc");

vector signed char __ATTRS_o_ai
vec_orc(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_orc_VScVBcVSc");

vector bool char __ATTRS_o_ai
vec_orc(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_orc_VBcVBcVBc");

vector float __ATTRS_o_ai
vec_orc(vector float __a, vector float __b) __asm__("__IBMBuiltin_vec_orc_VfVfVf");

vector float __ATTRS_o_ai
vec_orc(vector bool int __a, vector float __b) __asm__("__IBMBuiltin_vec_orc_VfVBiVf");

vector float __ATTRS_o_ai
vec_orc(vector float __a, vector bool int __b) __asm__("__IBMBuiltin_vec_orc_VfVfVBi");

vector double __ATTRS_o_ai
vec_orc(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_orc_VdVdVd");

vector double __ATTRS_o_ai
vec_orc(vector bool long long __a, vector double __b) __asm__("__IBMBuiltin_vec_orc_VdVBlVd");

vector double __ATTRS_o_ai
vec_orc(vector double __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_orc_VdVdVBl");

vector unsigned char __ATTRS_o_ai
vec_bperm(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_bperm_VUcVUcVUc");

vector unsigned long long __ATTRS_o_ai
vec_bperm (vector unsigned long long, vector unsigned char) __asm__ ("__IBMBuiltin_vec_bperm_VUllVUllVUc");

vector signed char __ATTRS_o_ai
vec_xl(signed long __a, const signed char * __b) __asm__("__IBMBuiltin___vec_xlb16_VSclcAC");

vector unsigned char __ATTRS_o_ai
vec_xl(signed long __a, const unsigned char * __b) __asm__("__IBMBuiltin___vec_xlb16_VUclcAC");

vector signed short __ATTRS_o_ai
vec_xl(signed long __a, const signed short * __b) __asm__("__IBMBuiltin___vec_xlh8_VSslsAC");

vector unsigned short __ATTRS_o_ai
vec_xl(signed long __a, const unsigned short * __b) __asm__("__IBMBuiltin___vec_xlh8_VUslsAC");

vector signed int __ATTRS_o_ai
vec_xl(signed long __a, const signed int * __b) __asm__("__IBMBuiltin___vec_xlw4_VSiliAC");

vector unsigned int __ATTRS_o_ai
vec_xl(signed long __a, const unsigned int * __b) __asm__("__IBMBuiltin___vec_xlw4_VUiliAC");

vector signed long long __ATTRS_o_ai
vec_xl(signed long __a, const signed long long * __b) __asm__("__IBMBuiltin___vec_xld2_VSlllAC");

vector unsigned long long __ATTRS_o_ai
vec_xl(signed long __a, const unsigned long long * __b) __asm__("__IBMBuiltin___vec_xld2_VUlllAC");

vector float __ATTRS_o_ai
vec_xl(signed long __a, const float * __b) __asm__("__IBMBuiltin___vec_xlw4_VflfAC");

vector double __ATTRS_o_ai
vec_xl(signed long __a, const double * __b) __asm__("__IBMBuiltin___vec_xld2_VdldAC");

vector signed char __ATTRS_o_ai
vec_xl(signed long __a, const vector signed char * __b) __asm__("__IBMBuiltin___vec_xlb16_VSclVScAC");

vector unsigned char __ATTRS_o_ai
vec_xl(signed long __a, const vector unsigned char * __b) __asm__("__IBMBuiltin___vec_xlb16_VUclVUcAC");

vector signed short __ATTRS_o_ai
vec_xl(signed long __a, const vector signed short * __b) __asm__("__IBMBuiltin___vec_xlh8_VSslVSsAC");

vector unsigned short __ATTRS_o_ai
vec_xl(signed long __a, const vector unsigned short * __b) __asm__("__IBMBuiltin___vec_xlh8_VUslVUsAC");

vector signed int __ATTRS_o_ai
vec_xl(signed long __a, const vector signed int * __b) __asm__("__IBMBuiltin___vec_xlw4_VSilVSiAC");

vector unsigned int __ATTRS_o_ai
vec_xl(signed long __a, const vector unsigned int * __b) __asm__("__IBMBuiltin___vec_xlw4_VUilVUiAC");

vector signed long long __ATTRS_o_ai
vec_xl(signed long __a, const vector signed long long * __b) __asm__("__IBMBuiltin___vec_xld2_VSllVSlAC");

vector unsigned long long __ATTRS_o_ai
vec_xl(signed long __a, const vector unsigned long long * __b) __asm__("__IBMBuiltin___vec_xld2_VUllVUlAC");

vector float __ATTRS_o_ai
vec_xl(signed long __a, const vector float * __b) __asm__("__IBMBuiltin___vec_xlw4_VflVfAC");

vector double __ATTRS_o_ai
vec_xl(signed long __a, const vector double * __b) __asm__("__IBMBuiltin___vec_xld2_VdlVdAC");

vector double __ATTRS_o_ai
vec_vsx_ld(int __a, const vector double * __b) __asm__("__IBMBuiltin___vec_xld2_VdiVdAC");

vector double __ATTRS_o_ai
vec_vsx_ld(int __a, const double * __b) __asm__("__IBMBuiltin___vec_xld2_VdidAC");

vector float __ATTRS_o_ai 
vec_vsx_ld(int __a, const vector float * __b) __asm__("__IBMBuiltin___vec_xlw4_VfiVfAC");

vector float __ATTRS_o_ai 
vec_vsx_ld(int __a, const float * __b) __asm__("__IBMBuiltin___vec_xlw4_VfifAC");

vector bool int __ATTRS_o_ai
vec_vsx_ld(int __a, const vector bool int * __b) __asm__("__IBMBuiltin___vec_xlw4_VBiiVBiAC");

vector signed int __ATTRS_o_ai
vec_vsx_ld(int __a, const vector signed int * __b) __asm__("__IBMBuiltin___vec_xlw4_VSiiVSiAC");

vector signed int __ATTRS_o_ai
vec_vsx_ld(int __a, const int * __b) __asm__("__IBMBuiltin___vec_xlw4_VSiiSiAC");

vector signed int __ATTRS_o_ai
vec_vsx_ld(int __a, const long * __b) __asm__("__IBMBuiltin___vec_xlw4_VSiiSlAC");

vector unsigned int __ATTRS_o_ai
vec_vsx_ld(int __a, const vector unsigned int * __b) __asm__("__IBMBuiltin___vec_xlw4_VUiiVUiAC");

vector unsigned int __ATTRS_o_ai
vec_vsx_ld(int __a, const unsigned int * __b) __asm__("__IBMBuiltin___vec_xlw4_VUiiUiAC");

vector unsigned int __ATTRS_o_ai
vec_vsx_ld(int __a, const unsigned long * __b) __asm__("__IBMBuiltin___vec_xlw4_VUiiUlAC");

vector bool short __ATTRS_o_ai
vec_vsx_ld(int __a, const vector bool short * __b) __asm__("__IBMBuiltin___vec_xlh8_VBsiVBsAC");

vector pixel __ATTRS_o_ai
vec_vsx_ld(int __a, const vector pixel * __b) __asm__("__IBMBuiltin___vec_xlh8_VpiVpAC");

vector signed short __ATTRS_o_ai
vec_vsx_ld(int __a, const vector signed short * __b) __asm__("__IBMBuiltin___vec_xlh8_VSsiVSsAC");

vector signed short __ATTRS_o_ai
vec_vsx_ld(int __a, const short * __b) __asm__("__IBMBuiltin___vec_xlh8_VSsiSsAC");

vector unsigned short __ATTRS_o_ai
vec_vsx_ld (int __a, const vector unsigned short * __b) __asm__("__IBMBuiltin___vec_xlh8_VUsiVUsAC");

vector unsigned short __ATTRS_o_ai
vec_vsx_ld (int __a, const unsigned short * __b) __asm__("__IBMBuiltin___vec_xlh8_VUsiUsAC");

vector bool char __ATTRS_o_ai
vec_vsx_ld (int __a, const vector bool char * __b) __asm__("__IBMBuiltin___vec_xlb16_VBciVBcAC");

vector signed char __ATTRS_o_ai
vec_vsx_ld (int __a, const vector signed char * __b) __asm__("__IBMBuiltin___vec_xlb16_VSciVScAC");

vector signed char __ATTRS_o_ai
vec_vsx_ld (int __a, const signed char * __b) __asm__("__IBMBuiltin___vec_xlb16_VSciScAC");

vector unsigned char __ATTRS_o_ai
vec_vsx_ld (int __a, const vector unsigned char * __b) __asm__("__IBMBuiltin___vec_xlb16_VUciVUcAC");

vector unsigned char __ATTRS_o_ai
vec_vsx_ld (int __a, const unsigned char * __b) __asm__("__IBMBuiltin___vec_xlb16_VUciUcAC");

void __ATTRS_o_ai
vec_xst(vector signed char __a, signed long __b, signed char * __c) __asm__("__IBMBuiltin___vec_xstb16_vVSclcA");

void __ATTRS_o_ai
vec_xst(vector unsigned char __a, signed long __b, unsigned char * __c) __asm__("__IBMBuiltin___vec_xstb16_vVUclcA");

void __ATTRS_o_ai
vec_xst(vector signed short __a, signed long __b, signed short * __c) __asm__("__IBMBuiltin___vec_xsth8_vVSslsA");

void __ATTRS_o_ai
vec_xst(vector unsigned short __a, signed long __b, unsigned short * __c) __asm__("__IBMBuiltin___vec_xsth8_vVUslsA");

void __ATTRS_o_ai
vec_xst(vector signed int __a, signed long __b, signed int * __c) __asm__("__IBMBuiltin___vec_xstw4_vVSiliA");

void __ATTRS_o_ai
vec_xst(vector unsigned int __a, signed long __b, unsigned int * __c) __asm__("__IBMBuiltin___vec_xstw4_vVUiliA");

void __ATTRS_o_ai
vec_xst(vector signed long long __a, signed long __b, signed long long * __c) __asm__("__IBMBuiltin___vec_xstd2_vVSlllA");

void __ATTRS_o_ai
vec_xst(vector unsigned long long __a, signed long __b, unsigned long long * __c) __asm__("__IBMBuiltin___vec_xstd2_vVUlllA");

void __ATTRS_o_ai
vec_xst(vector float __a, signed long __b, float * __c) __asm__("__IBMBuiltin___vec_xstw4_vVflfA");

void __ATTRS_o_ai
vec_xst(vector double __a, signed long __b, double * __c) __asm__("__IBMBuiltin___vec_xstd2_vVdldA");

void __ATTRS_o_ai
vec_xst(vector signed char __a, signed long __b, const vector signed char * __c) __asm__("__IBMBuiltin___vec_xstb16_vVSclVScAC");

void __ATTRS_o_ai
vec_xst(vector unsigned char __a, signed long __b, const vector unsigned char * __c) __asm__("__IBMBuiltin___vec_xstb16_vVUclVUcAC");

void __ATTRS_o_ai
vec_xst(vector signed short __a, signed long __b, const vector signed short * __c) __asm__("__IBMBuiltin___vec_xsth8_vVSslVSsAC");

void __ATTRS_o_ai
vec_xst(vector unsigned short __a, signed long __b, const vector unsigned short * __c) __asm__("__IBMBuiltin___vec_xsth8_vVUslVUsAC");

void __ATTRS_o_ai
vec_xst(vector signed int __a, signed long __b, const vector signed int * __c) __asm__("__IBMBuiltin___vec_xstw4_vVSilVSiAC");

void __ATTRS_o_ai
vec_xst(vector unsigned int __a, signed long __b, const vector unsigned int * __c) __asm__("__IBMBuiltin___vec_xstw4_vVUilVUiAC");

void __ATTRS_o_ai
vec_xst(vector signed long long __a, signed long __b, const vector signed long long * __c) __asm__("__IBMBuiltin___vec_xstd2_vVSllVSlAC");

void __ATTRS_o_ai
vec_xst(vector unsigned long long __a, signed long __b, const vector unsigned long long * __c) __asm__("__IBMBuiltin___vec_xstd2_vVUllVUlAC");

void __ATTRS_o_ai
vec_xst(vector float __a, signed long __b, const vector float * __c) __asm__("__IBMBuiltin___vec_xstw4_vVflVfAC");

void __ATTRS_o_ai
vec_xst(vector double __a, signed long __b, const vector double * __c) __asm__("__IBMBuiltin___vec_xstd2_vVdlVdAC");

void __ATTRS_o_ai 
vec_vsx_st (vector double, int, vector double *)  __asm__("__IBMBuiltin___vec_xstd2_vVdiVdA");

void __ATTRS_o_ai 
vec_vsx_st (vector double, int, double *)  __asm__("__IBMBuiltin___vec_xstd2_vVdidA");

void __ATTRS_o_ai 
vec_vsx_st (vector float, int, vector float *)  __asm__("__IBMBuiltin___vec_xstw4_vVfiVfA");

void __ATTRS_o_ai 
vec_vsx_st (vector float, int, float *)  __asm__("__IBMBuiltin___vec_xstw4_vVfifA");

void __ATTRS_o_ai 
vec_vsx_st (vector signed int, int, vector signed int *)  __asm__("__IBMBuiltin___vec_xstw4_vVSiiVSiA");

void __ATTRS_o_ai 
vec_vsx_st (vector signed int, int, int *)  __asm__("__IBMBuiltin___vec_xstw4_vVSiiSiA");

void __ATTRS_o_ai 
vec_vsx_st (vector unsigned int, int, vector unsigned int *)  __asm__("__IBMBuiltin___vec_xstw4_vVUiiVUiA");

void __ATTRS_o_ai 
vec_vsx_st (vector unsigned int, int, unsigned int *)  __asm__("__IBMBuiltin___vec_xstw4_vVUiiUiA");

void __ATTRS_o_ai 
vec_vsx_st (vector bool int, int, vector bool int *)  __asm__("__IBMBuiltin___vec_xstw4_vVBiiVBiA");

void __ATTRS_o_ai 
vec_vsx_st (vector bool int, int, unsigned int *)  __asm__("__IBMBuiltin___vec_xstw4_vVBiiUiA");

void __ATTRS_o_ai 
vec_vsx_st (vector bool int, int, int *)  __asm__("__IBMBuiltin___vec_xstw4_vVBiiSiA");

void __ATTRS_o_ai 
vec_vsx_st (vector signed short, int, vector signed short *)  __asm__("__IBMBuiltin___vec_xsth8_vVSsiVSsA");

void __ATTRS_o_ai 
vec_vsx_st (vector signed short, int, short *)  __asm__("__IBMBuiltin___vec_xsth8_vVSsiSsA");

void __ATTRS_o_ai 
vec_vsx_st (vector unsigned short, int, vector unsigned short *)  __asm__("__IBMBuiltin___vec_xsth8_vVUsiVUsA");

void __ATTRS_o_ai 
vec_vsx_st (vector unsigned short, int, unsigned short *)  __asm__("__IBMBuiltin___vec_xsth8_vVUsiUsA");

void __ATTRS_o_ai 
vec_vsx_st (vector bool short, int, vector bool short *)  __asm__("__IBMBuiltin___vec_xsth8_vVBsiVBsA");

void __ATTRS_o_ai 
vec_vsx_st (vector bool short, int, unsigned short *)  __asm__("__IBMBuiltin___vec_xsth8_vVBsiUsA");

void __ATTRS_o_ai 
vec_vsx_st (vector bool short, int, short *)  __asm__("__IBMBuiltin___vec_xsth8_vVBsiSsA");

void __ATTRS_o_ai 
vec_vsx_st (vector pixel, int, vector pixel *)  __asm__("__IBMBuiltin___vec_xsth8_vVpiVpA");

void __ATTRS_o_ai 
vec_vsx_st (vector pixel, int, unsigned short *)  __asm__("__IBMBuiltin___vec_xsth8_vVpiUsA");

void __ATTRS_o_ai 
vec_vsx_st (vector pixel, int, short *)  __asm__("__IBMBuiltin___vec_xsth8_vVpiSsA");

void __ATTRS_o_ai 
vec_vsx_st (vector signed char, int, vector signed char *)  __asm__("__IBMBuiltin___vec_xstb16_vVSciVScA");

void __ATTRS_o_ai 
vec_vsx_st (vector signed char, int, signed char *)  __asm__("__IBMBuiltin___vec_xstb16_vVSciScA");

void __ATTRS_o_ai 
vec_vsx_st (vector unsigned char, int, vector unsigned char *)  __asm__("__IBMBuiltin___vec_xstb16_vVUciVUcA");

void __ATTRS_o_ai 
vec_vsx_st (vector unsigned char, int, unsigned char *)  __asm__("__IBMBuiltin___vec_xstb16_vVUciUcA");

void __ATTRS_o_ai 
vec_vsx_st (vector bool char, int, vector bool char *)  __asm__("__IBMBuiltin___vec_xstb16_vVBciVBcA");

void __ATTRS_o_ai 
vec_vsx_st (vector bool char, int, unsigned char *)  __asm__("__IBMBuiltin___vec_xstb16_vVBciUcA");

void __ATTRS_o_ai 
vec_vsx_st (vector bool char, int, signed char *)  __asm__("__IBMBuiltin___vec_xstb16_vVBciScA");

#if defined(__LITTLE_ENDIAN__)
vector signed char __ATTRS_o_ai
vec_xl_be(signed long __a, const signed char * __b) __asm__("__IBMBuiltin___vec_be_xlb16_VSclcAC");

vector unsigned char __ATTRS_o_ai
vec_xl_be(signed long __a, const unsigned char * __b) __asm__("__IBMBuiltin___vec_be_xlb16_VUclcAC");

vector signed short __ATTRS_o_ai
vec_xl_be(signed long __a, const signed short * __b) __asm__("__IBMBuiltin___vec_be_xlh8_VSslsAC");

vector unsigned short __ATTRS_o_ai
vec_xl_be(signed long __a, const unsigned short * __b) __asm__("__IBMBuiltin___vec_be_xlh8_VUslsAC");

vector signed int __ATTRS_o_ai
vec_xl_be(signed long __a, const signed int * __b) __asm__("__IBMBuiltin___vec_be_xlw4_VSiliAC");

vector unsigned int __ATTRS_o_ai
vec_xl_be(signed long __a, const unsigned int * __b) __asm__("__IBMBuiltin___vec_be_xlw4_VUiliAC");

vector signed long long __ATTRS_o_ai
vec_xl_be(signed long __a, const signed long long * __b) __asm__("__IBMBuiltin___vec_be_xld2_VSlllAC");

vector unsigned long long __ATTRS_o_ai
vec_xl_be(signed long __a, const unsigned long long * __b) __asm__("__IBMBuiltin___vec_be_xld2_VUlllAC");

vector float __ATTRS_o_ai
vec_xl_be(signed long __a, const float * __b) __asm__("__IBMBuiltin___vec_be_xlw4_VflfAC");

vector double __ATTRS_o_ai
vec_xl_be(signed long __a, const double * __b) __asm__("__IBMBuiltin___vec_be_xld2_VdldAC");

vector signed char __ATTRS_o_ai
vec_xl_be(signed long __a, const vector signed char * __b) __asm__("__IBMBuiltin___vec_be_xlb16_VSclVScAC");

vector unsigned char __ATTRS_o_ai
vec_xl_be(signed long __a, const vector unsigned char * __b) __asm__("__IBMBuiltin___vec_be_xlb16_VUclVUcAC");

vector signed short __ATTRS_o_ai
vec_xl_be(signed long __a, const vector signed short * __b) __asm__("__IBMBuiltin___vec_be_xlh8_VSslVSsAC");

vector unsigned short __ATTRS_o_ai
vec_xl_be(signed long __a, const vector unsigned short * __b) __asm__("__IBMBuiltin___vec_be_xlh8_VUslVUsAC");

vector signed int __ATTRS_o_ai
vec_xl_be(signed long __a, const vector signed int * __b) __asm__("__IBMBuiltin___vec_be_xlw4_VSilVSiAC");

vector unsigned int __ATTRS_o_ai
vec_xl_be(signed long __a, const vector unsigned int * __b) __asm__("__IBMBuiltin___vec_be_xlw4_VUilVUiAC");

vector signed long long __ATTRS_o_ai
vec_xl_be(signed long __a, const vector signed long long * __b) __asm__("__IBMBuiltin___vec_be_xld2_VSllVSlAC");

vector unsigned long long __ATTRS_o_ai
vec_xl_be(signed long __a, const vector unsigned long long * __b) __asm__("__IBMBuiltin___vec_be_xld2_VUllVUlAC");

vector float __ATTRS_o_ai
vec_xl_be(signed long __a, const vector float * __b) __asm__("__IBMBuiltin___vec_be_xlw4_VflVfAC");

vector double __ATTRS_o_ai
vec_xl_be(signed long __a, const vector double * __b) __asm__("__IBMBuiltin___vec_be_xld2_VdlVdAC");

void __ATTRS_o_ai
vec_xst_be(vector signed char __a, signed long __b, signed char * __c) __asm__("__IBMBuiltin___vec_be_xstb16_vVSclcA");

void __ATTRS_o_ai
vec_xst_be(vector unsigned char __a, signed long __b, unsigned char * __c) __asm__("__IBMBuiltin___vec_be_xstb16_vVUclcA");

void __ATTRS_o_ai
vec_xst_be(vector signed short __a, signed long __b, signed short * __c) __asm__("__IBMBuiltin___vec_be_xsth8_vVSslsA");

void __ATTRS_o_ai
vec_xst_be(vector unsigned short __a, signed long __b, unsigned short * __c) __asm__("__IBMBuiltin___vec_be_xsth8_vVUslsA");

void __ATTRS_o_ai
vec_xst_be(vector signed int __a, signed long __b, signed int * __c) __asm__("__IBMBuiltin___vec_be_xstw4_vVSiliA");

void __ATTRS_o_ai
vec_xst_be(vector unsigned int __a, signed long __b, unsigned int * __c) __asm__("__IBMBuiltin___vec_be_xstw4_vVUiliA");

void __ATTRS_o_ai
vec_xst_be(vector signed long long __a, signed long __b, signed long long * __c) __asm__("__IBMBuiltin___vec_be_xstd2_vVSlllA");

void __ATTRS_o_ai
vec_xst_be(vector unsigned long long __a, signed long __b, unsigned long long * __c) __asm__("__IBMBuiltin___vec_be_xstd2_vVUlllA");

void __ATTRS_o_ai
vec_xst_be(vector float __a, signed long __b, float * __c) __asm__("__IBMBuiltin___vec_be_xstw4_vVflfA");

void __ATTRS_o_ai
vec_xst_be(vector double __a, signed long __b, double * __c) __asm__("__IBMBuiltin___vec_be_xstd2_vVdldA");

void __ATTRS_o_ai
vec_xst_be(vector signed char __a, signed long __b, const vector signed char * __c) __asm__("__IBMBuiltin___vec_be_xstb16_vVSclVScAC");

void __ATTRS_o_ai
vec_xst_be(vector unsigned char __a, signed long __b, const vector unsigned char * __c) __asm__("__IBMBuiltin___vec_be_xstb16_vVUclVUcAC");

void __ATTRS_o_ai
vec_xst_be(vector signed short __a, signed long __b, const vector signed short * __c) __asm__("__IBMBuiltin___vec_be_xsth8_vVSslVSsAC");

void __ATTRS_o_ai
vec_xst_be(vector unsigned short __a, signed long __b, const vector unsigned short * __c) __asm__("__IBMBuiltin___vec_be_xsth8_vVUslVUsAC");

void __ATTRS_o_ai
vec_xst_be(vector signed int __a, signed long __b, const vector signed int * __c) __asm__("__IBMBuiltin___vec_be_xstw4_vVSilVSiAC");

void __ATTRS_o_ai
vec_xst_be(vector unsigned int __a, signed long __b, const vector unsigned int * __c) __asm__("__IBMBuiltin___vec_be_xstw4_vVUilVUiAC");

void __ATTRS_o_ai
vec_xst_be(vector signed long long __a, signed long __b, const vector signed long long * __c) __asm__("__IBMBuiltin___vec_be_xstd2_vVSllVSlAC");

void __ATTRS_o_ai
vec_xst_be(vector unsigned long long __a, signed long __b, const vector unsigned long long * __c) __asm__("__IBMBuiltin___vec_be_xstd2_vVUllVUlAC");

void __ATTRS_o_ai
vec_xst_be(vector float __a, signed long __b, const vector float * __c) __asm__("__IBMBuiltin___vec_be_xstw4_vVflVfAC");

void __ATTRS_o_ai
vec_xst_be(vector double __a, signed long __b, const vector double * __c) __asm__("__IBMBuiltin___vec_be_xstd2_vVdlVdAC");

#else
vector signed char __ATTRS_o_ai
vec_xl_be(signed int __a, signed char * __b) __asm__("__IBMBuiltin___vec_xld2_VScicA");

vector unsigned char __ATTRS_o_ai
vec_xl_be(signed int __a, unsigned char * __b) __asm__("__IBMBuiltin___vec_xld2_VUcicA");

vector signed short __ATTRS_o_ai
vec_xl_be(signed int __a, signed short * __b) __asm__("__IBMBuiltin___vec_xld2_VSsisA");

vector unsigned short __ATTRS_o_ai
vec_xl_be(signed int __a, unsigned short * __b) __asm__("__IBMBuiltin___vec_xld2_VUsisA");

vector signed int __ATTRS_o_ai
vec_xl_be(signed int __a, signed int * __b) __asm__("__IBMBuiltin___vec_xld2_VSiiiA");

vector unsigned int __ATTRS_o_ai
vec_xl_be(signed int __a, unsigned int * __b) __asm__("__IBMBuiltin___vec_xld2_VUiiiA");

vector signed long long __ATTRS_o_ai
vec_xl_be(signed int __a, signed long long * __b) __asm__("__IBMBuiltin___vec_xld2_VSlilA");

vector unsigned long long __ATTRS_o_ai
vec_xl_be(signed int __a, unsigned long long * __b) __asm__("__IBMBuiltin___vec_xld2_VUlilA");

vector float __ATTRS_o_ai
vec_xl_be(signed int __a, float * __b) __asm__("__IBMBuiltin___vec_xld2_VfifA");

vector double __ATTRS_o_ai
vec_xl_be(signed int __a, double * __b) __asm__("__IBMBuiltin___vec_xld2_VdidA");

void __ATTRS_o_ai
vec_xst_be(vector signed char __a, signed int __b, signed char * __c) __asm__("__IBMBuiltin___vec_xstd2_vVScicA");

void __ATTRS_o_ai
vec_xst_be(vector unsigned char __a, signed int __b, unsigned char * __c) __asm__("__IBMBuiltin___vec_xstd2_vVUcicA");

void __ATTRS_o_ai
vec_xst_be(vector signed short __a, signed int __b, signed short * __c) __asm__("__IBMBuiltin___vec_xstd2_vVSsisA");

void __ATTRS_o_ai
vec_xst_be(vector unsigned short __a, signed int __b, unsigned short * __c) __asm__("__IBMBuiltin___vec_xstd2_vVUsisA");

void __ATTRS_o_ai
vec_xst_be(vector signed int __a, signed int __b, signed int * __c) __asm__("__IBMBuiltin___vec_xstd2_vVSiiiA");

void __ATTRS_o_ai
vec_xst_be(vector unsigned int __a, signed int __b, unsigned int * __c) __asm__("__IBMBuiltin___vec_xstd2_vVUiiiA");

void __ATTRS_o_ai
vec_xst_be(vector signed long long __a, signed int __b, signed long long * __c) __asm__("__IBMBuiltin___vec_xstd2_vVSlilA");

void __ATTRS_o_ai
vec_xst_be(vector unsigned long long __a, signed int __b, unsigned long long * __c) __asm__("__IBMBuiltin___vec_xstd2_vVUlilA");

void __ATTRS_o_ai
vec_xst_be(vector float __a, signed int __b, float * __c) __asm__("__IBMBuiltin___vec_xstd2_vVfifA");

void __ATTRS_o_ai
vec_xst_be(vector double __a, signed int __b, double * __c) __asm__("__IBMBuiltin___vec_xstd2_vVdidA");
#endif

vector int __attribute__((__overloadable__, __always_inline__)) vec_mergeo(vector int, vector int) __asm__("__IBMBuiltin_vec_mergeo_VSiVSiVSi");
vector int __attribute__((__overloadable__, __always_inline__)) vec_mergee(vector int, vector int) __asm__("__IBMBuiltin_vec_mergee_VSiVSiVSi");
vector unsigned int __attribute__((__overloadable__, __always_inline__)) vec_mergeo(vector unsigned int, vector unsigned int) __asm__("__IBMBuiltin_vec_mergeo_VUiVUiVUi");
vector unsigned int __attribute__((__overloadable__, __always_inline__)) vec_mergee(vector unsigned int, vector unsigned int) __asm__("__IBMBuiltin_vec_mergee_VUiVUiVUi");
vector bool int __attribute__((__overloadable__, __always_inline__)) vec_mergeo(vector bool int, vector bool int) __asm__("__IBMBuiltin_vec_mergeo_VBiVBiVBi");
vector bool int __attribute__((__overloadable__, __always_inline__)) vec_mergee(vector bool int, vector bool int) __asm__("__IBMBuiltin_vec_mergee_VBiVBiVBi");

#if defined(__LITTLE_ENDIAN__)
vector int __attribute__((__overloadable__, __always_inline__)) vec_mergeo_be(vector int, vector int) __asm__("__IBMBuiltin_vec_be_mergeo_VSiVSiVSi");
vector int __attribute__((__overloadable__, __always_inline__)) vec_mergee_be(vector int, vector int) __asm__("__IBMBuiltin_vec_be_mergee_VSiVSiVSi");
vector unsigned int __attribute__((__overloadable__, __always_inline__)) vec_mergeo_be(vector unsigned int, vector unsigned int) __asm__("__IBMBuiltin_vec_be_mergeo_VUiVUiVUi");
vector unsigned int __attribute__((__overloadable__, __always_inline__)) vec_mergee_be(vector unsigned int, vector unsigned int) __asm__("__IBMBuiltin_vec_be_mergee_VUiVUiVUi");
vector bool int __attribute__((__overloadable__, __always_inline__)) vec_mergeo_be(vector bool int, vector bool int) __asm__("__IBMBuiltin_vec_be_mergeo_VBiVBiVBi");
vector bool int __attribute__((__overloadable__, __always_inline__)) vec_mergee_be(vector bool int, vector bool int) __asm__("__IBMBuiltin_vec_be_mergee_VBiVBiVBi");
#endif

vector signed char  __ATTRS_o_ai vec_revb(vector signed char) __asm__("__IBMBuiltin___vec_revb_VScVSc");
vector unsigned char  __ATTRS_o_ai vec_revb(vector unsigned char) __asm__("__IBMBuiltin___vec_revb_VUcVUc");
vector signed short  __ATTRS_o_ai vec_revb (vector signed short) __asm__("__IBMBuiltin___vec_revb_VsVs");
vector unsigned short  __ATTRS_o_ai vec_revb (vector unsigned short) __asm__("__IBMBuiltin___vec_revb_VUsVUs");
vector signed int  __ATTRS_o_ai vec_revb (vector signed int) __asm__("__IBMBuiltin___vec_revb_ViVi");
vector unsigned int  __ATTRS_o_ai vec_revb (vector unsigned int) __asm__("__IBMBuiltin___vec_revb_VUiVUi");
vector signed long long  __ATTRS_o_ai vec_revb (vector signed long long) __asm__("__IBMBuiltin___vec_revb_VSllVSll");
vector unsigned long long  __ATTRS_o_ai vec_revb (vector unsigned long long) __asm__("__IBMBuiltin___vec_revb_VUllVUll");
vector float  __ATTRS_o_ai vec_revb (vector float) __asm__("__IBMBuiltin___vec_revb_VfVf");
vector double  __ATTRS_o_ai vec_revb (vector double) __asm__("__IBMBuiltin___vec_revb_VdVd");

vector signed char  __ATTRS_o_ai vec_reve(vector signed char) __asm__("__IBMBuiltin___vec_reve_VScVSc");
vector unsigned char  __ATTRS_o_ai vec_reve(vector unsigned char) __asm__("__IBMBuiltin___vec_reve_VUcVUc");
vector signed short  __ATTRS_o_ai vec_reve (vector signed short) __asm__("__IBMBuiltin___vec_reve_VsVs");
vector unsigned short  __ATTRS_o_ai vec_reve (vector unsigned short) __asm__("__IBMBuiltin___vec_reve_VUsVUs");
vector pixel  __ATTRS_o_ai vec_reve (vector pixel) __asm__("__IBMBuiltin___vec_reve_VpVp");
vector signed int  __ATTRS_o_ai vec_reve (vector signed int) __asm__("__IBMBuiltin___vec_reve_ViVi");
vector unsigned int  __ATTRS_o_ai vec_reve (vector unsigned int) __asm__("__IBMBuiltin___vec_reve_VUiVUi");
vector signed long long  __ATTRS_o_ai vec_reve (vector signed long long) __asm__("__IBMBuiltin___vec_reve_VSllVSll");
vector unsigned long long  __ATTRS_o_ai vec_reve (vector unsigned long long) __asm__("__IBMBuiltin___vec_reve_VUllVUll");
vector float  __ATTRS_o_ai vec_reve (vector float) __asm__("__IBMBuiltin___vec_reve_VfVf");
vector double  __ATTRS_o_ai vec_reve (vector double) __asm__("__IBMBuiltin___vec_reve_VdVd");

vector bool char  __ATTRS_o_ai vec_revb(vector bool char) __asm__("__IBMBuiltin___vec_revb_VBcVBc");
vector bool short  __ATTRS_o_ai vec_revb (vector bool short) __asm__("__IBMBuiltin___vec_revb_VBsVBs");
vector bool int  __ATTRS_o_ai vec_revb (vector bool int) __asm__("__IBMBuiltin___vec_revb_VBiVBi");
vector bool long long  __ATTRS_o_ai vec_revb (vector bool long long) __asm__("__IBMBuiltin___vec_revb_VBlVBl");

vector bool char  __ATTRS_o_ai vec_reve(vector bool char) __asm__("__IBMBuiltin___vec_reve_VBcVBc");
vector bool short  __ATTRS_o_ai vec_reve (vector bool short) __asm__("__IBMBuiltin___vec_reve_VBsVBs");
vector bool int  __ATTRS_o_ai vec_reve (vector bool int) __asm__("__IBMBuiltin___vec_reve_VBiVBi");
vector bool long long  __ATTRS_o_ai vec_reve (vector bool long long) __asm__("__IBMBuiltin___vec_reve_VBlVBl");



#undef __ATTRS_o_ai

#endif
